/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2008               */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
#pragma comment(copyright,"5765-543 (C) Copyright IBM Corp. 2008 @(#) 1.2 src/ppe/hpct/source/examples/psigma/mio/FBS_str_to_long.c, ppe.hpct, ppe_rhya, rhyas001a 08/11/04 11:40:16")

#include <fcntl.h>
#include <stdio.h>
#include <string.h>

#if defined(xLinux) || defined(pLinux)
#define int64 long long 
#endif

#define KILO       1024
#define MEGA   0x100000
#define GIGA 0x40000000
#define TERA 0x10000000000LL

int64
FBS_str_to_long( char *input )
{
int base ;
int64 ret ;
int sign ;
int64 mult ;
int i, iv, nc ;
char *value ;
char *v, *valid = "0123456789abcdef" ;
char storage[80];

   value = storage ;
   strcpy( value, input ) ;

   {
      int nc ;
      nc = strlen(value) ;
      if( nc > 1 && ( value[nc-1] == 'b' || value[nc-1] == 'B') ){
         if(value[nc-2] == 'k' || value[nc-2] == 'K' ||
            value[nc-2] == 'm' || value[nc-2] == 'M' ||
            value[nc-2] == 'g' || value[nc-2] == 'G' ||
            value[nc-2] == 't' || value[nc-2] == 'T' ) {
               value[nc-1] = 0 ;
         }
      }
   }

   sign = 1 ;
   if( *value == '+' ) {
      sign = 1 ;
      value++ ;
   } else if( *value == '-') {
      sign = -1 ;
      value++ ;
   }

   mult = 1 ;
   nc = strlen(value) ;
   if(nc){
      char c ;
      c = value[nc-1] ;
      if(      c == 'k' || c == 'K' )
         { mult = KILO ; value[nc-1] = 0 ; }
      else if( c == 'm' || c == 'M' )
         { mult = MEGA ; value[nc-1] = 0 ; }
      else if( c == 'g' || c == 'G' )
         { mult = GIGA ; value[nc-1] = 0 ; }
      else if( c == 't' || c == 'T' )
         { mult = TERA ; value[nc-1] = 0 ; }
   }

   if( *value== '0' && *(value+1) == 'x' ) {
      base = 16 ;
      value+= 2 ;
   } else if( *value == '0' ) {
      base = 8 ;
      value+= 1 ;
   } else {
      base = 10 ;
   }

   ret = 0 ;
   while( *value ) {
      v = valid ;
      for(i=0;i<base;i++){
        if( *value == valid[i] ){
           ret = ret*base + i ;
           break ;
        }
      }
      if( i == base ){
         fprintf(stderr  ,"Error : bad integer value %s\n",input);
         return(0);
      }
      value++ ;
   }

/*printf("str_to_long  : input=%s sign =%d mult=%d ret=%lld\n",input,sign,mult,ret);*/
   ret *= mult ;
   ret *= sign ;
   return(ret);
}

int
FBS_str_to_long_vector( char *input , int64 *vector, int n)
{
int i, vl, ret = 0 ;
char value[80] ;
   for(i=0;i<n;i++) vector[i] = 0 ;
   while( input && *input ) {
      vl = 0 ;
      while( *input && *input != ':' ) value[vl++] = *input++ ;
      value[vl] = 0 ;
      if( *input == ':' ) input++ ;
      vector[ret++] = FBS_str_to_long( value ) ;
   }
   return(ret);
}
