C IBM_PROLOG_BEGIN_TAG 
C This is an automatically generated prolog. 
C  
C  
C  
C Licensed Materials - Property of IBM 
C  
C (C) COPYRIGHT International Business Machines Corp. 2008 
C All Rights Reserved 
C  
C US Government Users Restricted Rights - Use, duplication or 
C disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
C  
C IBM_PROLOG_END_TAG 
      SUBROUTINE CALC1
C
C        COMPUTE CAPITAL  U, CAPITAL V, Z AND H
C
      PARAMETER (N1=513, N2=513)

      include "mpif.h"
#include "f_hpc.h"

      COMMON/decomp/js,je,taskid,numtasks,req(16),
     1                            istat(MPI_STATUS_SIZE,16)
      integer taskid,req
      COMMON  U(N1,N2), V(N1,N2), P(N1,N2),
     *        UNEW(N1,N2), VNEW(N1,N2),
     1        PNEW(N1,N2), UOLD(N1,N2),
     *        VOLD(N1,N2), POLD(N1,N2),
     2        CU(N1,N2), CV(N1,N2),
     *        Z(N1,N2), H(N1,N2), PSI(N1,N2)
C
      COMMON /CONS/ DT,TDT,DX,DY,A,ALPHA,ITMAX,MPRINT,M,N,MP1,
     1              NP1,EL,PI,TPI,DI,DJ,PCF
C
      integer ierr

      FSDX = 4./DX
      FSDY = 4./DY

C SPEC removed CCMIC$ DO GLOBAL
CME ------------------------------------------------

      call f_hpmstart(8, "MPI Calc1 start")
      CALL f_hpm_errchk
      if(taskid.lt.numtasks-1)then
      cALL mpi_irecv(V(1,je+1),n1,MPI_DOUBLE_PRECISION,
     1 taskid+1,1,MPI_COMM_WORLD,req(1),ierr)
      endif
      if(taskid.gt.0)then
      cALL mpi_isend(V(1,js),n1,MPI_DOUBLE_PRECISION,
     1 taskid-1,1,MPI_COMM_WORLD,req(4),ierr)
      endif
      if(taskid.gt.0)then
      cALL mpi_irecv(U(1,js-1),n1,MPI_DOUBLE_PRECISION,
     1 taskid-1,2,MPI_COMM_WORLD,req(2),ierr)
      cALL mpi_irecv(P(1,js-1),n1,MPI_DOUBLE_PRECISION,
     1 taskid-1,3,MPI_COMM_WORLD,req(3),ierr)
      endif
      if(taskid.lt.numtasks-1)then
      cALL mpi_isend(U(1,je),n1,MPI_DOUBLE_PRECISION,
     1  taskid+1,2,MPI_COMM_WORLD,req(5),ierr)
      cALL mpi_isend(P(1,je),n1,MPI_DOUBLE_PRECISION,
     1  taskid+1,3,MPI_COMM_WORLD,req(6),ierr)
      endif

      cALL MPI_WAITALL(6,req,istat,ierr)
      call f_hpmstop(8)
      CALL f_hpm_errchk

      call f_hpmstart( 10, "Loop 100" )
      CALL f_hpm_errchk
CME--- CHECK p(i,j-1) and u(i+1,j-1) CHECK -- <<<<<<<<<<<<<
C$OMP PARALLELDO
C$OMP&SHARED (FSDY,FSDX,M,N,U,V,P,CU,CV,Z,H,js,je)
C$OMP&PRIVATE (I,J)
      DO 100 J=js,je
      DO 100 I=1,M
      CU(I+1,J) = .5*(P(I+1,J)+P(I,J))*U(I+1,J)
      if(j.gt.1)then 
      CV(I,J)  = .5*(P(I,J)+P(I,J-1))*V(I,J)
      Z(I+1,J) = (FSDX*(V(I+1,J)-V(I,J))-FSDY*(U(I+1,J)
     1    -U(I+1,J-1)))/(P(I,J-1)+P(I+1,J-1)+P(I+1,J)+P(I,J))
      endif
      if(j.eq.n)then
      CV(I,J+1)  = .5*(P(I,J+1)+P(I,J))*V(I,J+1)
      Z(I+1,J+1) = (FSDX*(V(I+1,J+1)-V(I,J+1))-FSDY*(U(I+1,J+1)
     1          -U(I+1,J)))/(P(I,J)+P(I+1,J)+P(I+1,J+1)+P(I,J+1))
      endif
      H(I,J) = P(I,J)+.25*(U(I+1,J)*U(I+1,J)+U(I,J)*U(I,J)
     1               +V(I,J+1)*V(I,J+1)+V(I,J)*V(I,J))
  100 CONTINUE
      call f_hpmstop( 10 )
      CALL f_hpm_errchk

CME -------------------------------------------
C
C     PERIODIC CONTINUATION
C
      call f_hpmstart(11, "loop 110")
      CALL f_hpm_errchk
      DO 110 J=js,je
      CU(1,J) = CU(M+1,J)
      H(M+1,J) = H(1,J)
      if(j.gt.1)then
      Z(1,J) = Z(M+1,J)
      CV(M+1,J) = CV(1,J)
      endif
      if(j.eq.n)then
      Z(1,J+1) = Z(M+1,J+1)
      CV(M+1,J+1) = CV(1,J+1)
      endif
  110 CONTINUE
      call f_hpmstop(11)
      CALL f_hpm_errchk
      call f_hpmstart( 12, "MPI Calc1 end" )
      CALL f_hpm_errchk
      if(taskid.eq.0)then
      cALL mpi_irecv(cv(1,1),n1,MPI_DOUBLE_PRECISION,
     1    numtasks-1,1,MPI_COMM_WORLD,req(1),ierr)
      cALL mpi_irecv(z(1,1),n1,MPI_DOUBLE_PRECISION,
     1    numtasks-1,2,MPI_COMM_WORLD,req(2),ierr)
      endif
      if(taskid.eq.numtasks-1)then
      cALL mpi_irecv(cu(1,n+1),n1,MPI_DOUBLE_PRECISION,
     1    0,3,MPI_COMM_WORLD,req(3),ierr)
      cALL mpi_irecv(h(1,n+1),n1,MPI_DOUBLE_PRECISION,
     1    0,4,MPI_COMM_WORLD,req(4),ierr)
      endif
      if(taskid.eq.numtasks-1)then
      cALL mpi_isend(cv(1,n+1),n1,MPI_DOUBLE_PRECISION,
     1    0,1,MPI_COMM_WORLD,req(5),ierr)
      cALL mpi_isend(z(1,n+1),n1,MPI_DOUBLE_PRECISION,
     1    0,2,MPI_COMM_WORLD,req(6),ierr)
      endif
      if(taskid.eq.0)then
      cALL mpi_isend(cu(1,1),n1,MPI_DOUBLE_PRECISION,
     1    numtasks-1,3,MPI_COMM_WORLD,req(7),ierr)
      cALL mpi_isend(h(1,1),n1,MPI_DOUBLE_PRECISION,
     1    numtasks-1,4,MPI_COMM_WORLD,req(8),ierr)
      endif
      if(taskid.eq.0.or.taskid.eq.numtasks-1)then
      cALL MPI_WAITALL(8,req,istat,ierr)
      endif
c     DO 115 I=1,M
c     CU(I+1,N+1) = CU(I+1,1)
c     CV(I,1) = CV(I,N+1)
c     Z(I+1,1) = Z(I+1,N+1)
c     H(I,N+1) = H(I,1)
c 115 CONTINUE

      if(taskid.eq.numtasks-1)then
      cALL mpi_irecv(Cu(1,N+1),1,MPI_DOUBLE_PRECISION,
     1    0,1,MPI_COMM_WORLD,req(1),ierr)
      cALL mpi_irecv(H(M+1,N+1),1,MPI_DOUBLE_PRECISION,
     1    0,2,MPI_COMM_WORLD,req(2),ierr)
      endif
      if(taskid.eq.0)then
      cALL mpi_irecv(Cv(M+1,1),1,MPI_DOUBLE_PRECISION,
     1numtasks-1,3,MPI_COMM_WORLD,req(3),ierr)
      cALL mpi_irecv(Z(1,1),1,MPI_DOUBLE_PRECISION,
     1numtasks-1,4,MPI_COMM_WORLD,req(4),ierr)
      endif

      if(taskid.eq.numtasks-1)then
      cALL mpi_isend(Cv(1,N+1),1,MPI_DOUBLE_PRECISION,
     1 0,3,MPI_COMM_WORLD,req(5),ierr)
      cALL mpi_isend(z(m+1,n+1),1,MPI_DOUBLE_PRECISION,
     1 0,4,MPI_COMM_WORLD,req(6),ierr)
      endif
      if(taskid.eq.0)then
      cALL mpi_isend(Cu(M+1,1),1,MPI_DOUBLE_PRECISION,
     1  numtasks-1,1,MPI_COMM_WORLD,req(7),ierr)
      cALL mpi_isend(h(1,1),1,MPI_DOUBLE_PRECISION,
     1  numtasks-1,2,MPI_COMM_WORLD,req(8),ierr)
      endif
      if(taskid.eq.0.or.taskid.eq.numtasks-1)then
      cALL MPI_WAITALL(8,req,istat,ierr)
      endif
      call f_hpmstop( 12 )
      CALL f_hpm_errchk
CME      CU(1,N+1) = CU(M+1,1)
CME      CV(M+1,1) = CV(1,N+1)
CME      Z(1,1) = Z(M+1,N+1)
CME      H(M+1,N+1) = H(1,1)

C        END OF LOOP 100 CALCULATIONS
      RETURN
      END
