C IBM_PROLOG_BEGIN_TAG 
C This is an automatically generated prolog. 
C  
C  
C  
C Licensed Materials - Property of IBM 
C  
C (C) COPYRIGHT International Business Machines Corp. 2008 
C All Rights Reserved 
C  
C US Government Users Restricted Rights - Use, duplication or 
C disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
C  
C IBM_PROLOG_END_TAG 
      SUBROUTINE CALC2
C
C        COMPUTE NEW VALUES OF U,V,P
C
      PARAMETER (N1=513, N2=513)

      include "mpif.h"
#include "f_hpc.h"

      COMMON/decomp/js,je,taskid,numtasks,req(16),
     1                            istat(MPI_STATUS_SIZE,16)
      integer taskid,req
      COMMON  U(N1,N2), V(N1,N2), P(N1,N2),
     *        UNEW(N1,N2), VNEW(N1,N2),
     1        PNEW(N1,N2), UOLD(N1,N2),
     *        VOLD(N1,N2), POLD(N1,N2),
     2        CU(N1,N2), CV(N1,N2),
     *        Z(N1,N2), H(N1,N2), PSI(N1,N2)
C
      COMMON /CONS/ DT,TDT,DX,DY,A,ALPHA,ITMAX,MPRINT,M,N,MP1,
     1              NP1,EL,PI,TPI,DI,DJ,PCF
      integer ierr
      integer omp_get_thread_num

      TDTS8 = TDT/8.
      TDTSDX = TDT/DX
      TDTSDY = TDT/DY

C SPEC removed CCMIC$ DO GLOBAL
CME ---------------------------------------------------
      call f_hpmstart( 15, "MPI Calc2 start" )
      CALL f_hpm_errchk
      if(taskid.lt.numtasks-1)then
      cALL mpi_irecv(CV(1,je+1),n1,MPI_DOUBLE_PRECISION,
     1  taskid+1,1,MPI_COMM_WORLD,req(1),ierr)
      cALL mpi_irecv(Z(1,je+1),n1,MPI_DOUBLE_PRECISION,
     1  taskid+1,2,MPI_COMM_WORLD,req(2),ierr)
      endif
      if(taskid.gt.0)then
      cALL mpi_isend(CV(1,js),n1,MPI_DOUBLE_PRECISION,
     1  taskid-1,1,MPI_COMM_WORLD,req(5),ierr)
      cALL mpi_isend(Z(1,js),n1,MPI_DOUBLE_PRECISION,
     1  taskid-1,2,MPI_COMM_WORLD,req(6),ierr)
      endif
      if(taskid.gt.0)then
      cALL mpi_irecv(H(1,js-1),n1,MPI_DOUBLE_PRECISION,
     1 taskid-1,3,MPI_COMM_WORLD,req(3),ierr)
      cALL mpi_irecv(CU(1,js-1),n1,MPI_DOUBLE_PRECISION,
     1 taskid-1,4,MPI_COMM_WORLD,req(4),ierr)
      endif
      if(taskid.lt.numtasks-1)then
      cALL mpi_isend(H(1,je),n1,MPI_DOUBLE_PRECISION,
     1  taskid+1,3,MPI_COMM_WORLD,req(7),ierr)
      cALL mpi_isend(CU(1,je),n1,MPI_DOUBLE_PRECISION,
     1  taskid+1,4,MPI_COMM_WORLD,req(8),ierr)
      endif
      cALL MPI_WAITALL(8,req,istat,ierr)
CME -------------------------------------------
C
C     PERIODIC CONTINUATION
      call f_hpmstop( 15 )
      CALL f_hpm_errchk

C$OMP PARALLEL
C$OMP&SHARED (TDTSDX,TDTS8,TDTSDY,M,N,UNEW,VNEW,PNEW,UOLD,VOLD,POLD)
C$OMP&SHARED(CU,CV,Z,H,js,je)
C$OMP&PRIVATE (I,J,mytID)
      mytID = 20 + omp_get_thread_num()
      call f_hpmtstart( mytID, "Loop 200" )
      CALL f_hpm_errchk
C$OMP DO
      DO 200 J=js,je
      DO 200 I=1,M
      UNEW(I+1,J) = UOLD(I+1,J)+
     1    TDTS8*(Z(I+1,J+1)+Z(I+1,J))*(CV(I+1,J+1)+CV(I,J+1)+CV(I,J)
     2       +CV(I+1,J))-TDTSDX*(H(I+1,J)-H(I,J))
      if(j.gt.1)then
      VNEW(I,J) = VOLD(I,J)-TDTS8*(Z(I+1,J)+Z(I,J))
     1     *(CU(I+1,J)+CU(I,J)+CU(I,J-1)+CU(I+1,J-1))
     2    -TDTSDY*(H(I,J)-H(I,J-1))
      endif
      if(j.eq.n)then
      VNEW(I,J+1) = VOLD(I,J+1)-TDTS8*(Z(I+1,J+1)+Z(I,J+1))
     1       *(CU(I+1,J+1)+CU(I,J+1)+CU(I,J)+CU(I+1,J))
     2       -TDTSDY*(H(I,J+1)-H(I,J))
      endif
      PNEW(I,J) = POLD(I,J)-TDTSDX*(CU(I+1,J)-CU(I,J))
     1       -TDTSDY*(CV(I,J+1)-CV(I,J))
  200 CONTINUE
      call f_hpmtstop( mytID )
      CALL f_hpm_errchk
C$OMP END PARALLEL
CME-----------------------------------------------------
C
C     PERIODIC CONTINUATION
C
      DO 210 J=1,N
      UNEW(1,J) = UNEW(M+1,J)
      PNEW(M+1,J) = PNEW(1,J)
       if(j.gt.1)then
      VNEW(M+1,J) = VNEW(1,J)
       endif
      if(j.eq.n)then
      VNEW(M+1,J+1) = VNEW(1,J+1)
      endif
  210 CONTINUE
      call f_hpmstart( 16, "MPI Calc2 end" )
      CALL f_hpm_errchk
      if(taskid.eq.0)then
      cALL mpi_irecv(VNEW(1,1),n1,MPI_DOUBLE_PRECISION,
     1    numtasks-1,1,MPI_COMM_WORLD,req(1),ierr)
      endif
      if(taskid.eq.numtasks-1)then
      cALL mpi_irecv(UNEW(1,n+1),n1,MPI_DOUBLE_PRECISION,
     1    0,2,MPI_COMM_WORLD,req(2),ierr)
      cALL mpi_irecv(PNEW(1,n+1),n1,MPI_DOUBLE_PRECISION,
     1    0,3,MPI_COMM_WORLD,req(3),ierr)
      endif
      if(taskid.eq.numtasks-1)then
      cALL mpi_isend(VNEW(1,n+1),n1,MPI_DOUBLE_PRECISION,
     1    0,1,MPI_COMM_WORLD,req(4),ierr)
      endif
      if(taskid.eq.0)then
      cALL mpi_isend(UNEW(1,1),n1,MPI_DOUBLE_PRECISION,
     1    numtasks-1,2,MPI_COMM_WORLD,req(5),ierr)
      cALL mpi_isend(PNEW(1,1),n1,MPI_DOUBLE_PRECISION,
     1    numtasks-1,3,MPI_COMM_WORLD,req(6),ierr)
      endif
      if(taskid.eq.0.or.taskid.eq.numtasks-1)then
      cALL MPI_WAITALL(6,req,istat,ierr)
      endif
c     DO 215 I=1,M
c     UNEW(I+1,N+1) = UNEW(I+1,1)
c     VNEW(I,1) = VNEW(I,N+1)
c     PNEW(I,N+1) = PNEW(I,1)
c 215 CONTINUE
c     UNEW(1,N+1) = UNEW(M+1,1)
c     VNEW(M+1,1) = VNEW(1,N+1)
c     PNEW(M+1,N+1) = PNEW(1,1)
      if(taskid.eq.numtasks-1)then
      cALL mpi_irecv(UNEW(1,N+1),1,MPI_DOUBLE_PRECISION,
     1    0,2,MPI_COMM_WORLD,req(1),ierr)
      cALL mpi_irecv(PNEW(M+1,N+1),1,MPI_DOUBLE_PRECISION,
     1    0,3,MPI_COMM_WORLD,req(2),ierr)
      endif
      if(taskid.eq.0)then
      cALL mpi_irecv(VNEW(M+1,1),1,MPI_DOUBLE_PRECISION,
     1numtasks-1,1,MPI_COMM_WORLD,req(3),ierr)
      endif

      if(taskid.eq.0)then
      cALL mpi_isend(UNEW(M+1,1),1,MPI_DOUBLE_PRECISION,
     1 numtasks-1,2,MPI_COMM_WORLD,req(4),ierr)
      cALL mpi_isend(PNEW(1,1),1,MPI_DOUBLE_PRECISION,
     1 numtasks-1,3,MPI_COMM_WORLD,req(5),ierr)
      endif
      if(taskid.eq.numtasks-1)then
      cALL mpi_isend(VNEW(1,n+1),1,MPI_DOUBLE_PRECISION,
     1  0,1,MPI_COMM_WORLD,req(6),ierr)
      endif
      if(taskid.eq.0.or.taskid.eq.numtasks-1)then
      cALL MPI_WAITALL(6,req,istat,ierr)
      endif
      call f_hpmstop( 16 )
      CALL f_hpm_errchk
C

      END
