/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2008               */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
#pragma comment(copyright,"5765-543 (C) Copyright IBM Corp. 2008 @(#) 1.2 src/ppe/hpct/source/examples/hpm/relax.c, ppe.hpct, ppe_rhya 08/12/01 14:19:20")
/* 
 * Validation: 
 * Using the default input, "Red" and "Black" should have approximately:
 * PM_ST_CMPL:  2M
 * PM_LD_CMPL:  9M
 * PM_EXEC_FMA: 2M
 * FLOPS:      11M
 * Comp Int.:  ~ 1
 */
#include <math.h>

#ifdef HPM
#include <stdlib.h>
#include "libhpc.h"
#define hpm_errchk if (hpm_error_count) exit(4)
#endif /* HPM */

extern double rho2;

void updateOmega( omega )
    double *omega;
{
    if ( *omega == 1.0)
    {
        *omega = 1.0 / (1.0 - 0.5 * rho2);
    }
    else
    {
        *omega = 1.0 / (1.0 - 0.25 * rho2 * *omega );
    }
}

void relax( n, omega, f, u, norm )
    int    n;
    double *omega, *norm;
    double *f, *u;
{
    int i, k, lsw;
    double resid;

    *norm = 0.0;

#ifdef HPM
    hpmStart( 22, "Red" );
    hpm_errchk;
#endif /* HPM */
    lsw = 1;
    for ( i = 1; i < n-1; i++ )
    {
        for ( k = lsw; k < n-1; k += 2 )
        {
            resid = u[n*(i+1) + k] + u[n*(i-1) + k] +
                    u[n*i + (k+1)] + u[n*i + (k-1)] -
                    4 * u[n*i + k] - f[n*i + k];
            *norm += fabs(resid);
            u[n*i + k] -= *omega * resid / (-4);
        }
        lsw = 3 - lsw;
    }
#ifdef HPM
    hpmStop( 22 );
    hpm_errchk;
#endif /* HPM */

    updateOmega( omega );
    
#ifdef HPM
    hpmStart( 27, "Black" );
    hpm_errchk;
#endif /* HPM */
    lsw = 2;
    for ( i = 1; i < n-1; i++ )
    {   
        for ( k = lsw; k < n-1; k+=2 )
        {
            resid = u[n*(i+1) + k] + u[n*(i-1) + k] +
                    u[n*i + (k+1)] + u[n*i + (k-1)] -
                    4 * u[n*i + k] - f[n*i + k];
            *norm += fabs(resid);
            u[n*i + k] -= *omega * resid / (-4);
        }
        lsw = 3 - lsw;
    }
#ifdef HPM
    hpmStop( 27 );
    hpm_errchk;
#endif /* HPM */
}
