C IBM_PROLOG_BEGIN_TAG 
C This is an automatically generated prolog. 
C  
C  
C  
C Licensed Materials - Property of IBM 
C  
C (C) COPYRIGHT International Business Machines Corp. 2008 
C All Rights Reserved 
C  
C US Government Users Restricted Rights - Use, duplication or 
C disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
C  
C IBM_PROLOG_END_TAG 
C ** Version modified for SPEC Benchmark suite - see Comments below
      PROGRAM SHALOW 
C     BENCHMARK WEATHER PREDICTION PROGRAM FOR COMPARING THE
C     PREFORMANCE OF CURRENT SUPERCOMPUTERS. THE MODEL IS
C     BASED OF THE PAPER - THE DYNAMICS OF FINITE-DIFFERENCE
C     MODELS OF THE SHALLOW-WATER EQUATIONS, BY ROBERT SADOURNY
C     J. ATM. SCIENCES, VOL 32, NO 4, APRIL 1975.
C
C     CODE BY PAUL N. SWARZTRAUBER, NATIONAL CENTER FOR
C     ATMOSPHERIC RESEARCH, BOULDER, CO,  OCTOBER 1984.
C
C     MODIFIED BY R. K. SATO, NCAR, APRIL 7, 1986 FOR MULTITASKING.
C     MODIFIED FOR SPEC to run longer: ITMAX inCremented from 120 to
C                                      1200 - J.Lo 7/19/90
C     Modified by Bodo Parady for the SPECpar suite.  Various
C     compilation sizes added.  Iterations reduced to orginal
C     problem, but size increased 4x in each dimension.
C
C     Further modified by Reinhold Weicker (Siemens Nixdorf) for the
C     SPEC CFP95 suite:
C     Changed back to the form with PARAMETER statements for
C     N1 and N2, set N1 = N2 = 513.
C     The execution time is determined by these values and the
C     variable ITMAX (number of iterations) read from the input file.
C     Execution time is linear in ITMAX.


      PARAMETER (N1=513, N2=513)

      COMMON  U(N1,N2), V(N1,N2), P(N1,N2),
     *        UNEW(N1,N2), VNEW(N1,N2),
     *        PNEW(N1,N2), UOLD(N1,N2),
     *        VOLD(N1,N2), POLD(N1,N2),
     *        CU(N1,N2), CV(N1,N2),
     *        Z(N1,N2), H(N1,N2), PSI(N1,N2)
C
      include "mpif.h"
#include "f_hpc.h"

C The include file: f_hpc.h contains the following lines:
C #define f_hpmstart(id, s) _f_hpm_start_(id, __LINE__, __FILE__, s )
C #define f_hpmtstart(id, s) _f_hpm_tstart_(id, __LINE__, __FILE__, s )
C #define f_hpmstop(id) _f_hpm_stop_(id, __LINE__ )
C #define f_hpmtstop(id) _f_hpm_tstop_(id, __LINE__ )

      COMMON/decomp/js,je,taskid,numtasks,req(16),
     1                            istat(MPI_STATUS_SIZE,16)
      integer taskid,req
cME       integer taskid
      COMMON /CONS/ DT,TDT,DX,DY,A,ALPHA,ITMAX,MPRINT,M,N,MP1,
     1              NP1,EL,PI,TPI,DI,DJ,PCF
      REAL*8 t1,t2
C
        parameter (MASTER=0)
c***** MPI variables
      integer  ierr, numtasks, numwrkrs, dest, i,
     &         datamsg, sizemsg, source, nbytes, chunksize,
     &         int4, real4, excess, arraysize, begval
      integer  status(3)
c***** initial data
c***** initialize MPI

c      Get number of tasks working on this.

      CALL MPI_INIT( ierr )
 
      CALL MPI_COMM_RANK( MPI_COMM_WORLD, taskid, ierr )
      CALL MPI_COMM_SIZE( MPI_COMM_WORLD, numtasks, ierr )
      if(taskid.eq.MASTER)then
        timei = MPI_Wtime()
      WRITE(6,*) 'SPEC benchmark 102.swim'

      WRITE(6,*) ' '
      endif
C
C Initializing array req with MPI_REQUEST_NULL
C
      do i=1,16
	req(i) = MPI_REQUEST_NULL
      end do

C       REQUEST PROCESSORS FOR MICROTASKING
C SPEC removed CMIC$ GETCPUS 4
C
C
C       INITIALIZE CONSTANTS AND ARRAYS
C
      CALL f_hpminit( taskid, "swim_mpi" )
      CALL f_hpm_errchk
      CALL f_hpmstart(5, "Inital")
      CALL f_hpm_errchk
      CALL INITAL
      CALL f_hpmstop(5)
      CALL f_hpm_errchk
C
C     PRINT INITIAL VALUES
C
      if(taskid.eq.MASTER)then
      WRITE(6,390) N,M,DX,DY,DT,ALPHA,ITMAX
  390 FORMAT(' NUMBER OF POINTS IN THE X DIRECTION', I8/
     1       ' NUMBER OF POINTS IN THE Y DIRECTION', I8/
     2       ' GRID SPACING IN THE X DIRECTION    ', F8.0/
     3       ' GRID SPACING IN THE Y DIRECTION    ', F8.0/
     4       ' TIME STEP                          ', F8.0/
     5       ' TIME FILTER PARAMETER              ', F8.3/
     6       ' NUMBER OF ITERATIONS               ', I8)
      endif
      MNMIN = MIN0(M,N)
C initial data writes removed for SPEC
C      WRITE(6,391) (POLD(I,I),I=1,MNMIN)
C  391 FORMAT(/' INITIAL DIAGONAL ELEMENTS OF P ', //(8E15.7))
C      WRITE(6,392) (UOLD(I,I),I=1,MNMIN)
C  392 FORMAT(/' INITIAL DIAGONAL ELEMENTS OF U ', //(8E15.7))
C      WRITE(6,393) (VOLD(I,I),I=1,MNMIN)
C  393 FORMAT(/' INITIAL DIAGONAL ELEMENTS OF V ', //(8E15.7))
C        DETERMINE OVERHEAD OF TIMING CALLS

C  6/22/95 for SPEC: JWR: Initialization of TIME
      TIME = 0
      NCYCLE = 0
      t1 = MPI_Wtime()
   90 NCYCLE = NCYCLE + 1
C
C     COMPUTE CAPITAL  U, CAPITAL V, Z AND H
C
      CALL f_hpmstart( 1, "Calc1" )
      CALL f_hpm_errchk
      CALL CALC1
      CALL f_hpmstop( 1 )
      CALL f_hpm_errchk
C
C     COMPUTE NEW VALUES U,V AND P
C
      CALL f_hpmstart( 2, "Calc2" )
      CALL f_hpm_errchk
      CALL CALC2
      CALL f_hpmstop( 2 )
      CALL f_hpm_errchk
C
      TIME = TIME + DT
      IF(MOD(NCYCLE,MPRINT) .NE. 0) GO TO 370
      
      PTIME = TIME/3600.
C
C *** modified for SPEC results verification
C *** We want to ensure that ALL calculations were done
C *** so we "use" ALL of the computed results.
C ***
C *** Since ALL of the comparisons of the individual diagnal terms
C *** often differ in the smALLer values, the check we have selected
C *** is to add the absolute values of ALL terms and print these results
C
  350 FORMAT(/' CYCLE NUMBER',I5,' MODEL TIME IN  HOURS', F6.2)
C      WRITE(6,355) (PNEW(I,I),I=1,MNMIN)
C  355 FORMAT(/' DIAGONAL ELEMENTS OF P ', //(8E15.7))
C      WRITE(6,360) (UNEW(I,I),I=1,MNMIN)
C  360 FORMAT(/' DIAGONAL ELEMENTS OF U ', //(8E15.7))
C      WRITE(6,365) (VNEW(I,I),I=1,MNMIN)
C  365 FORMAT(/' DIAGONAL ELEMENTS OF V ', //(8E15.7))
C ***
        PCHECK = 0.0
        UCHECK = 0.0
        VCHECK = 0.0
        
        DO 3500 JCHECK = js,je
         DO 3500 ICHECK = 1, MNMIN
         PCHECK = PCHECK + ABS(PNEW(ICHECK,JCHECK))
         UCHECK = UCHECK + ABS(UNEW(ICHECK,JCHECK))
         VCHECK = VCHECK + ABS(VNEW(ICHECK,JCHECK))
 3500   CONTINUE
        CALL mpi_reduce(pcheck,tpcheck,1,MPI_DOUBLE_PRECISION,
     1    MPI_SUM,0,MPI_COMM_WORLD,ierr)
        CALL mpi_reduce(ucheck,tucheck,1,MPI_DOUBLE_PRECISION,
     1    MPI_SUM,0,MPI_COMM_WORLD,ierr)
        CALL mpi_reduce(vcheck,tvcheck,1,MPI_DOUBLE_PRECISION,
     1    MPI_SUM,0,MPI_COMM_WORLD,ierr)
C ***
C ***
      if(MASTER.eq.taskid)then
      WRITE(6,350) NCYCLE,PTIME
      endif
      if(MASTER.eq.taskid)then
        WRITE(6,366) tPCHECK, tUCHECK, tVCHECK
      endif
 366    FORMAT(/,
     *         ' Pcheck = ',E12.4,/,
     *         ' Ucheck = ',E12.4,/,
     *         ' Vcheck = ',E12.4,/)

370   CONTINUE
C        TEST FOR END OF RUN
      IF(NCYCLE .GE. ITMAX) THEN
      t2 = MPI_Wtime()
      if(taskid.eq.0)print*,'wALLclock time=',T2-T1
      CALL f_hpm_terminate( taskid )
      CALL f_hpm_errchk
      CALL MPI_FINALIZE(ierr)
      STOP
      ENDIF
C
C     TIME SMOOTHING AND UPDATE FOR NEXT CYCLE
C

      IF(NCYCLE .LE. 1) THEN
c        CALL f_hpmstart( 4, "Calc3z" )
         CALL CALC3Z
c        CALL f_hpmstop( 4 )
      ELSE
         CALL f_hpmstart( 3, "Calc3" )
         CALL f_hpm_errchk
         CALL CALC3
         CALL f_hpmstop( 3 )
         CALL f_hpm_errchk
      ENDIF
C
      GO TO 90
      END
      SUBROUTINE INITAL
C        INITIALIZE CONSTANTS AND ARRAYS
C           R. K. SATO 4/7/86
C
      PARAMETER (N1=513, N2=513)

      include "mpif.h"
      COMMON/decomp/js,je,taskid,numtasks,req(16),
     1                            istat(MPI_STATUS_SIZE,16)
      integer taskid,req
      COMMON  U(N1,N2), V(N1,N2), P(N1,N2),
     *        UNEW(N1,N2), VNEW(N1,N2),
     1        PNEW(N1,N2), UOLD(N1,N2),
     *        VOLD(N1,N2), POLD(N1,N2),
     2        CU(N1,N2), CV(N1,N2),
     *        Z(N1,N2), H(N1,N2), PSI(N1,N2)
C
      COMMON /CONS/ DT,TDT,DX,DY,A,ALPHA,ITMAX,MPRINT,M,N,MP1,
     1              NP1,EL,PI,TPI,DI,DJ,PCF
C
C     NOTE BELOW THAT TWO DELTA T (TDT) IS SET TO DT ON THE FIRST
C     CYCLE AFTER WHICH IT IS RESET TO DT+DT.
C
C The following code  was in SWM256, however, it was replaced by 
C		READ statements to avoid calculations to be done during
C		compile time.
C
      integer ierr

       DT = 20.
 
       DX = .25E5
       DY = .25E5
       A = 1.E6
       ALPHA = .001
       ITMAX = 102
       MPRINT = 240
       M = N1 - 1
       N = N2 - 1
c     READ (5,*) DT
c     READ (5,*) DX
c     READ (5,*) DY
c     READ (5,*) A
c     READ (5,*) ALPHA
c     READ (5,*) ITMAX
c     READ (5,*) MPRINT
c     READ (5,*) M
c     READ (5,*) N
      TDT = DT
      MP1 = M+1
      NP1 = N+1
      EL = FLOAT(N)*DX
      PI = 4.*ATAN(1.)
      TPI = PI+PI
      DI = TPI/FLOAT(M)
      DJ = TPI/FLOAT(N)
      PCF = PI*PI*A*A/(EL*EL)
      js = 1 + (N/numtasks+1)*taskid
      je = min(n2,js+N/numtasks)
C
C     INITIAL VALUES OF THE STREAM FUNCTION AND P
C
      DO 50 J=js,je
      DO 50 I=1,MP1
      PSI(I,J) = A*SIN((FLOAT(I)-.5)*DI)*SIN((FLOAT(J)-.5)*DJ)
      P(I,J) = PCF*(COS(2.*FLOAT(I-1)*DI)
     1                +COS(2.*FLOAT(J-1)*DJ))+50000.
      if(j.eq.n)then
      P(I,J+1) = PCF*(COS(2.*FLOAT(I-1)*DI)
     1                +COS(2.*FLOAT(J)*DJ))+50000.
      endif
   50 CONTINUE
C
C     INITIALIZE VELOCITIES
C
      if(taskid.lt.numtasks-1)then
      CALL mpi_irecv(psi(1,je+1),n1,MPI_DOUBLE_PRECISION,
     1    taskid+1,1,MPI_COMM_WORLD,req(1),ierr)
      endif
      if(taskid.gt.0)then
      CALL mpi_isend(psi(1,js),n1,MPI_DOUBLE_PRECISION,
     1    taskid-1,1,MPI_COMM_WORLD,req(2),ierr)
      endif
      CALL MPI_WAITALL(2,req,istat,ierr)
      DO 60 J=js,je
      DO 60 I=1,M
      U(I+1,J) = -(PSI(I+1,J+1)-PSI(I+1,J))/DY
      if(j.gt.1)then
      V(I,J) = (PSI(I+1,J)-PSI(I,J))/DX
      endif
      if(j.eq.n)then
      V(I,J+1) = (PSI(I+1,J+1)-PSI(I,J+1))/DX
      endif
   60 CONTINUE
C
C     PERIODIC CONTINUATION
C
      DO 70 J=1,N
      U(1,J) = U(M+1,J)
      V(M+1,J) = V(1,J)
      if(j.eq.n)then
      V(M+1,J+1) = V(1,J+1)
      endif
   70 CONTINUE
      if(taskid.eq.0)then
      CALL mpi_irecv(v(1,1),n1,MPI_DOUBLE_PRECISION,
     1    numtasks-1,1,MPI_COMM_WORLD,req(1),ierr)
      endif
      if(taskid.eq.numtasks-1)then
      CALL mpi_irecv(u(1,n+1),n1,MPI_DOUBLE_PRECISION,
     1    0,2,MPI_COMM_WORLD,req(2),ierr)
      endif
      if(taskid.eq.numtasks-1)then
      CALL mpi_isend(v(1,n+1),n1,MPI_DOUBLE_PRECISION,
     1    0,1,MPI_COMM_WORLD,req(3),ierr)
      endif
      if(taskid.eq.0)then
      CALL mpi_isend(u(1,1),n1,MPI_DOUBLE_PRECISION,
     1    numtasks-1,2,MPI_COMM_WORLD,req(4),ierr)
      endif
      if(taskid.eq.0.or.taskid.eq.numtasks-1)then
      CALL MPI_WAITALL(4,req,istat,ierr)
      endif
c     DO 75 I=1,M
c     U(I+1,N+1) = U(I+1,1)
c     V(I,1) = V(I,N+1)
c  75 CONTINUE
cm tag_v=2
      if(taskid.eq.0)then
      CALL mpi_irecv(v(m+1,1),1,MPI_DOUBLE_PRECISION,
     1    numtasks-1,1,MPI_COMM_WORLD,req(1),ierr)
      endif
      if(taskid.eq.numtasks-1)then
      CALL mpi_irecv(u(1,n+1),1,MPI_DOUBLE_PRECISION,
     1    0,2,MPI_COMM_WORLD,req(2),ierr)
      endif
      if(taskid.eq.numtasks-1)then
      CALL mpi_isend(v(1,n+1),1,MPI_DOUBLE_PRECISION,
     1    0,1,MPI_COMM_WORLD,req(3),ierr)
      endif
      if(taskid.eq.0)then
      CALL mpi_isend(u(M+1,1),1,MPI_DOUBLE_PRECISION,
     1    numtasks-1,2,MPI_COMM_WORLD,req(4),ierr)
      endif
      if(taskid.eq.0.or.taskid.eq.numtasks-1)then
      CALL MPI_WAITALL(4,req,istat,ierr)
      endif
c     U(1,N+1) = U(M+1,1)
c     V(M+1,1) = V(1,N+1)
      DO 86 J=js,je
      DO 86 I=1,MP1
      UOLD(I,J) = U(I,J)
      VOLD(I,J) = V(I,J)
      POLD(I,J) = P(I,J)
      if(j.eq.n)then
      UOLD(I,J+1) = U(I,J+1)
      VOLD(I,J+1) = V(I,J+1)
      POLD(I,J+1) = P(I,J+1)
      endif
   86 CONTINUE
C        END OF INITIALIZATION
      RETURN
      END
C SPEC removed CCMIC$ MICRO
      SUBROUTINE CALC1
C
C        COMPUTE CAPITAL  U, CAPITAL V, Z AND H
C
      PARAMETER (N1=513, N2=513)

      include "mpif.h"
      COMMON/decomp/js,je,taskid,numtasks,req(16),
     1                            istat(MPI_STATUS_SIZE,16)
      integer taskid,req
      COMMON  U(N1,N2), V(N1,N2), P(N1,N2),
     *        UNEW(N1,N2), VNEW(N1,N2),
     1        PNEW(N1,N2), UOLD(N1,N2),
     *        VOLD(N1,N2), POLD(N1,N2),
     2        CU(N1,N2), CV(N1,N2),
     *        Z(N1,N2), H(N1,N2), PSI(N1,N2)
C
      COMMON /CONS/ DT,TDT,DX,DY,A,ALPHA,ITMAX,MPRINT,M,N,MP1,
     1              NP1,EL,PI,TPI,DI,DJ,PCF
C
      integer ierr

      FSDX = 4./DX
      FSDY = 4./DY

C SPEC removed CCMIC$ DO GLOBAL
CME ------------------------------------------------
	CALL f_hpmstart(8, "MPI Calc1 start")
        CALL f_hpm_errchk
      if(taskid.lt.numtasks-1)then
      CALL mpi_irecv(V(1,je+1),n1,MPI_DOUBLE_PRECISION,
     1 taskid+1,1,MPI_COMM_WORLD,req(1),ierr)
      endif
      if(taskid.gt.0)then
      CALL mpi_isend(V(1,js),n1,MPI_DOUBLE_PRECISION,
     1 taskid-1,1,MPI_COMM_WORLD,req(4),ierr)
      endif
      if(taskid.gt.0)then
      CALL mpi_irecv(U(1,js-1),n1,MPI_DOUBLE_PRECISION,
     1 taskid-1,2,MPI_COMM_WORLD,req(2),ierr)
      CALL mpi_irecv(P(1,js-1),n1,MPI_DOUBLE_PRECISION,
     1 taskid-1,3,MPI_COMM_WORLD,req(3),ierr)
      endif
      if(taskid.lt.numtasks-1)then
      CALL mpi_isend(U(1,je),n1,MPI_DOUBLE_PRECISION,
     1  taskid+1,2,MPI_COMM_WORLD,req(5),ierr)
      CALL mpi_isend(P(1,je),n1,MPI_DOUBLE_PRECISION,
     1  taskid+1,3,MPI_COMM_WORLD,req(6),ierr)
      endif

      CALL MPI_WAITALL(6,req,istat,ierr)
	CALL f_hpmstop(8)
        CALL f_hpm_errchk

      CALL f_hpmstart( 10, "Loop 100" )
      CALL f_hpm_errchk
CME--- CHECK p(i,j-1) and u(i+1,j-1) CHECK -- <<<<<<<<<<<<<
C$OMP PARALLELDO
C$OMP&SHARED (FSDY,FSDX,M,N,U,V,P,CU,CV,Z,H,js,je)
C$OMP&PRIVATE (I,J)
      DO 100 J=js,je
      DO 100 I=1,M
      CU(I+1,J) = .5*(P(I+1,J)+P(I,J))*U(I+1,J)
      if(j.gt.1)then 
      CV(I,J)  = .5*(P(I,J)+P(I,J-1))*V(I,J)
      Z(I+1,J) = (FSDX*(V(I+1,J)-V(I,J))-FSDY*(U(I+1,J)
     1    -U(I+1,J-1)))/(P(I,J-1)+P(I+1,J-1)+P(I+1,J)+P(I,J))
      endif
      if(j.eq.n)then
      CV(I,J+1)  = .5*(P(I,J+1)+P(I,J))*V(I,J+1)
      Z(I+1,J+1) = (FSDX*(V(I+1,J+1)-V(I,J+1))-FSDY*(U(I+1,J+1)
     1          -U(I+1,J)))/(P(I,J)+P(I+1,J)+P(I+1,J+1)+P(I,J+1))
      endif
      H(I,J) = P(I,J)+.25*(U(I+1,J)*U(I+1,J)+U(I,J)*U(I,J)
     1               +V(I,J+1)*V(I,J+1)+V(I,J)*V(I,J))
  100 CONTINUE
      CALL f_hpmstop( 10 )
      CALL f_hpm_errchk

CME -------------------------------------------
C
C     PERIODIC CONTINUATION
C
	CALL f_hpmstart(11, "loop 110")
        CALL f_hpm_errchk
      DO 110 J=js,je
      CU(1,J) = CU(M+1,J)
      H(M+1,J) = H(1,J)
      if(j.gt.1)then
      Z(1,J) = Z(M+1,J)
      CV(M+1,J) = CV(1,J)
      endif
      if(j.eq.n)then
      Z(1,J+1) = Z(M+1,J+1)
      CV(M+1,J+1) = CV(1,J+1)
      endif
  110 CONTINUE
	CALL f_hpmstop(11)
        CALL f_hpm_errchk
      CALL f_hpmstart( 12, "MPI Calc1 end" )
      CALL f_hpm_errchk
      if(taskid.eq.0)then
      CALL mpi_irecv(cv(1,1),n1,MPI_DOUBLE_PRECISION,
     1    numtasks-1,1,MPI_COMM_WORLD,req(1),ierr)
      CALL mpi_irecv(z(1,1),n1,MPI_DOUBLE_PRECISION,
     1    numtasks-1,2,MPI_COMM_WORLD,req(2),ierr)
      endif
      if(taskid.eq.numtasks-1)then
      CALL mpi_irecv(cu(1,n+1),n1,MPI_DOUBLE_PRECISION,
     1    0,3,MPI_COMM_WORLD,req(3),ierr)
      CALL mpi_irecv(h(1,n+1),n1,MPI_DOUBLE_PRECISION,
     1    0,4,MPI_COMM_WORLD,req(4),ierr)
      endif
      if(taskid.eq.numtasks-1)then
      CALL mpi_isend(cv(1,n+1),n1,MPI_DOUBLE_PRECISION,
     1    0,1,MPI_COMM_WORLD,req(5),ierr)
      CALL mpi_isend(z(1,n+1),n1,MPI_DOUBLE_PRECISION,
     1    0,2,MPI_COMM_WORLD,req(6),ierr)
      endif
      if(taskid.eq.0)then
      CALL mpi_isend(cu(1,1),n1,MPI_DOUBLE_PRECISION,
     1    numtasks-1,3,MPI_COMM_WORLD,req(7),ierr)
      CALL mpi_isend(h(1,1),n1,MPI_DOUBLE_PRECISION,
     1    numtasks-1,4,MPI_COMM_WORLD,req(8),ierr)
      endif
      if(taskid.eq.0.or.taskid.eq.numtasks-1)then
      CALL MPI_WAITALL(8,req,istat,ierr)
      endif
c     DO 115 I=1,M
c     CU(I+1,N+1) = CU(I+1,1)
c     CV(I,1) = CV(I,N+1)
c     Z(I+1,1) = Z(I+1,N+1)
c     H(I,N+1) = H(I,1)
c 115 CONTINUE

      if(taskid.eq.numtasks-1)then
      CALL mpi_irecv(Cu(1,N+1),1,MPI_DOUBLE_PRECISION,
     1    0,1,MPI_COMM_WORLD,req(1),ierr)
      CALL mpi_irecv(H(M+1,N+1),1,MPI_DOUBLE_PRECISION,
     1    0,2,MPI_COMM_WORLD,req(2),ierr)
      endif
      if(taskid.eq.0)then
      CALL mpi_irecv(Cv(M+1,1),1,MPI_DOUBLE_PRECISION,
     1numtasks-1,3,MPI_COMM_WORLD,req(3),ierr)
      CALL mpi_irecv(Z(1,1),1,MPI_DOUBLE_PRECISION,
     1numtasks-1,4,MPI_COMM_WORLD,req(4),ierr)
      endif

      if(taskid.eq.numtasks-1)then
      CALL mpi_isend(Cv(1,N+1),1,MPI_DOUBLE_PRECISION,
     1 0,3,MPI_COMM_WORLD,req(5),ierr)
      CALL mpi_isend(z(m+1,n+1),1,MPI_DOUBLE_PRECISION,
     1 0,4,MPI_COMM_WORLD,req(6),ierr)
      endif
      if(taskid.eq.0)then
      CALL mpi_isend(Cu(M+1,1),1,MPI_DOUBLE_PRECISION,
     1  numtasks-1,1,MPI_COMM_WORLD,req(7),ierr)
      CALL mpi_isend(h(1,1),1,MPI_DOUBLE_PRECISION,
     1  numtasks-1,2,MPI_COMM_WORLD,req(8),ierr)
      endif
      if(taskid.eq.0.or.taskid.eq.numtasks-1)then
      CALL MPI_WAITALL(8,req,istat,ierr)
      endif
      CALL f_hpmstop( 12 )
      CALL f_hpm_errchk
CME      CU(1,N+1) = CU(M+1,1)
CME      CV(M+1,1) = CV(1,N+1)
CME      Z(1,1) = Z(M+1,N+1)
CME      H(M+1,N+1) = H(1,1)

C        END OF LOOP 100 CALCULATIONS
      RETURN
      END
C SPEC removed CCMIC$ MICRO
      SUBROUTINE CALC2
C
C        COMPUTE NEW VALUES OF U,V,P
C
      PARAMETER (N1=513, N2=513)

      include "mpif.h"
      COMMON/decomp/js,je,taskid,numtasks,req(16),
     1                            istat(MPI_STATUS_SIZE,16)
      integer taskid,req
      COMMON  U(N1,N2), V(N1,N2), P(N1,N2),
     *        UNEW(N1,N2), VNEW(N1,N2),
     1        PNEW(N1,N2), UOLD(N1,N2),
     *        VOLD(N1,N2), POLD(N1,N2),
     2        CU(N1,N2), CV(N1,N2),
     *        Z(N1,N2), H(N1,N2), PSI(N1,N2)
C
      COMMON /CONS/ DT,TDT,DX,DY,A,ALPHA,ITMAX,MPRINT,M,N,MP1,
     1              NP1,EL,PI,TPI,DI,DJ,PCF
      integer ierr

      TDTS8 = TDT/8.
      TDTSDX = TDT/DX
      TDTSDY = TDT/DY

C SPEC removed CCMIC$ DO GLOBAL
CME ---------------------------------------------------
      CALL f_hpmstart( 15, "MPI Calc2 start" )
      CALL f_hpm_errchk
      if(taskid.lt.numtasks-1)then
      CALL mpi_irecv(CV(1,je+1),n1,MPI_DOUBLE_PRECISION,
     1  taskid+1,1,MPI_COMM_WORLD,req(1),ierr)
      CALL mpi_irecv(Z(1,je+1),n1,MPI_DOUBLE_PRECISION,
     1  taskid+1,2,MPI_COMM_WORLD,req(2),ierr)
      endif
      if(taskid.gt.0)then
      CALL mpi_isend(CV(1,js),n1,MPI_DOUBLE_PRECISION,
     1  taskid-1,1,MPI_COMM_WORLD,req(5),ierr)
      CALL mpi_isend(Z(1,js),n1,MPI_DOUBLE_PRECISION,
     1  taskid-1,2,MPI_COMM_WORLD,req(6),ierr)
      endif
      if(taskid.gt.0)then
      CALL mpi_irecv(H(1,js-1),n1,MPI_DOUBLE_PRECISION,
     1 taskid-1,3,MPI_COMM_WORLD,req(3),ierr)
      CALL mpi_irecv(CU(1,js-1),n1,MPI_DOUBLE_PRECISION,
     1 taskid-1,4,MPI_COMM_WORLD,req(4),ierr)
      endif
      if(taskid.lt.numtasks-1)then
      CALL mpi_isend(H(1,je),n1,MPI_DOUBLE_PRECISION,
     1  taskid+1,3,MPI_COMM_WORLD,req(7),ierr)
      CALL mpi_isend(CU(1,je),n1,MPI_DOUBLE_PRECISION,
     1  taskid+1,4,MPI_COMM_WORLD,req(8),ierr)
      endif
      CALL MPI_WAITALL(8,req,istat,ierr)
CME -------------------------------------------
C
C     PERIODIC CONTINUATION
      CALL f_hpmstop( 15 )
      CALL f_hpm_errchk

      CALL f_hpmstart( 20, "Loop 200" )
      CALL f_hpm_errchk
C$OMP PARALLELDO
C$OMP&SHARED (TDTSDX,TDTS8,TDTSDY,M,N,UNEW,VNEW,PNEW,UOLD,VOLD,POLD)
C$OMP&SHARED(CU,CV,Z,H,js,je)
C$OMP&PRIVATE (I,J)
      DO 200 J=js,je
      DO 200 I=1,M
      UNEW(I+1,J) = UOLD(I+1,J)+
     1    TDTS8*(Z(I+1,J+1)+Z(I+1,J))*(CV(I+1,J+1)+CV(I,J+1)+CV(I,J)
     2       +CV(I+1,J))-TDTSDX*(H(I+1,J)-H(I,J))
      if(j.gt.1)then
      VNEW(I,J) = VOLD(I,J)-TDTS8*(Z(I+1,J)+Z(I,J))
     1     *(CU(I+1,J)+CU(I,J)+CU(I,J-1)+CU(I+1,J-1))
     2    -TDTSDY*(H(I,J)-H(I,J-1))
      endif
      if(j.eq.n)then
      VNEW(I,J+1) = VOLD(I,J+1)-TDTS8*(Z(I+1,J+1)+Z(I,J+1))
     1       *(CU(I+1,J+1)+CU(I,J+1)+CU(I,J)+CU(I+1,J))
     2       -TDTSDY*(H(I,J+1)-H(I,J))
      endif
      PNEW(I,J) = POLD(I,J)-TDTSDX*(CU(I+1,J)-CU(I,J))
     1       -TDTSDY*(CV(I,J+1)-CV(I,J))
  200 CONTINUE
      CALL f_hpmstop( 20 )
      CALL f_hpm_errchk
CME-----------------------------------------------------
C
C     PERIODIC CONTINUATION
C
      DO 210 J=1,N
      UNEW(1,J) = UNEW(M+1,J)
      PNEW(M+1,J) = PNEW(1,J)
       if(j.gt.1)then
      VNEW(M+1,J) = VNEW(1,J)
       endif
      if(j.eq.n)then
      VNEW(M+1,J+1) = VNEW(1,J+1)
      endif
  210 CONTINUE
      CALL f_hpmstart( 16, "MPI Calc2 end" )
      CALL f_hpm_errchk
      if(taskid.eq.0)then
      CALL mpi_irecv(VNEW(1,1),n1,MPI_DOUBLE_PRECISION,
     1    numtasks-1,1,MPI_COMM_WORLD,req(1),ierr)
      endif
      if(taskid.eq.numtasks-1)then
      CALL mpi_irecv(UNEW(1,n+1),n1,MPI_DOUBLE_PRECISION,
     1    0,2,MPI_COMM_WORLD,req(2),ierr)
      CALL mpi_irecv(PNEW(1,n+1),n1,MPI_DOUBLE_PRECISION,
     1    0,3,MPI_COMM_WORLD,req(3),ierr)
      endif
      if(taskid.eq.numtasks-1)then
      CALL mpi_isend(VNEW(1,n+1),n1,MPI_DOUBLE_PRECISION,
     1    0,1,MPI_COMM_WORLD,req(4),ierr)
      endif
      if(taskid.eq.0)then
      CALL mpi_isend(UNEW(1,1),n1,MPI_DOUBLE_PRECISION,
     1    numtasks-1,2,MPI_COMM_WORLD,req(5),ierr)
      CALL mpi_isend(PNEW(1,1),n1,MPI_DOUBLE_PRECISION,
     1    numtasks-1,3,MPI_COMM_WORLD,req(6),ierr)
      endif
      if(taskid.eq.0.or.taskid.eq.numtasks-1)then
      CALL MPI_WAITALL(6,req,istat,ierr)
      endif
c     DO 215 I=1,M
c     UNEW(I+1,N+1) = UNEW(I+1,1)
c     VNEW(I,1) = VNEW(I,N+1)
c     PNEW(I,N+1) = PNEW(I,1)
c 215 CONTINUE
c     UNEW(1,N+1) = UNEW(M+1,1)
c     VNEW(M+1,1) = VNEW(1,N+1)
c     PNEW(M+1,N+1) = PNEW(1,1)
      if(taskid.eq.numtasks-1)then
      CALL mpi_irecv(UNEW(1,N+1),1,MPI_DOUBLE_PRECISION,
     1    0,2,MPI_COMM_WORLD,req(1),ierr)
      CALL mpi_irecv(PNEW(M+1,N+1),1,MPI_DOUBLE_PRECISION,
     1    0,3,MPI_COMM_WORLD,req(2),ierr)
      endif
      if(taskid.eq.0)then
      CALL mpi_irecv(VNEW(M+1,1),1,MPI_DOUBLE_PRECISION,
     1numtasks-1,1,MPI_COMM_WORLD,req(3),ierr)
      endif

      if(taskid.eq.0)then
      CALL mpi_isend(UNEW(M+1,1),1,MPI_DOUBLE_PRECISION,
     1 numtasks-1,2,MPI_COMM_WORLD,req(4),ierr)
      CALL mpi_isend(PNEW(1,1),1,MPI_DOUBLE_PRECISION,
     1 numtasks-1,3,MPI_COMM_WORLD,req(5),ierr)
      endif
      if(taskid.eq.numtasks-1)then
      CALL mpi_isend(VNEW(1,n+1),1,MPI_DOUBLE_PRECISION,
     1  0,1,MPI_COMM_WORLD,req(6),ierr)
      endif
      if(taskid.eq.0.or.taskid.eq.numtasks-1)then
      CALL MPI_WAITALL(6,req,istat,ierr)
      endif
      CALL f_hpmstop( 16 )
      CALL f_hpm_errchk
C

      END
      SUBROUTINE CALC3Z
C
C         TIME SMOOTHER FOR FIRST ITERATION
C
      PARAMETER (N1=513, N2=513)

      include "mpif.h"
      COMMON/decomp/js,je,taskid,numtasks,req(16),
     1                            istat(MPI_STATUS_SIZE,16)
      integer taskid,req
      COMMON  U(N1,N2), V(N1,N2), P(N1,N2),
     *        UNEW(N1,N2), VNEW(N1,N2),
     1        PNEW(N1,N2), UOLD(N1,N2),
     *        VOLD(N1,N2), POLD(N1,N2),
     2        CU(N1,N2), CV(N1,N2),
     *        Z(N1,N2), H(N1,N2), PSI(N1,N2)
C
      COMMON /CONS/ DT,TDT,DX,DY,A,ALPHA,ITMAX,MPRINT,M,N,MP1,
     1              NP1,EL,PI,TPI,DI,DJ,PCF
C
CME -----------------------------------------
      integer ierr

      TDT = TDT+TDT
      DO 400 J=js,je
      DO 400 I=1,MP1
      UOLD(I,J) = U(I,J)
      VOLD(I,J) = V(I,J)
      POLD(I,J) = P(I,J)
      U(I,J)    = UNEW(I,J)
      V(I,J)    = VNEW(I,J)
      P(I,J)    = PNEW(I,J)
      if(j.eq.n)then
      UOLD(I,J+1) = U(I,J+1)
      VOLD(I,J+1) = V(I,J+1)
      POLD(I,J+1) = P(I,J+1)
      U(I,J+1)    = UNEW(I,J+1)
      V(I,J+1)    = VNEW(I,J+1)
      P(I,J+1)    = PNEW(I,J+1)
      endif
  400 CONTINUE
      RETURN
      END
CME ----------------------------------------
C SPEC removed CCMIC$ MICRO
      SUBROUTINE CALC3
C
C         TIME SMOOTHER
C
      PARAMETER (N1=513, N2=513)

      include "mpif.h"
      COMMON/decomp/js,je,taskid,numtasks,req(16),
     1                            istat(MPI_STATUS_SIZE,16)
      integer taskid,req
      COMMON  U(N1,N2), V(N1,N2), P(N1,N2),
     *        UNEW(N1,N2), VNEW(N1,N2),
     1        PNEW(N1,N2), UOLD(N1,N2),
     *        VOLD(N1,N2), POLD(N1,N2),
     2        CU(N1,N2), CV(N1,N2),
     *        Z(N1,N2), H(N1,N2), PSI(N1,N2)
C
      COMMON /CONS/ DT,TDT,DX,DY,A,ALPHA,ITMAX,MPRINT,M,N,MP1,
     1              NP1,EL,PI,TPI,DI,DJ,PCF
      integer ierr

C
C        TIME SMOOTHING AND UPDATE FOR NEXT CYCLE
C

C SPEC removed CCMIC$ DO GLOBAL
      CALL f_hpmstart( 30, "Loop 300" )
      CALL f_hpm_errchk
C$OMP PARALLELDO
C$OMP&SHARED (ALPHA,M,N,U,V,P,UNEW,VNEW,PNEW,UOLD,VOLD,POLD)
C$OMP&SHARED (JS,JE)
C$OMP&PRIVATE (I,J)
      DO 300 J=js,je
      DO 300 I=1,M
      UOLD(I,J) = U(I,J)+ALPHA*(UNEW(I,J)-2.*U(I,J)+UOLD(I,J))
      VOLD(I,J) = V(I,J)+ALPHA*(VNEW(I,J)-2.*V(I,J)+VOLD(I,J))
      POLD(I,J) = P(I,J)+ALPHA*(PNEW(I,J)-2.*P(I,J)+POLD(I,J))
      U(I,J) = UNEW(I,J)
      V(I,J) = VNEW(I,J)
      P(I,J) = PNEW(I,J)
  300 CONTINUE
      CALL f_hpmstop( 30 )
      CALL f_hpm_errchk
CME-------------------------------------------

C
C     PERIODIC CONTINUATION
C
CME----------------------------------------------
      DO 320 J=1,N
      UOLD(M+1,J) = UOLD(1,J)
      VOLD(M+1,J) = VOLD(1,J)
      POLD(M+1,J) = POLD(1,J)
      U(M+1,J) = U(1,J)
      V(M+1,J) = V(1,J)
      P(M+1,J) = P(1,J)
  320 CONTINUE
CME------------------------------------------------------
      CALL f_hpmstart( 18, "MPI in Calc3" )
      CALL f_hpm_errchk
      if(taskid.eq.numtasks-1)then                        
      CALL mpi_irecv(v(1,n+1),n1,MPI_DOUBLE_PRECISION,     
     1 0,1,MPI_COMM_WORLD,req(1),ierr)
      CALL mpi_irecv(u(1,n+1),n1,MPI_DOUBLE_PRECISION,     
     1 0,2,MPI_COMM_WORLD,req(2),ierr)         
      CALL mpi_irecv(p(1,n+1),n1,MPI_DOUBLE_PRECISION,     
     1 0,3,MPI_COMM_WORLD,req(3),ierr)         
      CALL mpi_irecv(vold(1,n+1),n1,MPI_DOUBLE_PRECISION,     
     1 0,4,MPI_COMM_WORLD,req(4),ierr)
      CALL mpi_irecv(uold(1,n+1),n1,MPI_DOUBLE_PRECISION,     
     1 0,5,MPI_COMM_WORLD,req(5),ierr)         
      CALL mpi_irecv(pold(1,n+1),n1,MPI_DOUBLE_PRECISION,     
     1 0,6,MPI_COMM_WORLD,req(6),ierr)         
      endif
      if(taskid.eq.0)then
      CALL mpi_isend(v(1,1),n1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,1,MPI_COMM_WORLD,req(7),ierr)                        
      CALL mpi_isend(u(1,1),n1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,2,MPI_COMM_WORLD,req(8),ierr)
      CALL mpi_isend(p(1,1),n1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,3,MPI_COMM_WORLD,req(9),ierr)
      CALL mpi_isend(vold(1,1),n1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,4,MPI_COMM_WORLD,req(10),ierr)                        
      CALL mpi_isend(uold(1,1),n1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,5,MPI_COMM_WORLD,req(11),ierr)
      CALL mpi_isend(pold(1,1),n1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,6,MPI_COMM_WORLD,req(12),ierr)
      endif 
      if(taskid.eq.0.or.taskid.eq.numtasks-1)then
      CALL MPI_WAITALL(12,req,istat,ierr)
      endif

c      DO 325 I=1,M
c      UOLD(I,N+1) = UOLD(I,1)
c      VOLD(I,N+1) = VOLD(I,1)
c      POLD(I,N+1) = POLD(I,1)
c      U(I,N+1)    = U(I,1)
c      V(I,N+1)    = V(I,1)
c      P(I,N+1)    = P(I,1)
c 325 CONTINUE

      if(taskid.eq.numtasks-1)then                        
      CALL mpi_irecv(v(m+1,n+1),1,MPI_DOUBLE_PRECISION,     
     1 0,1,MPI_COMM_WORLD,req(1),ierr)
      CALL mpi_irecv(u(m+1,n+1),1,MPI_DOUBLE_PRECISION,     
     1 0,2,MPI_COMM_WORLD,req(2),ierr)         
      CALL mpi_irecv(p(m+1,n+1),1,MPI_DOUBLE_PRECISION,     
     1 0,3,MPI_COMM_WORLD,req(3),ierr)         
      CALL mpi_irecv(vold(m+1,n+1),1,MPI_DOUBLE_PRECISION,     
     1 0,4,MPI_COMM_WORLD,req(4),ierr)
      CALL mpi_irecv(uold(m+1,n+1),1,MPI_DOUBLE_PRECISION,     
     1 0,5,MPI_COMM_WORLD,req(5),ierr)         
      CALL mpi_irecv(pold(m+1,n+1),1,MPI_DOUBLE_PRECISION,     
     1 0,6,MPI_COMM_WORLD,req(6),ierr)         
      endif
      if(taskid.eq.0)then
      CALL mpi_isend(v(1,1),1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,1,MPI_COMM_WORLD,req(7),ierr)                        
      CALL mpi_isend(u(1,1),1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,2,MPI_COMM_WORLD,req(8),ierr)
      CALL mpi_isend(p(1,1),1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,3,MPI_COMM_WORLD,req(9),ierr)
      CALL mpi_isend(vold(1,1),1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,4,MPI_COMM_WORLD,req(10),ierr)                        
      CALL mpi_isend(uold(1,1),1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,5,MPI_COMM_WORLD,req(11),ierr)
      CALL mpi_isend(pold(1,1),1,MPI_DOUBLE_PRECISION,      
     1   numtasks-1,6,MPI_COMM_WORLD,req(12),ierr)
      endif
      if(taskid.eq.0.or.taskid.eq.numtasks-1)then
      CALL MPI_WAITALL(12,req,istat,ierr)
      endif
      CALL f_hpmstop( 18 )
      CALL f_hpm_errchk

CME
CME      UOLD(M+1,N+1) = UOLD(1,1)
CME      VOLD(M+1,N+1) = VOLD(1,1)
CME      POLD(M+1,N+1) = POLD(1,1)
CME      U(M+1,N+1) = U(1,1)
CME      V(M+1,N+1) = V(1,1)
CME      P(M+1,N+1) = P(1,1)

C
      RETURN
      END
C---------------------- Error Check --------------------
      SUBROUTINE F_HPM_ERRCHK

      INTEGER ierr
      LOGICAL f_hpm_error
      EXTERNAL f_hpm_error

      IF ( f_hpm_error() ) THEN
         CALL MPI_Abort(MPI_COMM_WORLD, 4, ierr)
      END IF

      RETURN
      END
