/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 2008               */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
#pragma comment(copyright,"5765-543 (C) Copyright IBM Corp. 2008 @(#) 1.2 src/ppe/hpct/source/examples/mio/fbs/fbs.c, ppe.hpct, ppe_rhya, rhyas001a 08/11/04 11:40:16")
#define _LARGE_FILES

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>
#if defined(xLinux) || defined(OPTERON) || defined(pLinux)
#define LINUX
#define int64 long long
#else
#include <sys/flock.h>
#include <sys/finfo.h>
#endif

#define READ  1
#define WRITE 2
#define FORWARD  1
#define BACKWARD 2

#define ALIGN 4096

extern double rtc() ;
extern int64 FBS_str_to_long(char *) ;

#include "FBS_encode.h"

main( int argc, char **argv )
{
int fd[20] ;
int nr, bs, nwork, stride, nread, iread, nwrite, iwrite , async, iseg, nseg;
int unlink_file = 0 ;
int64 allocate, trunc, seg_start ;
char *file="file.dat";
char name[256], *data ;
float delta ;
int i, j, ipass ;
int nfd, ext ;
int npass, check_data ;
double start, finish ;
int backread = 0 ;
int status ;
int my_task=0, ntask=1 ;
int oflags ;
int skiplastclose;

   if(1)getenv("HOME");

   nr = 1 ;
   nwork=1 ;
   stride=-1 ;
   bs=4096 ;
   nfd=1;
   npass=1 ;
   nwrite=1 ;
   nread=2 ;
   async=0 ;
   ext=0 ;
   trunc = -1 ;
   allocate = -1 ;
   check_data = 1 ;
   nseg = 1 ;
   skiplastclose=0 ;

   for(i=1;i<argc;i++){
      if(strcmp(argv[i], "unlink" ) == 0){
         unlink_file=1 ;
         printf("unlink =%c\n",unlink_file?'T':'F');
         continue ;
      }
      if(strcmp(argv[i], "nounlink" ) == 0){
         unlink_file=0 ;
         printf("unlink =%c\n",unlink_file?'T':'F');
         continue ;
      }
      if(strncmp(argv[i], "file=",5 ) == 0){
         file= argv[i]+5 ;
         printf("file =%s\n",file);
         continue ;
      }
      if(strncmp(argv[i], "ext=",4 ) == 0){
         ext = (int)FBS_str_to_long(argv[i]+4);
         printf("ext =%d\n",ext);
         continue ;
      }
      if(strncmp(argv[i], "nfd=",4 ) == 0){
         nfd = (int)FBS_str_to_long(argv[i]+4);
         printf("nfd =%d\n",nfd);
         continue ;
      }
      if(strncmp(argv[i], "nr=",3 ) == 0){
         nr = (int)FBS_str_to_long(argv[i]+3);
         printf("nr =%d\n",nr);
         continue ;
      }
      if(strncmp(argv[i], "nseg=",5 ) == 0){
         nseg = (int)FBS_str_to_long(argv[i]+5);
         printf("nseg =%d\n",nseg);
         continue ;
      }
      if(strncmp(argv[i], "bs=",3 ) == 0){
         bs = (int)FBS_str_to_long(argv[i]+3);
         printf("bs =%d\n",bs);
         continue ;
      }
      if(strcmp(argv[i], "nocheck" ) == 0){
         check_data=0;
         printf("check=false\n");
         continue ;
      }
      if(strcmp(argv[i], "check" ) == 0){
         check_data=1;
         printf("check=true\n");
         continue ;
      }
      if(strcmp(argv[i], "notrunc" ) == 0){
         trunc=-1;
         printf("trunc=false\n");
         continue ;
      }
      if(strncmp(argv[i], "trunc=", 6 ) == 0){
         trunc = FBS_str_to_long(argv[i]+6);
         printf("trunc=%lld\n",trunc);
         continue ;
      }
      if(strcmp(argv[i], "skiplastclose" ) == 0){
         skiplastclose=1;
         printf("skiplastclose=true\n");
         continue ;
      }
      if(strncmp(argv[i], "allocate=", 9 ) == 0){
         allocate = FBS_str_to_long(argv[i]+9);
         printf("allocate=%lld\n",allocate);
         continue ;
      }
      if(strncmp(argv[i], "async=",6 ) == 0){
         async = (int)FBS_str_to_long(argv[i]+6);
         printf("async =%d\n",async);
         continue ;
      }
      if(strncmp(argv[i], "nread=",6 ) == 0){
         nread = (int)FBS_str_to_long(argv[i]+6);
         if(nread < 0){ backread=1 ; nread = -nread ; }
         printf("nread =%d\n",nread);
         printf("backread =%c\n",backread?'T':'F');
         continue ;
      }
      if(strncmp(argv[i], "nwrite=",7 ) == 0){
         nwrite = (int)FBS_str_to_long(argv[i]+7);
         printf("nwrite =%d\n",nwrite);
         continue ;
      }
      if(strncmp(argv[i], "nwork=",6 ) == 0){
         nwork = (int)FBS_str_to_long(argv[i]+6);
         printf("nwork =%d\n",nwork);
         continue ;
      }
      if(strncmp(argv[i], "stride=",7 ) == 0){
         stride = (int)FBS_str_to_long(argv[i]+7);
         printf("stride =%d\n",stride);
         continue ;
      }
      if(strncmp(argv[i], "itask=",6 ) == 0){
         my_task = (int)FBS_str_to_long(argv[i]+6);
         printf("itask =%d\n",my_task);
         continue ;
      }
      if(strncmp(argv[i], "ntask=",6 ) == 0){
         ntask = (int)FBS_str_to_long(argv[i]+6);
         printf("ntask =%d\n",ntask);
         continue ;
      }
      if(strncmp(argv[i], "npass=",6 ) == 0){
         npass = (int)FBS_str_to_long(argv[i]+6);
         printf("npass =%d\n",npass);
         continue ;
      }
      printf("Unknown option %s\n",argv[i]);
      goto done ;
   }
   if( stride == -1 ) stride = bs ;

   data = malloc(bs+ALIGN);
   if( data == 0 ) {
      printf("Unable to malloc %d bytes\n",bs);
      goto done;
   }

   {
      long long nx ;
      nx = (long long)data & (ALIGN-1) ;
      if(nx)data = data + ( ALIGN - nx ) ;
   }

   printf("nr      =%d\n",nr);
   printf("bs  =%d\n",bs);
   printf("nwork   =%d\n",nwork );

  oflags = nwrite ? O_RDWR | O_CREAT : O_RDONLY ;

  for(ipass=0;ipass<npass;ipass++){
     for(j=0;j<nfd;j++){
        if( nfd > 1 )
           sprintf(name,"%s.%d",file,ext+j);
        else
           sprintf(name,"%s",file);
        fd[j] = open(name, oflags , 0640 ) ;
  
   
        printf("main : fd[j]=%d\n",fd[j]);
        if( fd[j] < 0 ) {
           printf("Unable to open file %s errno=%d\n",name,errno);
           goto done;
        }
     }

/*     if( allocate > 0 ){
        int ret ;
        int64 pos=0 ;
        extern int bauerj_posix_fallocate(int, int64, int64);
        ret = bauerj_posix_fallocate( fd[0], pos, allocate);
fprintf(stderr,"%d=bauerj_posix_fallocate(%d,%lld,%lld)\n",ret,fd[0],pos,allocate);
        close(fd[0]);
        exit(0);
     }*/
  
     seg_start = 0 ;
     for(iseg=0;iseg<nseg;iseg++){
        seg_start = iseg * ( nr * bs ) ;
        if(1){
           struct flock64 flk ;
           int ret ;
           for(j=0;j<nfd;j++){
              flk.l_type   = F_UNLCK ;
              flk.l_whence = SEEK_SET ;
              flk.l_start  = 0 ;
              flk.l_len    = 0 ;
              ret = fcntl( fd[j], F_SETLK64, (int *)(&flk) ) ;
           }
        }
        for(j=0;j<nfd;j++){
           for(iwrite=0;iwrite<nwrite;iwrite++){
              do_io( j, WRITE, FORWARD , fd[j], data, nr, bs , seg_start, nwork , stride , check_data,my_task,ntask) ;
              if(0){fsync( fd[j] ) ;}
           }
        }
     
        for(j=0;j<nfd;j++){
           for(iread=0;iread<nread;iread++){
              do_io( j, READ , FORWARD , fd[j], data, nr, bs , seg_start, nwork , stride , check_data,my_task,ntask) ;
              if(backread)do_io( j, READ , BACKWARD, fd[j], data, nr, bs , seg_start, nwork , stride , check_data,my_task,ntask) ;
           }
        }
     }
  
     if(trunc >= 0){
        for(j=0;j<nfd;j++){
           ftruncate(fd[j] , trunc ) ;
        }
     }
  
     if( (!skiplastclose) || ipass!=npass ) for(j=0;j<nfd;j++) close( fd[j] ) ;
  
  } /* ipass */
  if( unlink_file ){
      int ret ;
      ret = unlink(file);
fprintf(stderr,"%d=unlink(\"%s\")\n",ret,file);
  }
done :
   return(0);
}

do_io( int fn, int rw, int fb, int fd, char *data, int nr, int bs , int64 seg_start, int nwork , int stride , int check_data, int my_task, int ntask)
{
int i ;
size_t ret ;
double start, finish ;
float delta, rate ;
off_t sret, cur_pos ;
int wr_count=0;
int record ;
int64 count ;
int64 pos ;

   pos = seg_start ;
   sret = lseek( fd, pos, SEEK_SET ) ;
   cur_pos = sret ;

   start = rtc() ;
   count = 0 ;
   for(i=0;i<nr;i++)
   {
      if( fb == BACKWARD )
         record = nr-i-1 ;
      else
         record = i ;

      if( (record%ntask) != my_task ) continue ;

      pos = seg_start + (int64)record*(int64)stride ;
      if( (ntask>1) || (cur_pos != pos) ) {
         sret = lseek( fd, pos, SEEK_SET ) ;
         cur_pos = sret ;
      }

      if(rw==WRITE){
         int j ;
         if(check_data)for(j=0;j<nwork;j++)FBS_encode_data( 'w', data, fn, bs, record, wr_count ) ;
      }

      if( rw == READ ){
         ret = read(fd, data, bs ) ;
      } else
         ret = write(fd, data, bs ) ;

      if( ret != bs ) {
         printf("Bad %s ret=%d errno=%d\n",
            (rw==READ)?"read":"write",ret, errno);
         goto done ;
      } else {
         cur_pos += ret ;
      }
      if(rw==READ){
         int j ;
         for(j=0;j<nwork;j++){
            if(check_data && !FBS_encode_data( 'r', data, fn, bs, record, wr_count ) )
            {
              close( fd ) ;
              goto done ;
            }
         }
      }
      count += ret ;
   }
   finish = rtc() ;

   delta = finish - start ;
   rate = count/delta ;

   printf("%-8s %-5s   %lld/%6.2f  %11.4e\n",
      (fb==FORWARD)?"forward":"backward",
      (rw==READ)?"read":"write",
      count,delta,rate);

   return ;
done :
   /*_remote_close( (void *)(-999) );*/
   exit(-1);

}
