c IBM_PROLOG_BEGIN_TAG 
c This is an automatically generated prolog. 
c  
c  
c  
c Licensed Materials - Property of IBM 
c  
c (C) COPYRIGHT International Business Machines Corp. 1993,2008 
c All Rights Reserved 
c  
c US Government Users Restricted Rights - Use, duplication or 
c disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
c  
c IBM_PROLOG_END_TAG 
c -------------------------------------------------------------------------
c  5765-D93 (C) COPYRIGHT IBM CORP 1993, 1999 
c  All Rights Reserved
c  Licensed Materials - Property of IBM
c  
c  US Government Users Restricted Rights - Use, duplication or disclosure
c  restricted by GSA ADP Schedule Contract with IBM Corp.
c
c  Program bw.f 
c  This program tests point-to-point bandwidth using MPI Send/Recv.
c
c -------------------------------------------------------------------------
      program  bw
      implicit none
 
      include 'mpif.h'
      integer rc
      integer  nsize
      parameter  ( nsize = 2 ** 18 )
      real*4   x(nsize), y(nsize)
      integer  numtask, rank
      integer  len, count
      real*8   t1, t2
      real*4   band
      integer  i, k, numit
      integer status(MPI_STATUS_SIZE)

c     numit is the number of messages passed
      data     numit/100/

      call MPI_INIT ( rc )
      call MPI_COMM_RANK ( MPI_COMM_WORLD, rank, rc )
      call MPI_COMM_SIZE ( MPI_COMM_WORLD, numtask, rc )

      write(6,*)'hello from task',rank

 
c  Initialize message passing parameters.

      count   =  nsize 
      len     =  4 * nsize

c  Initialize x, y arrays on task 0.
c
      if ( rank .eq. 0 ) then
         do i = 1, nsize
            x(i) = float ( i * (rank + 1) )
            y(i) = 0.0
         enddo
      endif
c
c  Initialize x, y arrays on task 1.
c
      if ( rank .eq. 1 ) then
         do i = 1, nsize
            x(i) = 0.0
            y(i) = float ( i * (rank + 1) )
         enddo
      endif
 
 
c  Synchronize before taking timings.
 
         call MPI_BARRIER ( MPI_COMM_WORLD, rc )  

c  Obtain timings

         t1 = MPI_WTIME ( )

c  Do the message pingpong numit times.

c     ~~~~~~~~~~~~~~~
      do i = 1, numit 

c
      if ( rank .eq. 0 ) then
c  Send a message to task 1 first.
      call MPI_SEND (x,count,MPI_REAL4,1,11,MPI_COMM_WORLD, rc )
c  Receive an echo message from task 1 at task 0.
      call MPI_RECV (y,count,MPI_REAL4,1,12,MPI_COMM_WORLD,status,rc)
      endif

      if ( rank .eq. 1 ) then
c  Receive a message from task 0 at task 1.
      call MPI_RECV (x,count,MPI_REAL4,0,11,MPI_COMM_WORLD,status,rc)
c  Echo a message back to task 0 by task 1.
      call MPI_SEND (y,count,MPI_REAL4,0,12,MPI_COMM_WORLD, rc )
      endif


      enddo
c     ~~~~~~~~~~~~~~~
 
         t2 = MPI_WTIME( ) 


c  Write out result.
         
         if( rank .eq. 0 ) then
           band =  2. * len * numit / ( t2 - t1 ) 
           band = band * 1.e-6
		   write(6,'(A,F11.6,A)') 
     *               'MEASURED BANDWIDTH = ',band,' *10**6 Bytes/sec'	
         endif

      call MPI_FINALIZE ( rc )
      stop
      end
