c IBM_PROLOG_BEGIN_TAG 
c This is an automatically generated prolog. 
c  
c  
c  
c Licensed Materials - Property of IBM 
c  
c (C) COPYRIGHT International Business Machines Corp. 1993,2008 
c All Rights Reserved 
c  
c US Government Users Restricted Rights - Use, duplication or 
c disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
c  
c IBM_PROLOG_END_TAG 
c -------------------------------------------------------------------------
c  5765-D93 (C) COPYRIGHT IBM CORP 1993, 1999 
c  All Rights Reserved
c  Licensed Materials - Property of IBM
c  
c  US Government Users Restricted Rights - Use, duplication or disclosure
c  restricted by GSA ADP Schedule Contract with IBM Corp.
c -------------------------------------------------------------------------
c
c program bcast.f
c This program does a brodcast by calling MPI routine MPI_Bcast..
c
c -----------------------------------------------------------------------------
      program  bcast 
      implicit  none
 
      include 'mpif.h'
      integer rc
      integer   nsize
      parameter ( nsize = 2 ** 10 )
      real*4    x(nsize), sum1, sum2
      integer   numtask, rank
      integer   count, root
      integer   i

c  Finding out parallel environment.
 
      call MPI_INIT ( rc )
      call MPI_COMM_RANK ( MPI_COMM_WORLD, rank, rc )
      call MPI_COMM_SIZE ( MPI_COMM_WORLD, numtask, rc )

c  Say hello from each task.

      write(6,*) 'Hello from task ', rank

c  Initialize array x on the source task.

      root = 0
 
      if ( rank .eq. root )  then
         do i = 1, nsize
            x(i) = 1.0 * i
         enddo
      endif

c  Initialize message passing parameters.

      count = nsize

c  Now do the broadcast.

      call MPI_BCAST ( x, count, MPI_REAL4, root, MPI_COMM_WORLD, rc )

c  Verify the results by check-sum method.

         if( rank .ne. root ) then
            sum1 = 0.0 
            sum2 = 0.0
            do i = 1, nsize
               sum1 = 1.0 * i 
               sum2 = x(i)
               if( sum1 .ne. sum2 ) then 
                 write(6,*)'BROADCAST TEST FAILED on task',rank
                 stop
               endif
            enddo
         endif


         if( rank .eq. root ) then
            write(6,*) 'BROADCAST TEST COMPLETED SUCCESSFULLY'
         endif

      call MPI_FINALIZE ( rc )
      stop
      end
