/* IBM_PROLOG_BEGIN_TAG                                                   */
/* This is an automatically generated prolog.                             */
/*                                                                        */
/*                                                                        */
/*                                                                        */
/* Licensed Materials - Property of IBM                                   */
/*                                                                        */
/* (C) COPYRIGHT International Business Machines Corp. 1994,2008          */
/* All Rights Reserved                                                    */
/*                                                                        */
/* US Government Users Restricted Rights - Use, duplication or            */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      */
/*                                                                        */
/* IBM_PROLOG_END_TAG                                                     */
#ifndef _H_MPI
#define _H_MPI
/****************************************************************************
 Name: mpi.h

 Description: C/C++ header file describing the Message Passing Interface
              implemented by the Parallel Environment

 Notes:  This file is used for both 32 bit and 64 bit applications. The 
         conditional compilation variable __64BIT__ is used to manage any
         differences that need to be explicit in mpi.h.

****************************************************************************/

/* @(#) 1.31.1.47 src/ppe/poe/include/mpi.h, ppe.poe.mpi, ppe_rhya, rhya0837c 08/09/16 10:27:01  */

#define MPI_VERSION 1
#define MPI_SUBVERSION 2

#define MPI_SUCCESS 0

enum {MPI_ERR_BUFFER=50,MPI_ERR_COUNT,MPI_ERR_TYPE,MPI_ERR_TAG,
      MPI_ERR_COMM,MPI_ERR_RANK,MPI_ERR_REQUEST,MPI_ERR_ROOT,MPI_ERR_GROUP,
      MPI_ERR_OP,MPI_ERR_TOPOLOGY,MPI_ERR_DIMS,MPI_ERR_ARG,MPI_ERR_UNKNOWN,
      MPI_ERR_TRUNCATE,MPI_ERR_OTHER,MPI_ERR_INTERN,MPI_ERR_IN_STATUS,
      MPI_ERR_PENDING,MPI_ERR_INFO_KEY,MPI_ERR_INFO_VALUE,MPI_ERR_INFO_NOKEY,
      MPI_ERR_INFO,MPI_ERR_FILE,MPI_ERR_NOT_SAME,MPI_ERR_AMODE,
      MPI_ERR_UNSUPPORTED_DATAREP,MPI_ERR_UNSUPPORTED_OPERATION,
      MPI_ERR_NO_SUCH_FILE,MPI_ERR_FILE_EXISTS,MPI_ERR_BAD_FILE,MPI_ERR_ACCESS,
      MPI_ERR_NO_SPACE,MPI_ERR_QUOTA,MPI_ERR_READ_ONLY,MPI_ERR_FILE_IN_USE,
      MPI_ERR_DUP_DATAREP,MPI_ERR_CONVERSION,MPI_ERR_IO,MPI_ERR_WIN,
      MPI_ERR_BASE,MPI_ERR_SIZE,MPI_ERR_DISP,MPI_ERR_LOCKTYPE,MPI_ERR_ASSERT,
      MPI_ERR_RMA_CONFLICT,MPI_ERR_RMA_SYNC,MPI_ERR_NO_MEM,MPI_ERR_KEYVAL};
#define MPI_ERR_LASTCODE 500
#define MPI_PENDING MPI_ERR_PENDING

#define MPI_BOTTOM ((void*) 0L)
#define MPI_ROOT -99
#define MPI_IN_PLACE ((void *) -1L)

#define MPI_STATUS_IGNORE ((MPI_Status*) -2L) 
#define MPI_STATUSES_IGNORE ((MPI_Status*) -3L) 
#define MPI_PROC_NULL -3
#define MPI_ANY_SOURCE -1
#define MPI_ANY_TAG -1
#define MPI_UNDEFINED -1

#define MPI_SOURCE source
#define MPI_TAG tag
#define MPI_ERROR error

enum { MPI_ERRORS_ARE_FATAL, MPI_ERRORS_RETURN, MPE_ERRORS_WARN };

enum { MPI_THREAD_SINGLE, MPI_THREAD_FUNNELED, MPI_THREAD_SERIALIZED, MPI_THREAD_MULTIPLE };

#define MPI_MAX_PROCESSOR_NAME 256
#define MPI_MAX_ERROR_STRING   128
#ifdef __64BIT__
#define MPI_BSEND_OVERHEAD      39
#else
#define MPI_BSEND_OVERHEAD      23
#endif
#define MPI_MAX_FILE_NAME      1023
#define MPI_MAX_DATAREP_STRING 255
#define MPI_MAX_INFO_KEY       127
#define MPI_MAX_INFO_VAL       1023
#define MPI_MAX_OBJECT_NAME    256

/* combiner values used for datatype decoding functions */
#define MPI_COMBINER_NAMED            0  /* a named predefined datatype    */
#define MPI_COMBINER_DUP              1  /* MPI_TYPE_DUP                   */
#define MPI_COMBINER_CONTIGUOUS       2  /* MPI_TYPE_CONTIGUOUS            */
#define MPI_COMBINER_VECTOR           3  /* MPI_TYPE_VECTOR                */
#define MPI_COMBINER_HVECTOR_INTEGER  4  /* MPI_TYPE_HVECTOR from Fortran  */
#define MPI_COMBINER_HVECTOR          5  /* MPI_TYPE_HVECTOR from C and    */
                                         /*   C++ and in some case Fortran */
                                         /*   or MPI_TYPE_CREATE_HVECTOR   */
#define MPI_COMBINER_INDEXED          6  /* MPI_TYPE_INDEXED               */
#define MPI_COMBINER_HINDEXED_INTEGER 7  /* MPI_TYPE_HINDEXED from Fortran */
#define MPI_COMBINER_HINDEXED         8  /* MPI_TYPE_HINDEXED from C and   */
                                         /*   C++ and in some case Fortran */
                                         /*   or MPI_TYPE_CREATE_HINDEXED  */
#define MPI_COMBINER_INDEXED_BLOCK    9  /* MPI_TYPE_CREATE_INDEXED_BLOCK  */
#define MPI_COMBINER_STRUCT_INTEGER   10 /* MPI_TYPE_STRUCT from Fortran   */
#define MPI_COMBINER_STRUCT           11 /* MPI_TYPE_STRUCT from C and     */
                                         /*   C++ and in some case Fortran */
                                         /*   or MPI_TYPE_CREATE_STRUCT    */
#define MPI_COMBINER_SUBARRAY         12 /* MPI_TYPE_CREATE_SUBARRAY       */
#define MPI_COMBINER_DARRAY           13 /* MPI_TYPE_CREATE_DARRAY         */
#define MPI_COMBINER_F90_REAL         14 /* MPI_TYPE_CREATE_F90_REAL       */
#define MPI_COMBINER_F90_COMPLEX      15 /* MPI_TYPE_CREATE_F90_COMPLEX    */
#define MPI_COMBINER_F90_INTEGER      16 /* MPI_TYPE_CREATE_F90_INTEGER    */
#define MPI_COMBINER_RESIZED          17 /* MPI_TYPE_CREATE_RESIZED        */

/* Fortran type classes */
#define MPI_TYPECLASS_REAL             1
#define MPI_TYPECLASS_INTEGER          2
#define MPI_TYPECLASS_COMPLEX          3

/* C to Fortran and Fortran to C conversion macros */
typedef int MPI_Fint;

extern MPI_Fint* MPI_F_STATUS_IGNORE;
extern MPI_Fint* MPI_F_STATUSES_IGNORE;

#define MPI_Comm_f2c(x) ((MPI_Comm)(x))
#define MPI_Type_f2c(x) ((MPI_Datatype)(x))
#define MPI_Group_f2c(x) ((MPI_Group)(x))
#define MPI_Request_f2c(x) ((MPI_Request)(x))
#define MPI_File_f2c(x) ((MPI_File)(x))
#define MPI_Win_f2c(x) ((MPI_Win)(x))
#define MPI_Op_f2c(x) ((MPI_Op)(x))
#define MPI_Info_f2c(x) ((MPI_Info)(x))
#define MPI_Errhandler_f2c(x) ((MPI_Errhandler)(x))
#define MPI_Status_f2c(x,y) ((void)memcpy((y),(x),sizeof(MPI_Status)),MPI_SUCCESS)

#define MPI_Comm_c2f(x) ((MPI_Fint)(x))
#define MPI_Type_c2f(x) ((MPI_Fint)(x))
#define MPI_Group_c2f(x) ((MPI_Fint)(x))
#define MPI_Request_c2f(x) ((MPI_Fint)(x))
#define MPI_File_c2f(x) ((MPI_Fint)(x))
#define MPI_Win_c2f(x) ((MPI_Fint)(x))
#define MPI_Op_c2f(x) ((MPI_Fint)(x))
#define MPI_Info_c2f(x) ((MPI_Fint)(x))
#define MPI_Errhandler_c2f(x) ((MPI_Fint)(x))
#define MPI_Status_c2f(x,y) ((void)memcpy((y),(x),sizeof(MPI_Status)),MPI_SUCCESS)

#define PMPI_Comm_f2c(x) ((MPI_Comm)(x))
#define PMPI_Type_f2c(x) ((MPI_Datatype)(x))
#define PMPI_Group_f2c(x) ((MPI_Group)(x))
#define PMPI_Request_f2c(x) ((MPI_Request)(x))
#define PMPI_File_f2c(x) ((MPI_File)(x))
#define PMPI_Win_f2c(x) ((MPI_Win)(x))
#define PMPI_Op_f2c(x) ((MPI_Op)(x))
#define PMPI_Info_f2c(x) ((MPI_Info)(x))
#define PMPI_Errhandler_f2c(x) ((MPI_Errhandler)(x))
#define PMPI_Status_f2c(x,y) ((void)memcpy((y),(x),sizeof(MPI_Status)),MPI_SUCCESS)

#define PMPI_Comm_c2f(x) ((MPI_Fint)(x))
#define PMPI_Type_c2f(x) ((MPI_Fint)(x))
#define PMPI_Group_c2f(x) ((MPI_Fint)(x))
#define PMPI_Request_c2f(x) ((MPI_Fint)(x))
#define PMPI_File_c2f(x) ((MPI_Fint)(x))
#define PMPI_Win_c2f(x) ((MPI_Fint)(x))
#define PMPI_Op_c2f(x) ((MPI_Fint)(x))
#define PMPI_Info_c2f(x) ((MPI_Fint)(x))         
#define PMPI_Errhandler_c2f(x) ((MPI_Fint)(x))
#define PMPI_Status_c2f(x,y) ((void)memcpy((y),(x),sizeof(MPI_Status)),MPI_SUCCESS)

/* MPI special purpose datatypes  */
#define MPI_LB                 0
#define MPI_UB                 1
#define MPI_BYTE               2
#define MPI_PACKED             3
/* MPI Predefined Datatypes for C language bindings */
#define MPI_CHAR               4
#define MPI_UNSIGNED_CHAR      5
#define MPI_SIGNED_CHAR        6
#define MPI_SHORT              7
#define MPI_INT                8
#define MPI_LONG               9
#define MPI_UNSIGNED_SHORT     10
#define MPI_UNSIGNED           11
#define MPI_UNSIGNED_LONG      12
#define MPI_FLOAT              13
#define MPI_DOUBLE             14
#define MPI_LONG_DOUBLE        15

#define MPI_LONG_LONG_INT      39
#define MPI_UNSIGNED_LONG_LONG 40
#define MPI_WCHAR              41

/* MPI Predefined Datatypes for Fortran language bindings */
#define MPI_INTEGER1           16
#define MPI_INTEGER2           17
#define MPI_INTEGER4           18
#define MPI_REAL4              19
#define MPI_REAL8              20
/* #define MPI_REAL16             21 */
#define MPI_COMPLEX8           22
#define MPI_COMPLEX16          23
/* #define MPI_COMPLEX32          24 */
#define MPI_LOGICAL1           25
#define MPI_LOGICAL2           26
#define MPI_LOGICAL4           27
#define MPI_CHARACTER          28

#define MPI_INTEGER8           42
#define MPI_LOGICAL8           43

/* MPI Predefined datatypes for reduction functions */
           /* C  Reduction Types  */
#define MPI_FLOAT_INT          29  /* {MPI_FLOAT, MPI_INT} */
#define MPI_DOUBLE_INT         30  /* {MPI_DOUBLE, MPI_INT} */
#define MPI_LONG_INT           31  /* {MPI_LONG, MPI_INT} */
#define MPI_2INT               32  /* {MPI_INT, MPI_INT} */
#define MPI_SHORT_INT          33  /* {MPI_SHORT, MPI_INT */
#define MPI_LONG_DOUBLE_INT    34  /* {MPI_LONG_DOUBLE, MPI_INT} */
           /* Fortran Reduction Types */
#define MPI_2REAL              35  /* {MPI_REAL, MPI_REAL} */
#define MPI_2DOUBLE_PRECISION  36  /* {MPI_DOUBLE_PRECISION, MPI_DOUBLE_PRECISION} */
#define MPI_2INTEGER           37  /* {MPI_INTEGER, MPI_INTEGER} */
#define MPI_2COMPLEX           38  /* {MPI_COMPLEX, MPI_COMPLEX} */

/* The following types, for MPI-2 support must have their own objects 
   and handles so there is a place to put each print name.             */

#define MPI_LONG_LONG          44
#define MPI_INTEGER            45
#define MPI_REAL               46
#define MPI_DOUBLE_PRECISION   47
#define MPI_COMPLEX            48
#define MPI_DOUBLE_COMPLEX     49
#define MPI_LOGICAL            50

enum { MPI_COMM_WORLD, MPI_COMM_SELF };

/* The order of these is mandated by the MPI standard */
enum { MPI_IDENT, MPI_CONGRUENT, MPI_SIMILAR, MPI_UNEQUAL };

enum { MPI_TAG_UB, MPI_IO, MPI_HOST, MPI_WTIME_IS_GLOBAL, MPI_WIN_BASE, MPI_WIN_SIZE,
       MPI_WIN_DISP_UNIT, MPI_LASTUSEDCODE };

enum { MPI_MAX, MPI_MIN, MPI_SUM, MPI_PROD, MPI_MAXLOC, MPI_MINLOC,
       MPI_BAND, MPI_BOR, MPI_BXOR, MPI_LAND, MPI_LOR, MPI_LXOR, MPI_REPLACE, MAX_OP };

#define MPI_HANDLE_NULL     -1
#define MPI_GROUP_NULL      MPI_HANDLE_NULL
#define MPI_COMM_NULL       MPI_HANDLE_NULL
#define MPI_DATATYPE_NULL   MPI_HANDLE_NULL
#define MPI_REQUEST_NULL    MPI_HANDLE_NULL
#define MPI_OP_NULL         MPI_HANDLE_NULL
#define MPI_ERRHANDLER_NULL MPI_HANDLE_NULL
#define MPI_KEYVAL_INVALID  MPI_HANDLE_NULL
#define MPI_INFO_NULL       MPI_HANDLE_NULL
#define MPI_FILE_NULL       MPI_HANDLE_NULL
#define MPI_WIN_NULL        MPI_HANDLE_NULL

#define MPI_GROUP_EMPTY 0

#define MPI_NON_ATOMIC              0
#define MPI_ATOMIC                  1

#define MPI_DISPLACEMENT_CURRENT    -1LL

#define MPI_DISTRIBUTE_NONE         0
#define MPI_DISTRIBUTE_BLOCK        1
#define MPI_DISTRIBUTE_CYCLIC       2
#define MPI_DISTRIBUTE_DFLT_DARG    0

#define MPI_ORDER_C                 1
#define MPI_ORDER_FORTRAN           2

#define MPI_SEEK_SET                0
#define MPI_SEEK_CUR                1
#define MPI_SEEK_END                2

#define MPI_MODE_RDONLY             0x000001
#define MPI_MODE_WRONLY             0x000002
#define MPI_MODE_RDWR               0x000004
#define MPI_MODE_CREATE             0x000008
#define MPI_MODE_APPEND             0x000010
#define MPI_MODE_EXCL               0x000020
#define MPI_MODE_DELETE_ON_CLOSE    0x000040
#define MPI_MODE_UNIQUE_OPEN        0x000080
#define MPI_MODE_SEQUENTIAL         0x000100

#define MPI_LOCK_EXCLUSIVE          0
#define MPI_LOCK_SHARED             1

#define MPI_MODE_NOCHECK            0x000200
#define MPI_MODE_NOSTORE            0x000400
#define MPI_MODE_NOPUT              0x000800
#define MPI_MODE_NOPRECEDE          0x001000
#define MPI_MODE_NOSUCCEED          0x002000

enum { MPI_GRAPH, MPI_CART };

typedef long MPI_Aint;
typedef int MPI_Handle;
typedef MPI_Handle MPI_Group;
typedef MPI_Handle MPI_Comm;
typedef MPI_Handle MPI_Datatype;
typedef MPI_Handle MPI_Request;
typedef MPI_Handle MPI_Op;
typedef MPI_Handle MPI_Errhandler; 

typedef struct {
   int source;
   int tag;
   int error;
   MPI_Aint val1;
   int val2;
   int val3;
   int val4;
   int val5;
} MPI_Status;

typedef MPI_Handle MPI_Info;
typedef MPI_Handle MPI_File;
typedef MPI_Handle MPI_Win;
typedef long long int MPI_Offset;

#if defined(__cplusplus)
   extern "C" {
#endif

typedef int MPI_Copy_function(MPI_Comm,int,void *,void *,void *,int *);
typedef int MPI_Delete_function(MPI_Comm,int,void *,void *);

typedef void MPI_Handler_function(MPI_Comm *,int *,...);

typedef void MPI_User_function(void *invec,void *inoutvec,int *len,
                               MPI_Datatype *datatype);
typedef int MPI_Comm_copy_attr_function(MPI_Comm oldcomm, int comm_keyval, void *extra_state,
              void *attribute_val_in, void *attribute_val_out, int *flag);
typedef int MPI_Comm_delete_attr_function(MPI_Comm comm, int comm_keyval, void *attribute_val,
              void *extra_state);
typedef int MPI_Win_copy_attr_function(MPI_Win oldwin, int win_keyval, void *extra_state,
              void *attribute_val_in, void *attribute_val_out, int *flag);
typedef int MPI_Win_delete_attr_function(MPI_Win win, int win_keyval, void *attribute_val,
              void *extra_state);
typedef int MPI_Type_copy_attr_function(MPI_Datatype oldwin, int win_keyval, void *extra_state,
              void *attribute_val_in, void *attribute_val_out, int *flag);
typedef int MPI_Type_delete_attr_function(MPI_Datatype win, int win_keyval, void *attribute_val,
              void *extra_state);

typedef void MPI_File_errhandler_fn(MPI_File *,int *,...);
typedef void MPI_Win_errhandler_fn(MPI_Win *,int *,...);
typedef void MPI_Comm_errhandler_fn(MPI_Comm *,int *,...);

typedef int MPI_Grequest_query_function(void *extra_state, MPI_Status *status);
typedef int MPI_Grequest_free_function(void *extra_state);
typedef int MPI_Grequest_cancel_function(void *extra_state, int complete);

typedef int MPI_Datarep_extent_function(MPI_Datatype,MPI_Aint *,void *);
typedef int MPI_Datarep_conversion_function(void *,MPI_Datatype,int,void *,
                                            MPI_Offset,void *);
#define MPI_CONVERSION_FN_NULL  0

#if defined(__cplusplus)
   }
#endif

#define MPI_NULL_COPY_FN         0
#define MPI_NULL_DELETE_FN       0
#define MPI_COMM_NULL_COPY_FN    0
#define MPI_COMM_NULL_DELETE_FN  0
#define MPI_TYPE_NULL_COPY_FN    0
#define MPI_TYPE_NULL_DELETE_FN  0
#define MPI_WIN_NULL_COPY_FN     0
#define MPI_WIN_NULL_DELETE_FN   0
MPI_Copy_function       _mpi_dup_fn;
#define MPI_DUP_FN      _mpi_dup_fn
#define MPI_COMM_DUP_FN _mpi_dup_fn
#define MPI_TYPE_DUP_FN _mpi_dup_fn
#define MPI_WIN_DUP_FN  _mpi_dup_fn

#if defined(__cplusplus)
  extern "C" {
#endif


   /* C Bindings for Point-to-Point Communication */

int MPI_Send(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
             MPI_Comm comm);
int MPI_Recv(void* buf, int count, MPI_Datatype datatype, int source, int tag,
             MPI_Comm comm, MPI_Status *status);
int MPI_Get_count(MPI_Status *status, MPI_Datatype datatype, int *count);
int MPI_Bsend(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
             MPI_Comm comm);
int MPI_Ssend(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
             MPI_Comm comm);
int MPI_Rsend(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
             MPI_Comm comm);
int MPI_Buffer_attach( void* buffer, int size);
int MPI_Buffer_detach( void* buffer, int* size);
int MPI_Isend(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
              MPI_Comm comm, MPI_Request *request);
int MPI_Ibsend(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
              MPI_Comm comm, MPI_Request *request);
int MPI_Issend(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
              MPI_Comm comm, MPI_Request *request);
int MPI_Irsend(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
              MPI_Comm comm, MPI_Request *request);
int MPI_Irecv(void* buf, int count, MPI_Datatype datatype, int source, int tag,
              MPI_Comm comm, MPI_Request *request);
int MPI_Wait(MPI_Request *request, MPI_Status *status);
int MPI_Test(MPI_Request *request, int *flag, MPI_Status *status);
int MPI_Request_free(MPI_Request *request);
int MPI_Waitany(int count, MPI_Request *array_of_requests, int *index,
              MPI_Status *status);
int MPI_Testany(int count, MPI_Request *array_of_requests, int *index, int *flag,
              MPI_Status *status);
int MPI_Waitall(int count, MPI_Request *array_of_requests,
              MPI_Status *array_of_statuses);
int MPI_Testall(int count, MPI_Request *array_of_requests, int *flag,
              MPI_Status *array_of_statuses);
int MPI_Waitsome(int incount, MPI_Request *array_of_requests, int *outcount,
              int *array_of_indices, MPI_Status *array_of_statuses);
int MPI_Testsome(int incount, MPI_Request *array_of_requests, int *outcount,
              int *array_of_indices, MPI_Status *array_of_statuses);
int MPI_Iprobe(int source, int tag, MPI_Comm comm, int *flag, MPI_Status *status);
int MPI_Probe(int source, int tag, MPI_Comm comm, MPI_Status *status);
int MPI_Cancel(MPI_Request *request);
int MPI_Test_cancelled(MPI_Status *status, int *flag);
int MPI_Send_init(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
              MPI_Comm comm, MPI_Request *request);
int MPI_Bsend_init(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
              MPI_Comm comm, MPI_Request *request);
int MPI_Ssend_init(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
              MPI_Comm comm, MPI_Request *request);
int MPI_Rsend_init(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
              MPI_Comm comm, MPI_Request *request);
int MPI_Recv_init(void* buf, int count, MPI_Datatype datatype, int source, int tag,
              MPI_Comm comm, MPI_Request *request);
int MPI_Start(MPI_Request *request);
int MPI_Startall(int count, MPI_Request *array_of_requests);
int MPI_Sendrecv(void *sendbuf, int sendcount, MPI_Datatype sendtype, int dest,
              int sendtag, void *recvbuf, int recvcount, MPI_Datatype recvtype,
              int source, int recvtag, MPI_Comm comm, MPI_Status *status);
int MPI_Sendrecv_replace(void* buf, int count, MPI_Datatype datatype, int dest,
              int sendtag, int source, int recvtag, MPI_Comm comm, MPI_Status *status);
int MPI_Type_contiguous(int count, MPI_Datatype oldtype, MPI_Datatype *newtype);
int MPI_Type_vector(int count, int blocklength, int stride, MPI_Datatype oldtype,
              MPI_Datatype *newtype);
int MPI_Type_hvector(int count, int blocklength, MPI_Aint stride, MPI_Datatype oldtype,
              MPI_Datatype *newtype);
int MPI_Type_indexed(int count, int *array_of_blocklengths, int *array_of_displacements,
              MPI_Datatype oldtype, MPI_Datatype *newtype);
int MPI_Type_hindexed(int count, int *array_of_blocklengths, MPI_Aint *array_of_displacements,
              MPI_Datatype oldtype, MPI_Datatype *newtype);
int MPI_Type_struct(int count, int *array_of_blocklengths, MPI_Aint *array_of_displacements,
              MPI_Datatype *array_of_types, MPI_Datatype *newtype);

int MPI_Type_get_envelope(MPI_Datatype datatype, int *num_integers, int *num_addresses,
              int *num_datatypes, int *combiner );
int MPI_Type_get_contents(MPI_Datatype datatype, int max_integers, int max_addresses,
              int max_datatypes, int array_of_integers[], MPI_Aint array_of_addresses[],
              MPI_Datatype array_of_datatypes[] );
int MPI_Type_create_keyval(MPI_Type_copy_attr_function *type_copy_attr_fn,
              MPI_Type_delete_attr_function *type_delete_attr_fn, int *type_keyval,
              void *extra_state);
int MPI_Type_delete_attr(MPI_Datatype type, int type_keyval);
int MPI_Type_free_keyval(int *type_keyval);
int MPI_Type_get_attr(MPI_Datatype type, int type_keyval, void *attribute_val, int *flag);
int MPI_Type_set_attr(MPI_Datatype type, int type_keyval, void *attribute_val);
int MPI_Type_dup(MPI_Datatype type, MPI_Datatype *newtype);
int MPI_Type_create_hindexed(int count, int *array_of_blocklengths,
              MPI_Aint *array_of_displacements, MPI_Datatype oldtype, MPI_Datatype *newtype);
int MPI_Type_create_hvector(int count, int blocklength, MPI_Aint stride, MPI_Datatype oldtype, 
              MPI_Datatype *newtype);
int MPI_Type_create_struct(int count, int *array_of_blocklengths, MPI_Aint *array_of_displacements,
              MPI_Datatype *array_of_types, MPI_Datatype *newtype);
int MPI_Type_get_extent(MPI_Datatype datatype, MPI_Aint *lb, MPI_Aint *extent);
int MPI_Type_create_f90_real(int p, int r, MPI_Datatype *newtype);
int MPI_Type_create_f90_complex(int p, int r, MPI_Datatype *newtype); 
int MPI_Type_create_f90_integer(int r, MPI_Datatype *newtype);
int MPI_Type_match_size(int typeclass, int size, MPI_Datatype *type);

int MPI_Address(void* location, MPI_Aint *address);
int MPI_Type_extent(MPI_Datatype datatype, MPI_Aint *extent);
int MPI_Type_size(MPI_Datatype datatype, int *size);
int MPI_Type_lb(MPI_Datatype datatype, MPI_Aint *displacement);
int MPI_Type_ub(MPI_Datatype datatype, MPI_Aint *displacement);
int MPI_Type_commit(MPI_Datatype *datatype);
int MPI_Type_free(MPI_Datatype *datatype);
int MPI_Get_elements(MPI_Status *status, MPI_Datatype datatype, int *count);
int MPI_Pack(void* inbuf, int incount, MPI_Datatype datatype, void *outbuf, int outsize,
              int *position,  MPI_Comm comm);
int MPI_Unpack(void* inbuf, int insize, int *position, void *outbuf, int outcount,
              MPI_Datatype datatype, MPI_Comm comm);
int MPI_Pack_size(int incount, MPI_Datatype datatype, MPI_Comm comm, int *size);

    /*  C Bindings for Collective Communication   */

int MPI_Barrier(MPI_Comm comm );
int MPI_Bcast(void* buffer, int count, MPI_Datatype datatype, int root, MPI_Comm comm );
int MPI_Gather(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int recvcount, MPI_Datatype recvtype, int root, MPI_Comm comm) ;
int MPI_Gatherv(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int *recvcounts, int *displs, MPI_Datatype recvtype, int root,
              MPI_Comm comm);
int MPI_Scatter(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int recvcount, MPI_Datatype recvtype, int root, MPI_Comm comm);
int MPI_Scatterv(void* sendbuf, int *sendcounts, int *displs, MPI_Datatype sendtype,
              void* recvbuf, int recvcount, MPI_Datatype recvtype, int root, MPI_Comm comm);
int MPI_Allgather(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int recvcount, MPI_Datatype recvtype, MPI_Comm comm);
int MPI_Allgatherv(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int *recvcounts, int *displs, MPI_Datatype recvtype, MPI_Comm comm);
int MPI_Alltoall(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int recvcount, MPI_Datatype recvtype, MPI_Comm comm);
int MPI_Alltoallv(void* sendbuf, int *sendcounts, int *sdispls, MPI_Datatype sendtype,
              void* recvbuf, int *recvcounts, int *rdispls, MPI_Datatype recvtype,
              MPI_Comm comm);
int MPI_Reduce(void* sendbuf, void* recvbuf, int count, MPI_Datatype datatype,
              MPI_Op op, int root, MPI_Comm comm);
int MPI_Op_create(MPI_User_function *function, int commute, MPI_Op *op);
int MPI_Op_free( MPI_Op *op);
int MPI_Allreduce(void* sendbuf, void* recvbuf, int count, MPI_Datatype datatype,
              MPI_Op op, MPI_Comm comm);
int MPI_Reduce_scatter(void* sendbuf, void* recvbuf, int *recvcounts,
              MPI_Datatype datatype, MPI_Op op, MPI_Comm comm);
int MPI_Scan(void* sendbuf, void* recvbuf, int count, MPI_Datatype datatype,
              MPI_Op op, MPI_Comm comm );
int MPI_Alltoallw(void* sendbuf, int *sendcounts, int *sdispls, MPI_Datatype *sendtypes, 
              void* recvbuf, int *recvcounts, int *rdispls, MPI_Datatype *recvtypes, 
              MPI_Comm comm);
int MPI_Exscan(void* sendbuf, void* recvbuf, int count, MPI_Datatype datatype, MPI_Op op, 
              MPI_Comm comm);
    /* C  Bindings for Groups, Contexts, and Communicators  */

int MPI_Group_size(MPI_Group group, int *size);
int MPI_Group_rank(MPI_Group group, int *rank);
int MPI_Group_translate_ranks (MPI_Group group1, int n, int *ranks1,
              MPI_Group group2, int *ranks2);
int MPI_Group_compare(MPI_Group group1,MPI_Group group2, int *result);
int MPI_Comm_group(MPI_Comm comm, MPI_Group *group);
int MPI_Group_union(MPI_Group group1, MPI_Group group2, MPI_Group *newgroup);
int MPI_Group_intersection(MPI_Group group1, MPI_Group group2, MPI_Group *newgroup);
int MPI_Group_difference(MPI_Group group1, MPI_Group group2, MPI_Group *newgroup);
int MPI_Group_incl(MPI_Group group, int n, int *ranks, MPI_Group *newgroup);
int MPI_Group_excl(MPI_Group group, int n, int *ranks, MPI_Group *newgroup);
int MPI_Group_range_incl(MPI_Group group, int n, int ranges[][3], MPI_Group *newgroup);
int MPI_Group_range_excl(MPI_Group group, int n, int ranges[][3], MPI_Group *newgroup);
int MPI_Group_free(MPI_Group *group);
int MPI_Comm_size(MPI_Comm comm, int *size);
int MPI_Comm_rank(MPI_Comm comm, int *rank);
int MPI_Comm_compare(MPI_Comm comm1, MPI_Comm comm2, int *result);
int MPI_Comm_dup(MPI_Comm comm, MPI_Comm *newcomm);
int MPI_Comm_create(MPI_Comm comm, MPI_Group group, MPI_Comm *newcomm);
int MPI_Comm_split(MPI_Comm comm, int color, int key, MPI_Comm *newcomm);
int MPI_Comm_free(MPI_Comm *comm);
int MPI_Comm_test_inter(MPI_Comm comm, int *flag);
int MPI_Comm_remote_size(MPI_Comm comm, int *size);
int MPI_Comm_remote_group(MPI_Comm comm, MPI_Group *group);
int MPI_Intercomm_create(MPI_Comm local_comm, int local_leader, MPI_Comm peer_comm,
              int remote_leader, int tag, MPI_Comm *newintercomm);
int MPI_Intercomm_merge(MPI_Comm intercomm, int high, MPI_Comm *newintracomm);
int MPI_Keyval_create(MPI_Copy_function *copy_fn, MPI_Delete_function *delete_fn,
              int *keyval, void* extra_state);
int MPI_Keyval_free(int *keyval);
int MPI_Attr_put(MPI_Comm comm, int keyval, void *attribute_val);
int MPI_Attr_get(MPI_Comm comm, int keyval, void *attribute_val, int *flag);
int MPI_Attr_delete(MPI_Comm comm, int keyval);
int MPI_Comm_create_errhandler(MPI_Comm_errhandler_fn *function, MPI_Errhandler *errhandler);
int MPI_Comm_get_errhandler(MPI_Comm comm, MPI_Errhandler *errhandler);
int MPI_Comm_set_errhandler(MPI_Comm comm, MPI_Errhandler errhandler);
int MPI_Comm_create_keyval(MPI_Comm_copy_attr_function *comm_copy_attr_fn,
              MPI_Comm_delete_attr_function *comm_delete_attr_fn, int *comm_keyval,
              void *extra_state);
int MPI_Comm_delete_attr(MPI_Comm comm, int comm_keyval);
int MPI_Comm_free_keyval(int *comm_keyval);
int MPI_Comm_get_attr(MPI_Comm comm, int comm_keyval, void *attribute_val, int *flag);
int MPI_Comm_set_attr(MPI_Comm comm, int comm_keyval, void *attribute_val);


   /*   C Bindings for Process Topologies   */

int MPI_Cart_create(MPI_Comm comm_old, int ndims, int *dims, int *periods,
              int reorder, MPI_Comm *comm_cart);
int MPI_Dims_create(int nnodes, int ndims, int *dims);
int MPI_Graph_create(MPI_Comm comm_old, int nnodes, int *index, int *edges,
              int reorder, MPI_Comm *comm_graph);
int MPI_Topo_test(MPI_Comm comm, int *status);
int MPI_Graphdims_get(MPI_Comm comm, int *nnodes, int *nedges);
int MPI_Graph_get(MPI_Comm comm, int maxindex, int maxedges, int *index, int *edges);
int MPI_Cartdim_get(MPI_Comm comm, int *ndims);
int MPI_Cart_get(MPI_Comm comm, int maxdims, int *dims, int *periods, int *coords);
int MPI_Cart_rank(MPI_Comm comm, int *coords, int *rank);
int MPI_Cart_coords(MPI_Comm comm, int rank, int maxdims, int *coords);
int MPI_Graph_neighbors_count(MPI_Comm comm, int rank, int *nneighbors);
int MPI_Graph_neighbors(MPI_Comm comm, int rank, int maxneighbors, int *neighbors);
int MPI_Cart_shift(MPI_Comm comm, int direction, int disp, int *rank_source, int *rank_dest);
int MPI_Cart_sub(MPI_Comm comm, int *remain_dims, MPI_Comm *newcomm);
int MPI_Cart_map(MPI_Comm comm, int ndims, int *dims, int *periods, int *newrank);
int MPI_Graph_map(MPI_Comm comm, int nnodes, int *index, int *edges, int *newrank);


  /*    C bindings for Environmental Inquiry   */

int MPI_Get_version(int *version, int *subversion);
int MPI_Get_processor_name(char *name, int *resultlen);
int MPI_Errhandler_create(MPI_Handler_function *function, MPI_Errhandler *errhandler);
int MPI_Errhandler_set(MPI_Comm comm, MPI_Errhandler errhandler);
int MPI_Errhandler_get(MPI_Comm comm, MPI_Errhandler *errhandler);
int MPI_Errhandler_free(MPI_Errhandler *errhandler);
int MPI_Error_string(int errorcode, char *string, int *resultlen);
int MPI_Error_class(int errorcode, int *errorclass);
double MPI_Wtime(void);
double MPI_Wtick(void);
int MPI_Init(int *argc, char ***argv);
int MPI_Finalize(void);
int MPI_Initialized(int *flag);
int MPI_Abort(MPI_Comm comm, int errorcode);


  /*    C Bindings for Profiling  */

int MPI_Pcontrol(const int level,...);

    /*  C Bindings for Non-Blocking Collective Communication   */

int MPE_Ibarrier(MPI_Comm comm,MPI_Request *request);
int MPE_Ibcast(void* buffer, int count, MPI_Datatype datatype, int root, MPI_Comm comm,
              MPI_Request *request);
int MPE_Igather(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int recvcount, MPI_Datatype recvtype, int root, MPI_Comm comm,MPI_Request *request);
int MPE_Igatherv(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int *recvcounts, int *displs, MPI_Datatype recvtype, int root,
              MPI_Comm comm,MPI_Request *request);
int MPE_Iscatter(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int recvcount, MPI_Datatype recvtype, int root, MPI_Comm comm,MPI_Request *request);
int MPE_Iscatterv(void* sendbuf, int *sendcounts, int *displs, MPI_Datatype sendtype,
              void* recvbuf, int recvcount, MPI_Datatype recvtype, int root, MPI_Comm comm,
              MPI_Request *request);
int MPE_Iallgather(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int recvcount, MPI_Datatype recvtype, MPI_Comm comm,MPI_Request *request);
int MPE_Iallgatherv(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int *recvcounts, int *displs, MPI_Datatype recvtype, MPI_Comm comm,
              MPI_Request *request);
int MPE_Ialltoall(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int recvcount, MPI_Datatype recvtype, MPI_Comm comm,MPI_Request *request);
int MPE_Ialltoallv(void* sendbuf, int *sendcounts, int *sdispls, MPI_Datatype sendtype,
              void* recvbuf, int *recvcounts, int *rdispls, MPI_Datatype recvtype,
              MPI_Comm comm,MPI_Request *request);
int MPE_Ireduce(void* sendbuf, void* recvbuf, int count, MPI_Datatype datatype,
              MPI_Op op, int root, MPI_Comm comm,MPI_Request *request);
int MPE_Iallreduce(void* sendbuf, void* recvbuf, int count, MPI_Datatype datatype,
              MPI_Op op, MPI_Comm comm,MPI_Request *request);
int MPE_Ireduce_scatter(void* sendbuf, void* recvbuf, int *recvcounts,
              MPI_Datatype datatype, MPI_Op op, MPI_Comm comm,MPI_Request *request);
int MPE_Iscan(void* sendbuf, void* recvbuf, int count, MPI_Datatype datatype,
              MPI_Op op, MPI_Comm comm ,MPI_Request *request);

    /*  C Bindings for MPI 1-sided */

int MPI_Win_create(void *base, MPI_Aint size, int disp_unit,
                    MPI_Info info, MPI_Comm comm, MPI_Win *win);
int MPI_Win_free(MPI_Win *win);
int MPI_Win_get_group(MPI_Win win, MPI_Group *group);
int MPI_Put(void *origin_addr, int origin_count, MPI_Datatype origin_datatype,
            int target_rank, MPI_Aint target_disp, int target_count,
            MPI_Datatype target_datatype, MPI_Win win);
int MPI_Get(void *origin_addr, int origin_count, MPI_Datatype origin_datatype,
            int target_rank, MPI_Aint target_disp, int target_count,
            MPI_Datatype target_datatype, MPI_Win win);
int MPI_Accumulate(void *origin_addr, int origin_count, MPI_Datatype
                   origin_datatype, int target_rank, MPI_Aint target_disp,
                   int target_count, MPI_Datatype target_datatype,
                   MPI_Op op, MPI_Win win);
int MPI_Win_fence(int assert, MPI_Win win);
int MPI_Win_start(MPI_Group group, int assert, MPI_Win win);
int MPI_Win_complete(MPI_Win win);
int MPI_Win_post(MPI_Group group, int assert, MPI_Win win);
int MPI_Win_wait(MPI_Win win);
int MPI_Win_test(MPI_Win win, int *flag);
int MPI_Win_lock(int lock_type, int rank, int assert, MPI_Win win);
int MPI_Win_unlock(int rank, MPI_Win win);
int MPI_Win_get_attr(MPI_Win win, int win_keyval, void *attribute_val,
                       int *flag);
int MPI_Win_set_attr(MPI_Win win, int win_keyval, void *attribute_val);
int MPI_Win_create_keyval(MPI_Win_copy_attr_function *win_copy_attr_fn,
              MPI_Win_delete_attr_function *win_delete_attr_fn, int *win_keyval,
              void *extra_state);
int MPI_Win_delete_attr(MPI_Win win, int win_keyval);
int MPI_Win_free_keyval(int *win_keyval);
int MPI_Win_create_errhandler(MPI_Win_errhandler_fn *function, MPI_Errhandler *errhandler);
int MPI_Win_set_errhandler(MPI_Win win, MPI_Errhandler err);
int MPI_Win_get_errhandler(MPI_Win win, MPI_Errhandler *errhandler);

int MPI_Alloc_mem(MPI_Aint size, MPI_Info info, void *baseptr);
int MPI_Free_mem(void *base);

    /*  C Bindings for I/O  */

int MPI_File_open(MPI_Comm comm,char *filename,int amode,MPI_Info info,
                  MPI_File *fh);
int MPI_File_close(MPI_File *fh);
int MPI_File_delete(char *filename,MPI_Info info);
int MPI_File_set_size(MPI_File fh,MPI_Offset size);
int MPI_File_get_size(MPI_File fh,MPI_Offset *size);
int MPI_File_get_group(MPI_File fh,MPI_Group *group);
int MPI_File_get_amode(MPI_File fh,int *amode);
int MPI_File_set_info(MPI_File fh,MPI_Info info);
int MPI_File_get_info(MPI_File fh,MPI_Info *info_used);
int MPI_File_set_view(MPI_File fh,MPI_Offset disp,MPI_Datatype etype,
                      MPI_Datatype filetype,char *datarep,MPI_Info info);
int MPI_File_get_view(MPI_File fh,MPI_Offset *disp,MPI_Datatype *etype,
                      MPI_Datatype *filetype,char *datarep);
int MPI_File_read_at(MPI_File fh,MPI_Offset offset,void *buf,int count,
                     MPI_Datatype datatype,MPI_Status *status);
int MPI_File_read_at_all(MPI_File fh,MPI_Offset offset,void *buf,int count,
                         MPI_Datatype datatype,MPI_Status *status);
int MPI_File_write_at(MPI_File fh,MPI_Offset offset,void *buf,int count,
                      MPI_Datatype datatype,MPI_Status *status);
int MPI_File_write_at_all(MPI_File fh,MPI_Offset offset,void *buf,int count,
                          MPI_Datatype datatype,MPI_Status *status);
int MPI_File_iread_at(MPI_File fh,MPI_Offset offset,void *buf,int count,
                      MPI_Datatype datatype,MPI_Request *request);
int MPI_File_iwrite_at(MPI_File fh,MPI_Offset offset,void *buf,int count,
                       MPI_Datatype datatype,MPI_Request *request);
int MPI_File_get_atomicity(MPI_File fh,int *flag);
int MPI_File_sync(MPI_File fh);
int MPI_Type_create_subarray(int ndims,int array_of_sizes[],
                             int array_of_subsizes[],int array_of_starts[],
                             int order,MPI_Datatype oldtype,
                             MPI_Datatype *newtype);
int MPI_Type_create_darray(int size,int rank,int ndims,int array_of_gsizes[],
                           int array_of_distribs[],int array_of_dargs[],
                           int array_of_psizes[],int order,MPI_Datatype oldtype,
                           MPI_Datatype *newtype);
int MPI_File_create_errhandler(MPI_File_errhandler_fn *function,
                               MPI_Errhandler *errhandler);
int MPI_File_set_errhandler(MPI_File fh,MPI_Errhandler errhandler);
int MPI_File_get_errhandler(MPI_File fh,MPI_Errhandler *errhandler);
int MPI_File_create_errhandler(MPI_File_errhandler_fn *function, MPI_Errhandler *errhandler);
int MPI_File_get_byte_offset(MPI_File fh, MPI_Offset offset, MPI_Offset *disp);
int MPI_File_get_info(MPI_File fh, MPI_Info *info_used);
int MPI_File_get_position(MPI_File fh, MPI_Offset *offset);
int MPI_File_get_position_shared(MPI_File fh, MPI_Offset *offset);
int MPI_File_get_type_extent(MPI_File fh, MPI_Datatype datatype, MPI_Aint *extent);
int MPI_File_iread(MPI_File fh, void *buf, int count, MPI_Datatype datatype, MPI_Request *request);
int MPI_File_iread_shared(MPI_File fh, void *buf, int count, MPI_Datatype datatype,
             MPI_Request *request);
int MPI_File_iwrite(MPI_File fh, void *buf, int count, MPI_Datatype datatype, 
             MPI_Request *request);
int MPI_File_iwrite_shared(MPI_File fh, void *buf, int count, MPI_Datatype datatype,
             MPI_Request *request);
int MPI_File_preallocate(MPI_File fh, MPI_Offset size);
int MPI_File_read(MPI_File fh, void *buf, int count, MPI_Datatype datatype, MPI_Status *status);
int MPI_File_read_all(MPI_File fh, void *buf, int count, MPI_Datatype datatype, MPI_Status *status);
int MPI_File_read_all_begin(MPI_File fh, void *buf, int count, MPI_Datatype datatype);
int MPI_File_read_all_end(MPI_File fh, void *buf, MPI_Status *status);
int MPI_File_read_at_all_begin(MPI_File fh, MPI_Offset offset, void *buf, int count,
             MPI_Datatype datatype);
int MPI_File_read_at_all_end(MPI_File fh, void *buf, MPI_Status *status);
int MPI_File_read_ordered(MPI_File fh, void *buf, int count, MPI_Datatype datatype,
             MPI_Status *status);
int MPI_File_read_ordered_begin(MPI_File fh, void *buf, int count, MPI_Datatype datatype);
int MPI_File_read_ordered_end(MPI_File fh, void *buf, MPI_Status *status);
int MPI_File_read_shared(MPI_File fh, void *buf, int count, MPI_Datatype datatype,
             MPI_Status *status);
int MPI_File_seek(MPI_File fh, MPI_Offset offset, int whence);
int MPI_File_seek_shared(MPI_File fh, MPI_Offset offset, int whence);
int MPI_File_set_atomicity(MPI_File fh, int flag);
int MPI_File_set_info(MPI_File fh, MPI_Info info);
int MPI_File_write(MPI_File fh, void *buf, int count, MPI_Datatype datatype, MPI_Status *status);
int MPI_File_write_all(MPI_File fh, void *buf, int count, MPI_Datatype datatype,
             MPI_Status *status);
int MPI_File_write_all_begin(MPI_File fh, void *buf, int count, MPI_Datatype datatype);
int MPI_File_write_all_end(MPI_File fh, void *buf, MPI_Status *status);
int MPI_File_write_at_all_begin(MPI_File fh, MPI_Offset offset, void *buf, int count,
             MPI_Datatype datatype);
int MPI_File_write_at_all_end(MPI_File fh, void *buf, MPI_Status *status);
int MPI_File_write_ordered(MPI_File fh, void *buf, int count, MPI_Datatype datatype,
             MPI_Status *status);
int MPI_File_write_ordered_begin(MPI_File fh, void *buf, int count, MPI_Datatype datatype);
int MPI_File_write_ordered_end(MPI_File fh, void *buf, MPI_Status *status);
int MPI_File_write_shared(MPI_File fh, void *buf, int count, MPI_Datatype datatype,
             MPI_Status *status);
int MPI_Register_datarep(char *datarep, MPI_Datarep_conversion_function *read_conversion_fn,
             MPI_Datarep_conversion_function *write_conversion_fn,
             MPI_Datarep_extent_function *dtype_file_extent_fn, void *extra_state);
int MPI_Info_create(MPI_Info *info);
int MPI_Info_set(MPI_Info Info,char *key,char *value);
int MPI_Info_delete(MPI_Info info,char *key);
int MPI_Info_get(MPI_Info info,char *key,int valuelen,char *value,int *flag);
int MPI_Info_get_valuelen(MPI_Info info,char *key,int *valuelen,int *flag);
int MPI_Info_get_nkeys(MPI_Info info,int *nkeys);
int MPI_Info_get_nthkey(MPI_Info info,int n,char *key);
int MPI_Info_dup(MPI_Info info, MPI_Info *newinfo);
int MPI_Info_free(MPI_Info *info);

    /* C-bindings for External Interfaces */
int MPI_Add_error_class(int *errorclass);
int MPI_Add_error_code(int errorclass, int *errorcode);
int MPI_Add_error_string(int errorcode, char *string);
int MPI_Comm_call_errhandler(MPI_Comm comm, int errorcode);
int MPI_Comm_set_name(MPI_Comm comm, char *comm_name);
int MPI_Comm_get_name(MPI_Comm comm, char *comm_name, int *resultlen);
int MPI_File_call_errhandler(MPI_File fh, int errorcode);
int MPI_Type_set_name(MPI_Datatype type, char *type_name);
int MPI_Type_get_name(MPI_Datatype type, char *type_name, int *resultlen);
int MPI_Win_call_errhandler(MPI_Win win, int errorcode);
int MPI_Win_set_name(MPI_Win win, char *win_name);
int MPI_Win_get_name(MPI_Win win, char *win_name, int *resultlen);

int MPI_Init_thread(int *argc, char ***argv, int required, int *provided);
int MPI_Query_thread(int *provided);
int MPI_Is_thread_main(int *flag);
int MPI_Grequest_start(MPI_Grequest_query_function *grequest_query_fn, 
              MPI_Grequest_free_function *grequest_free_fn, 
              MPI_Grequest_cancel_function *grequest_cancel_fn, 
              void *extra_state, MPI_Request *request);
int MPI_Grequest_complete(MPI_Request request);
int MPI_Status_set_elements(MPI_Status *status, MPI_Datatype datatype, int count);
int MPI_Status_set_cancelled(MPI_Status *status, int flag);

    /* C-bindings for Miscellany */

int MPI_Finalized(int *flag);
int MPI_Type_create_indexed_block(int count, int blocklength, int *array_of_displacements,
     MPI_Datatype oldtype, MPI_Datatype *newtype);
int MPI_Request_get_status(MPI_Request request, int *flag, MPI_Status *status);
int MPI_Get_address(void *location, MPI_Aint *address);
int MPI_Type_create_resized(MPI_Datatype oldtype, MPI_Aint lb, MPI_Aint extent,
             MPI_Datatype *newtype);
int MPI_Type_get_true_extent(MPI_Datatype datatype, MPI_Aint *true_lb, MPI_Aint *true_extent);
int MPI_Pack_external(char *datarep, void *inbuf, int incount, MPI_Datatype datatype,
             void *outbuf, MPI_Aint outsize, MPI_Aint *position);
int MPI_Unpack_external(char *datarep, void *inbuf, MPI_Aint insize, MPI_Aint *position,
             void *outbuf, int outcount, MPI_Datatype datatype);
int MPI_Pack_external_size(char *datarep, int incount, MPI_Datatype datatype, MPI_Aint *size);


/****************************************************************************
 ****************  Profiling (PMPI) Entry Points for C  *********************
 ****************************************************************************/

   /* C Bindings for Point-to-Point Communication */

int PMPI_Send(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
             MPI_Comm comm);
int PMPI_Recv(void* buf, int count, MPI_Datatype datatype, int source, int tag,
             MPI_Comm comm, MPI_Status *status);
int PMPI_Get_count(MPI_Status *status, MPI_Datatype datatype, int *count);
int PMPI_Bsend(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
             MPI_Comm comm);
int PMPI_Ssend(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
             MPI_Comm comm);
int PMPI_Rsend(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
             MPI_Comm comm);
int PMPI_Buffer_attach( void* buffer, int size);
int PMPI_Buffer_detach( void* buffer, int* size);
int PMPI_Isend(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
              MPI_Comm comm, MPI_Request *request);
int PMPI_Ibsend(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
              MPI_Comm comm, MPI_Request *request);
int PMPI_Issend(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
              MPI_Comm comm, MPI_Request *request);
int PMPI_Irsend(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
              MPI_Comm comm, MPI_Request *request);
int PMPI_Irecv(void* buf, int count, MPI_Datatype datatype, int source, int tag,
              MPI_Comm comm, MPI_Request *request);
int PMPI_Wait(MPI_Request *request, MPI_Status *status);
int PMPI_Test(MPI_Request *request, int *flag, MPI_Status *status);
int PMPI_Request_free(MPI_Request *request);
int PMPI_Waitany(int count, MPI_Request *array_of_requests, int *index,
              MPI_Status *status);
int PMPI_Testany(int count, MPI_Request *array_of_requests, int *index, int *flag,
              MPI_Status *status);
int PMPI_Waitall(int count, MPI_Request *array_of_requests,
              MPI_Status *array_of_statuses);
int PMPI_Testall(int count, MPI_Request *array_of_requests, int *flag,
              MPI_Status *array_of_statuses);
int PMPI_Waitsome(int incount, MPI_Request *array_of_requests, int *outcount,
              int *array_of_indices, MPI_Status *array_of_statuses);
int PMPI_Testsome(int incount, MPI_Request *array_of_requests, int *outcount,
              int *array_of_indices, MPI_Status *array_of_statuses);
int PMPI_Iprobe(int source, int tag, MPI_Comm comm, int *flag, MPI_Status *status);
int PMPI_Probe(int source, int tag, MPI_Comm comm, MPI_Status *status);
int PMPI_Cancel(MPI_Request *request);
int PMPI_Test_cancelled(MPI_Status *status, int *flag);
int PMPI_Send_init(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
              MPI_Comm comm, MPI_Request *request);
int PMPI_Bsend_init(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
              MPI_Comm comm, MPI_Request *request);
int PMPI_Ssend_init(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
              MPI_Comm comm, MPI_Request *request);
int PMPI_Rsend_init(void* buf, int count, MPI_Datatype datatype, int dest, int tag,
              MPI_Comm comm, MPI_Request *request);
int PMPI_Recv_init(void* buf, int count, MPI_Datatype datatype, int source, int tag,
              MPI_Comm comm, MPI_Request *request);
int PMPI_Start(MPI_Request *request);
int PMPI_Startall(int count, MPI_Request *array_of_requests);
int PMPI_Sendrecv(void *sendbuf, int sendcount, MPI_Datatype sendtype, int dest,
              int sendtag, void *recvbuf, int recvcount, MPI_Datatype recvtype,
              int source, int recvtag, MPI_Comm comm, MPI_Status *status);
int PMPI_Sendrecv_replace(void* buf, int count, MPI_Datatype datatype, int dest,
              int sendtag, int source, int recvtag, MPI_Comm comm, MPI_Status *status);
int PMPI_Type_contiguous(int count, MPI_Datatype oldtype, MPI_Datatype *newtype);
int PMPI_Type_vector(int count, int blocklength, int stride, MPI_Datatype oldtype,
              MPI_Datatype *newtype);
int PMPI_Type_hvector(int count, int blocklength, MPI_Aint stride, MPI_Datatype oldtype,
              MPI_Datatype *newtype);
int PMPI_Type_indexed(int count, int *array_of_blocklengths, int *array_of_displacements,
              MPI_Datatype oldtype, MPI_Datatype *newtype);
int PMPI_Type_hindexed(int count, int *array_of_blocklengths, MPI_Aint *array_of_displacements,
              MPI_Datatype oldtype, MPI_Datatype *newtype);
int PMPI_Type_struct(int count, int *array_of_blocklengths, MPI_Aint *array_of_displacements,
              MPI_Datatype *array_of_types, MPI_Datatype *newtype);

int PMPI_Type_get_envelope(MPI_Datatype datatype, int *num_integers, int *num_addresses,
             int *num_datatypes, int *combiner );
int PMPI_Type_get_contents(MPI_Datatype datatype, int max_integers, int max_addresses,
             int max_datatypes, int array_of_integers[], MPI_Aint array_of_addresses[],
             MPI_Datatype array_of_datatypes[] );
int PMPI_Type_create_keyval(MPI_Type_copy_attr_function *type_copy_attr_fn,
             MPI_Type_delete_attr_function *type_delete_attr_fn, int *type_keyval,
             void *extra_state);
int PMPI_Type_delete_attr(MPI_Datatype type, int type_keyval);
int PMPI_Type_free_keyval(int *type_keyval);
int PMPI_Type_get_attr(MPI_Datatype type, int type_keyval, void *attribute_val, int *flag);
int PMPI_Type_set_attr(MPI_Datatype type, int type_keyval, void *attribute_val);
int PMPI_Type_dup(MPI_Datatype type, MPI_Datatype *newtype);
int PMPI_Type_create_hindexed(int count, int *array_of_blocklengths,
              MPI_Aint *array_of_displacements, MPI_Datatype oldtype, MPI_Datatype *newtype);
int PMPI_Type_create_hvector(int count, int blocklength, MPI_Aint stride,
              MPI_Datatype oldtype, MPI_Datatype *newtype);
int PMPI_Type_create_struct(int count, int *array_of_blocklengths, 
              MPI_Aint *array_of_displacements,
              MPI_Datatype *array_of_types, MPI_Datatype *newtype);
int PMPI_Type_get_extent(MPI_Datatype datatype, MPI_Aint *lb, MPI_Aint *extent);
int PMPI_Type_create_f90_real(int p, int r, MPI_Datatype *newtype);
int PMPI_Type_create_f90_complex(int p, int r, MPI_Datatype *newtype); 
int PMPI_Type_create_f90_integer(int r, MPI_Datatype *newtype);
int PMPI_Type_match_size(int typeclass, int size, MPI_Datatype *type);

int PMPI_Address(void* location, MPI_Aint *address);
int PMPI_Type_extent(MPI_Datatype datatype, MPI_Aint *extent);
int PMPI_Type_size(MPI_Datatype datatype, int *size);
int PMPI_Type_lb(MPI_Datatype datatype, MPI_Aint *displacement);
int PMPI_Type_ub(MPI_Datatype datatype, MPI_Aint *displacement);
int PMPI_Type_commit(MPI_Datatype *datatype);
int PMPI_Type_free(MPI_Datatype *datatype);
int PMPI_Get_elements(MPI_Status *status, MPI_Datatype datatype, int *count);
int PMPI_Pack(void* inbuf, int incount, MPI_Datatype datatype, void *outbuf, int outsize,
              int *position,  MPI_Comm comm);
int PMPI_Unpack(void* inbuf, int insize, int *position, void *outbuf, int outcount,
              MPI_Datatype datatype, MPI_Comm comm);
int PMPI_Pack_size(int incount, MPI_Datatype datatype, MPI_Comm comm, int *size);

    /*  C Bindings for Collective Communication   */

int PMPI_Barrier(MPI_Comm comm );
int PMPI_Bcast(void* buffer, int count, MPI_Datatype datatype, int root, MPI_Comm comm );
int PMPI_Gather(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int recvcount, MPI_Datatype recvtype, int root, MPI_Comm comm) ;
int PMPI_Gatherv(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int *recvcounts, int *displs, MPI_Datatype recvtype, int root,
              MPI_Comm comm);
int PMPI_Scatter(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int recvcount, MPI_Datatype recvtype, int root, MPI_Comm comm);
int PMPI_Scatterv(void* sendbuf, int *sendcounts, int *displs, MPI_Datatype sendtype,
              void* recvbuf, int recvcount, MPI_Datatype recvtype, int root, MPI_Comm comm);
int PMPI_Allgather(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int recvcount, MPI_Datatype recvtype, MPI_Comm comm);
int PMPI_Allgatherv(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int *recvcounts, int *displs, MPI_Datatype recvtype, MPI_Comm comm);
int PMPI_Alltoall(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int recvcount, MPI_Datatype recvtype, MPI_Comm comm);
int PMPI_Alltoallv(void* sendbuf, int *sendcounts, int *sdispls, MPI_Datatype sendtype,
              void* recvbuf, int *recvcounts, int *rdispls, MPI_Datatype recvtype,
              MPI_Comm comm);
int PMPI_Reduce(void* sendbuf, void* recvbuf, int count, MPI_Datatype datatype,
              MPI_Op op, int root, MPI_Comm comm);
int PMPI_Op_create(MPI_User_function *function, int commute, MPI_Op *op);
int PMPI_Op_free( MPI_Op *op);
int PMPI_Allreduce(void* sendbuf, void* recvbuf, int count, MPI_Datatype datatype,
              MPI_Op op, MPI_Comm comm);
int PMPI_Reduce_scatter(void* sendbuf, void* recvbuf, int *recvcounts,
              MPI_Datatype datatype, MPI_Op op, MPI_Comm comm);
int PMPI_Scan(void* sendbuf, void* recvbuf, int count, MPI_Datatype datatype,
              MPI_Op op, MPI_Comm comm );
int PMPI_Alltoallw(void* sendbuf, int *sendcounts, int *sdispls, MPI_Datatype *sendtypes, 
              void* recvbuf, int *recvcounts, int *rdispls, MPI_Datatype *recvtypes, 
              MPI_Comm comm);
int PMPI_Exscan(void* sendbuf, void* recvbuf, int count, MPI_Datatype datatype, 
              MPI_Op op, MPI_Comm comm);

    /* C  Bindings for Groups, Contexts, and Communicators  */

int PMPI_Group_size(MPI_Group group, int *size);
int PMPI_Group_rank(MPI_Group group, int *rank);
int PMPI_Group_translate_ranks (MPI_Group group1, int n, int *ranks1,
              MPI_Group group2, int *ranks2);
int PMPI_Group_compare(MPI_Group group1,MPI_Group group2, int *result);
int PMPI_Comm_group(MPI_Comm comm, MPI_Group *group);
int PMPI_Group_union(MPI_Group group1, MPI_Group group2, MPI_Group *newgroup);
int PMPI_Group_intersection(MPI_Group group1, MPI_Group group2, MPI_Group *newgroup);
int PMPI_Group_difference(MPI_Group group1, MPI_Group group2, MPI_Group *newgroup);
int PMPI_Group_incl(MPI_Group group, int n, int *ranks, MPI_Group *newgroup);
int PMPI_Group_excl(MPI_Group group, int n, int *ranks, MPI_Group *newgroup);
int PMPI_Group_range_incl(MPI_Group group, int n, int ranges[][3], MPI_Group *newgroup);
int PMPI_Group_range_excl(MPI_Group group, int n, int ranges[][3], MPI_Group *newgroup);
int PMPI_Group_free(MPI_Group *group);
int PMPI_Comm_size(MPI_Comm comm, int *size);
int PMPI_Comm_rank(MPI_Comm comm, int *rank);
int PMPI_Comm_compare(MPI_Comm comm1, MPI_Comm comm2, int *result);
int PMPI_Comm_dup(MPI_Comm comm, MPI_Comm *newcomm);
int PMPI_Comm_create(MPI_Comm comm, MPI_Group group, MPI_Comm *newcomm);
int PMPI_Comm_split(MPI_Comm comm, int color, int key, MPI_Comm *newcomm);
int PMPI_Comm_free(MPI_Comm *comm);
int PMPI_Comm_test_inter(MPI_Comm comm, int *flag);
int PMPI_Comm_remote_size(MPI_Comm comm, int *size);
int PMPI_Comm_remote_group(MPI_Comm comm, MPI_Group *group);
int PMPI_Intercomm_create(MPI_Comm local_comm, int local_leader, MPI_Comm peer_comm,
              int remote_leader, int tag, MPI_Comm *newintercomm);
int PMPI_Intercomm_merge(MPI_Comm intercomm, int high, MPI_Comm *newintracomm);
int PMPI_Keyval_create(MPI_Copy_function *copy_fn, MPI_Delete_function *delete_fn,
              int *keyval, void* extra_state);
int PMPI_Keyval_free(int *keyval);
int PMPI_Attr_put(MPI_Comm comm, int keyval, void *attribute_val);
int PMPI_Attr_get(MPI_Comm comm, int keyval, void *attribute_val, int *flag);
int PMPI_Attr_delete(MPI_Comm comm, int keyval);

int PMPI_Comm_create_errhandler(MPI_Comm_errhandler_fn *function, MPI_Errhandler *errhandler);
int PMPI_Comm_get_errhandler(MPI_Comm comm, MPI_Errhandler *errhandler);
int PMPI_Comm_set_errhandler(MPI_Comm comm, MPI_Errhandler errhandler);
int PMPI_Comm_create_keyval(MPI_Comm_copy_attr_function *comm_copy_attr_fn,
             MPI_Comm_delete_attr_function *comm_delete_attr_fn, int *comm_keyval,
             void *extra_state);
int PMPI_Comm_delete_attr(MPI_Comm comm, int comm_keyval);
int PMPI_Comm_free_keyval(int *comm_keyval);
int PMPI_Comm_get_attr(MPI_Comm comm, int comm_keyval, void *attribute_val, int *flag);
int PMPI_Comm_set_attr(MPI_Comm comm, int comm_keyval, void *attribute_val);


   /*   C Bindings for Process Topologies   */

int PMPI_Cart_create(MPI_Comm comm_old, int ndims, int *dims, int *periods,
              int reorder, MPI_Comm *comm_cart);
int PMPI_Dims_create(int nnodes, int ndims, int *dims);
int PMPI_Graph_create(MPI_Comm comm_old, int nnodes, int *index, int *edges,
              int reorder, MPI_Comm *comm_graph);
int PMPI_Topo_test(MPI_Comm comm, int *status);
int PMPI_Graphdims_get(MPI_Comm comm, int *nnodes, int *nedges);
int PMPI_Graph_get(MPI_Comm comm, int maxindex, int maxedges, int *index, int *edges);
int PMPI_Cartdim_get(MPI_Comm comm, int *ndims);
int PMPI_Cart_get(MPI_Comm comm, int maxdims, int *dims, int *periods, int *coords);
int PMPI_Cart_rank(MPI_Comm comm, int *coords, int *rank);
int PMPI_Cart_coords(MPI_Comm comm, int rank, int maxdims, int *coords);
int PMPI_Graph_neighbors_count(MPI_Comm comm, int rank, int *nneighbors);
int PMPI_Graph_neighbors(MPI_Comm comm, int rank, int maxneighbors, int *neighbors);
int PMPI_Cart_shift(MPI_Comm comm, int direction, int disp, int *rank_source, int *rank_dest);
int PMPI_Cart_sub(MPI_Comm comm, int *remain_dims, MPI_Comm *newcomm);
int PMPI_Cart_map(MPI_Comm comm, int ndims, int *dims, int *periods, int *newrank);
int PMPI_Graph_map(MPI_Comm comm, int nnodes, int *index, int *edges, int *newrank);


  /*    C bindings for Environmental Inquiry   */

int PMPI_Get_version(int *version, int *subversion);
int PMPI_Get_processor_name(char *name, int *resultlen);
int PMPI_Errhandler_create(MPI_Handler_function *function, MPI_Errhandler *errhandler);
int PMPI_Errhandler_set(MPI_Comm comm, MPI_Errhandler errhandler);
int PMPI_Errhandler_get(MPI_Comm comm, MPI_Errhandler *errhandler);
int PMPI_Errhandler_free(MPI_Errhandler *errhandler);
int PMPI_Error_string(int errorcode, char *string, int *resultlen);
int PMPI_Error_class(int errorcode, int *errorclass);
double PMPI_Wtime(void);
double PMPI_Wtick(void);
int PMPI_Init(int *argc, char ***argv);
int PMPI_Finalize(void);
int PMPI_Initialized(int *flag);
int PMPI_Abort(MPI_Comm comm, int errorcode);


  /*    C Bindings for Profiling  */

int PMPI_Pcontrol(const int level,...);

    /*  C Bindings for Non-Blocking Collective Communication   */

int PMPE_Ibarrier(MPI_Comm comm,MPI_Request *request);
int PMPE_Ibcast(void* buffer, int count, MPI_Datatype datatype, int root, MPI_Comm comm, 
              MPI_Request *request);
int PMPE_Igather(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int recvcount, MPI_Datatype recvtype, int root, MPI_Comm comm,MPI_Request *request);
int PMPE_Igatherv(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int *recvcounts, int *displs, MPI_Datatype recvtype, int root,
              MPI_Comm comm,MPI_Request *request);
int PMPE_Iscatter(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int recvcount, MPI_Datatype recvtype, int root, MPI_Comm comm,MPI_Request *request);
int PMPE_Iscatterv(void* sendbuf, int *sendcounts, int *displs, MPI_Datatype sendtype,
              void* recvbuf, int recvcount, MPI_Datatype recvtype, int root, MPI_Comm comm,
              MPI_Request *request);
int PMPE_Iallgather(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int recvcount, MPI_Datatype recvtype, MPI_Comm comm,MPI_Request *request);
int PMPE_Iallgatherv(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int *recvcounts, int *displs, MPI_Datatype recvtype, MPI_Comm comm,
              MPI_Request *request);
int PMPE_Ialltoall(void* sendbuf, int sendcount, MPI_Datatype sendtype, void* recvbuf,
              int recvcount, MPI_Datatype recvtype, MPI_Comm comm,MPI_Request *request);
int PMPE_Ialltoallv(void* sendbuf, int *sendcounts, int *sdispls, MPI_Datatype sendtype,
              void* recvbuf, int *recvcounts, int *rdispls, MPI_Datatype recvtype,
              MPI_Comm comm,MPI_Request *request);
int PMPE_Ireduce(void* sendbuf, void* recvbuf, int count, MPI_Datatype datatype,
              MPI_Op op, int root, MPI_Comm comm,MPI_Request *request);
int PMPE_Iallreduce(void* sendbuf, void* recvbuf, int count, MPI_Datatype datatype,
              MPI_Op op, MPI_Comm comm,MPI_Request *request);
int PMPE_Ireduce_scatter(void* sendbuf, void* recvbuf, int *recvcounts,
              MPI_Datatype datatype, MPI_Op op, MPI_Comm comm,MPI_Request *request);
int PMPE_Iscan(void* sendbuf, void* recvbuf, int count, MPI_Datatype datatype,
              MPI_Op op, MPI_Comm comm ,MPI_Request *request);

    /*  C Bindings for MPI 1-sided */

int PMPI_Win_create(void *base, MPI_Aint size, int disp_unit,
                    MPI_Info info, MPI_Comm comm, MPI_Win *win);
int PMPI_Win_free(MPI_Win *win);
int PMPI_Win_get_group(MPI_Win win, MPI_Group *group);
int PMPI_Put(void *origin_addr, int origin_count, MPI_Datatype origin_datatype,
              int target_rank, MPI_Aint target_disp, int target_count,
              MPI_Datatype target_datatype, MPI_Win win);
int PMPI_Get(void *origin_addr, int origin_count, MPI_Datatype origin_datatype,
              int target_rank, MPI_Aint target_disp, int target_count,
              MPI_Datatype target_datatype, MPI_Win win);
int PMPI_Accumulate(void *origin_addr, int origin_count, MPI_Datatype
              origin_datatype, int target_rank, MPI_Aint target_disp,
              int target_count, MPI_Datatype target_datatype,
              MPI_Op op, MPI_Win win);
int PMPI_Win_fence(int assert, MPI_Win win);
int PMPI_Win_start(MPI_Group group, int assert, MPI_Win win);
int PMPI_Win_complete(MPI_Win win);
int PMPI_Win_post(MPI_Group group, int assert, MPI_Win win);
int PMPI_Win_wait(MPI_Win win);
int PMPI_Win_test(MPI_Win win, int *flag);
int PMPI_Win_lock(int lock_type, int rank, int assert, MPI_Win win);
int PMPI_Win_unlock(int rank, MPI_Win win);
int PMPI_Win_get_attr(MPI_Win win, int win_keyval, void *attribute_val, int *flag);
int PMPI_Win_set_attr(MPI_Win win, int win_keyval, void *attribute_val);

int PMPI_Alloc_mem(MPI_Aint size, MPI_Info info, void *baseptr);
int PMPI_Free_mem(void *base);

    /*  C Bindings for I/O  */

int PMPI_File_open(MPI_Comm comm,char *filename,int amode,MPI_Info info,
                   MPI_File *fh);
int PMPI_File_close(MPI_File *fh);
int PMPI_File_delete(char *filename,MPI_Info info);
int PMPI_File_set_size(MPI_File fh,MPI_Offset size);
int PMPI_File_get_size(MPI_File fh,MPI_Offset *size);
int PMPI_File_get_group(MPI_File fh,MPI_Group *group);
int PMPI_File_get_amode(MPI_File fh,int *amode);
int PMPI_File_set_info(MPI_File fh,MPI_Info info);
int PMPI_File_get_info(MPI_File fh,MPI_Info *info_used);
int PMPI_File_set_view(MPI_File fh,MPI_Offset disp,MPI_Datatype etype,
                       MPI_Datatype filetype,char *datarep,MPI_Info info);
int PMPI_File_get_view(MPI_File fh,MPI_Offset *disp,MPI_Datatype *etype,
                       MPI_Datatype *filetype,char *datarep);
int PMPI_File_read_at(MPI_File fh,MPI_Offset offset,void *buf,int count,
                      MPI_Datatype datatype,MPI_Status *status);
int PMPI_File_read_at_all(MPI_File fh,MPI_Offset offset,void *buf,int count,
                          MPI_Datatype datatype,MPI_Status *status);
int PMPI_File_write_at(MPI_File fh,MPI_Offset offset,void *buf,int count,
                       MPI_Datatype datatype,MPI_Status *status);
int PMPI_File_write_at_all(MPI_File fh,MPI_Offset offset,void *buf,int count,
                           MPI_Datatype datatype,MPI_Status *status);
int PMPI_File_iread_at(MPI_File fh,MPI_Offset offset,void *buf,int count,
                       MPI_Datatype datatype,MPI_Request *request);
int PMPI_File_iwrite_at(MPI_File fh,MPI_Offset offset,void *buf,int count,
                        MPI_Datatype datatype,MPI_Request *request);
int PMPI_File_get_atomicity(MPI_File fh,int *flag);
int PMPI_File_sync(MPI_File fh);
int PMPI_Type_create_subarray(int ndims,int array_of_sizes[],
                              int array_of_subsizes[],int array_of_starts[],
                              int order,MPI_Datatype oldtype,
                              MPI_Datatype *newtype);
int PMPI_Type_create_darray(int size,int rank,int ndims,int array_of_gsizes[],
                            int array_of_distribs[],int array_of_dargs[],
                            int array_of_psizes[],int order,MPI_Datatype oldtype,
                            MPI_Datatype *newtype);
int PMPI_File_create_errhandler(MPI_File_errhandler_fn *function,
                                MPI_Errhandler *errhandler);
int PMPI_File_set_errhandler(MPI_File fh,MPI_Errhandler errhandler);
int PMPI_File_get_errhandler(MPI_File fh,MPI_Errhandler *errhandler);
int PMPI_File_create_errhandler(MPI_File_errhandler_fn *function, MPI_Errhandler *errhandler);
int PMPI_File_get_byte_offset(MPI_File fh, MPI_Offset offset, MPI_Offset *disp);
int PMPI_File_get_info(MPI_File fh, MPI_Info *info_used);
int PMPI_File_get_position(MPI_File fh, MPI_Offset *offset);
int PMPI_File_get_position_shared(MPI_File fh, MPI_Offset *offset);
int PMPI_File_get_type_extent(MPI_File fh, MPI_Datatype datatype, MPI_Aint *extent);
int PMPI_File_iread(MPI_File fh, void *buf, int count, MPI_Datatype datatype, 
             MPI_Request *request);
int PMPI_File_iread_shared(MPI_File fh, void *buf, int count, MPI_Datatype datatype,
             MPI_Request *request);
int PMPI_File_iwrite(MPI_File fh, void *buf, int count, MPI_Datatype datatype,
             MPI_Request *request);
int PMPI_File_iwrite_shared(MPI_File fh, void *buf, int count, MPI_Datatype datatype,
             MPI_Request *request);
int PMPI_File_preallocate(MPI_File fh, MPI_Offset size);
int PMPI_File_read(MPI_File fh, void *buf, int count, MPI_Datatype datatype, MPI_Status *status);
int PMPI_File_read_all(MPI_File fh, void *buf, int count, MPI_Datatype datatype,
             MPI_Status *status);
int PMPI_File_read_all_begin(MPI_File fh, void *buf, int count, MPI_Datatype datatype);
int PMPI_File_read_all_end(MPI_File fh, void *buf, MPI_Status *status);
int PMPI_File_read_at_all_begin(MPI_File fh, MPI_Offset offset, void *buf, int count,
             MPI_Datatype datatype);
int PMPI_File_read_at_all_end(MPI_File fh, void *buf, MPI_Status *status);
int PMPI_File_read_ordered(MPI_File fh, void *buf, int count, MPI_Datatype datatype,
             MPI_Status *status);
int PMPI_File_read_ordered_begin(MPI_File fh, void *buf, int count, MPI_Datatype datatype);
int PMPI_File_read_ordered_end(MPI_File fh, void *buf, MPI_Status *status);
int PMPI_File_read_shared(MPI_File fh, void *buf, int count, MPI_Datatype datatype,
             MPI_Status *status);
int PMPI_File_seek(MPI_File fh, MPI_Offset offset, int whence);
int PMPI_File_seek_shared(MPI_File fh, MPI_Offset offset, int whence);
int PMPI_File_set_atomicity(MPI_File fh, int flag);
int PMPI_File_set_info(MPI_File fh, MPI_Info info);
int PMPI_File_write(MPI_File fh, void *buf, int count, MPI_Datatype datatype, MPI_Status *status);
int PMPI_File_write_all(MPI_File fh, void *buf, int count, MPI_Datatype datatype,
             MPI_Status *status);
int PMPI_File_write_all_begin(MPI_File fh, void *buf, int count, MPI_Datatype datatype);
int PMPI_File_write_all_end(MPI_File fh, void *buf, MPI_Status *status);
int PMPI_File_write_at_all_begin(MPI_File fh, MPI_Offset offset, void *buf, int count,
             MPI_Datatype datatype);
int PMPI_File_write_at_all_end(MPI_File fh, void *buf, MPI_Status *status);
int PMPI_File_write_ordered(MPI_File fh, void *buf, int count, MPI_Datatype datatype,
             MPI_Status *status);
int PMPI_File_write_ordered_begin(MPI_File fh, void *buf, int count, MPI_Datatype datatype);
int PMPI_File_write_ordered_end(MPI_File fh, void *buf, MPI_Status *status);
int PMPI_File_write_shared(MPI_File fh, void *buf, int count, MPI_Datatype datatype,
             MPI_Status *status);
int PMPI_Register_datarep(char *datarep, MPI_Datarep_conversion_function *read_conversion_fn,
             MPI_Datarep_conversion_function *write_conversion_fn,
             MPI_Datarep_extent_function *dtype_file_extent_fn, void *extra_state);
int PMPI_Info_create(MPI_Info *info);
int PMPI_Info_set(MPI_Info Info,char *key,char *value);
int PMPI_Info_delete(MPI_Info info,char *key);
int PMPI_Info_get(MPI_Info info,char *key,int valuelen,char *value,int *flag);
int PMPI_Info_get_valuelen(MPI_Info info,char *key,int *valuelen,int *flag);
int PMPI_Info_get_nkeys(MPI_Info info,int *nkeys);
int PMPI_Info_get_nthkey(MPI_Info info,int n,char *key);
int PMPI_Info_dup(MPI_Info info, MPI_Info *newinfo);
int PMPI_Info_free(MPI_Info *info);

    /* PMPI C bindings for External Interfaces */
int PMPI_Add_error_class(int *errorclass);
int PMPI_Add_error_code(int errorclass, int *errorcode);
int PMPI_Add_error_string(int errorcode, char *string);
int PMPI_Comm_call_errhandler(MPI_Comm comm, int errorcode);
int PMPI_Comm_set_name(MPI_Comm comm, char *comm_name);
int PMPI_Comm_get_name(MPI_Comm comm, char *comm_name, int *resultlen);
int PMPI_File_call_errhandler(MPI_File fh, int errorcode);
int PMPI_Type_set_name(MPI_Datatype type, char *type_name);
int PMPI_Type_get_name(MPI_Datatype type, char *type_name, int *resultlen);
int PMPI_Win_call_errhandler(MPI_Win win, int errorcode);
int PMPI_Win_set_name(MPI_Win win, char *win_name);
int PMPI_Win_get_name(MPI_Win win, char *win_name, int *resultlen);

int PMPI_Init_thread(int *argc, char ***argv, int required, int *provided);
int PMPI_Query_thread(int *provided);
int PMPI_Is_thread_main(int *flag);
int PMPI_Grequest_start(MPI_Grequest_query_function *grequest_query_fn, 
              MPI_Grequest_free_function *grequest_free_fn, 
              MPI_Grequest_cancel_function *grequest_cancel_fn, void *extra_state, 
              MPI_Request *request);
int PMPI_Grequest_complete(MPI_Request request);
int PMPI_Status_set_elements(MPI_Status *status, MPI_Datatype datatype, int count);
int PMPI_Status_set_cancelled(MPI_Status *status, int flag);

    /* PMPI C bindings for Miscellany */

int PMPI_Finalized(int *flag);
int PMPI_Type_create_indexed_block(int count, int blocklength, int *array_of_displacements,
              MPI_Datatype oldtype, MPI_Datatype *newtype);
int PMPI_Request_get_status(MPI_Request request, int *flag, MPI_Status *status);
int PMPI_Get_address(void *location, MPI_Aint *address);
int PMPI_Type_create_resized(MPI_Datatype oldtype, MPI_Aint lb, MPI_Aint extent,
              MPI_Datatype *newtype);
int PMPI_Type_get_true_extent(MPI_Datatype datatype, MPI_Aint *true_lb,
              MPI_Aint *true_extent);
int PMPI_Pack_external(char *datarep, void *inbuf, int incount, MPI_Datatype datatype,
              void *outbuf, MPI_Aint outsize, MPI_Aint *position);
int PMPI_Unpack_external(char *datarep, void *inbuf, MPI_Aint insize, MPI_Aint *position,
              void *outbuf, int outcount, MPI_Datatype datatype);
int PMPI_Pack_external_size(char *datarep, int incount, MPI_Datatype datatype, MPI_Aint *size);

#if defined(__cplusplus)
   }
#endif

/****************************************************************************

 The following part of mpi.h defines the MPI C++ bindings which are based on
 an implementation of the University of Notre Dame. The copyright and license 
 text below belongs to this part of mpi.h only.

 COPYRIGHT NOTICE:

 Copyright 1997, University of Notre Dame.
 Authors: Andrew Lumsdaine, Michael P. McNally, Jeremy G. Siek, 
          Jeffery M. Squyres.

 DISCLAIMER:
 LICENSOR, AUTHORS AND THE UNIVERSITY OF NOTRE DAME MAKE NO REPRESENTATIONS, 
 OR WARRANTIES, EXPRESS OR IMPLIED. By way of example, but not limitation, 
 Licensor, Authors and the University of Notre Dame MAKE NO REPRESENTATIONS, 
 OR WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR PURPOSE OR THAT 
 USE OF THE LICENSED SOFTWARE COMPONENTS OR DOCUMENTATION WILL NO INFRINGE ANY 
 PATENTS, COPYRIGHTS, TRADEMARKS, OR OTHER RIGHTS. 

 END OF COPYRIGHT NOTICE.

****************************************************************************/

/***************************************************************************/
/* The following compile switches for the C++ bindings can be used:        */
/*                                                                         */
/* - _MPI_CPP_BINDINGS:      If defined the C++ bindings are enabled       */
/*                                                                         */
/* - _MPI_CPP_ALL_CONSTANTS: MPI::SEEK_SET,MPI::SEEK_CUR and               */
/*                           MPI::SEEK_END conflict with macros defined    */
/*                           in stdio.h. Because of this they are disabled */
/*                           by default.                                   */
/*                           To enable these constants in mpi.h,           */
/*                           _MPI_CPP_ALL_CONSTANTS has to be defined.     */
/***************************************************************************/

#if defined(__cplusplus) && defined(_MPI_CPP_BINDINGS)

/****************************************************************************/
/*                                                                          */
/*    Declaration of all MPI member functions, constants and classes        */
/*                                                                          */
/****************************************************************************/

/********************************************************************/
/*                                                                  */
/*                       Namespace MPI:                             */
/*                                                                  */
/********************************************************************/

class MPI
{
public:

  /* declaration of all C++ MPI classes */

  class Comm;
  class Intracomm;
  class Intercomm;
  class Graphcomm;
  class Cartcomm;
  class Datatype;
  class Errhandler;
  class Group;
  class Op;
  class Request;
  class Prequest;
  class Status;
  class Info;
  class File;
  class Win;
  class Grequest;

  /* typedefs for MPI C++ datatypes */

  typedef MPI_Aint Aint;
  typedef MPI_Offset Offset;

  /* typedefs for C++ named predefined datatypes */

  typedef MPI_Fint Fint;

  /* typedef for user defined callback for creating MPI_OP */

  typedef void User_function(const void* invec, void* inoutvec, int len, const Datatype& datatype);

  /* typedefs for user defined datarepresentation callbacks */

  typedef int Datarep_conversion_function(void* userbuf, Datatype& datatype, int count, 
              void* filebuf, Offset position, void* extra_state);
  typedef int Datarep_extent_function(const Datatype& datatype, Aint& file_extent, 
              void* extra_state);


  /********************************************************************/
  /*                            MPI Constants                         */
  /*                                                                  */
  /* enums (and not static const int) are used for integer types      */
  /* because so the value is known at compile time (e.g. to specify   */
  /* sizes for static arrays)                                         */
  /********************************************************************/

  /* error classes */

  enum
  {
   SUCCESS                   = MPI_SUCCESS,
   ERR_BUFFER                = MPI_ERR_BUFFER,
   ERR_COUNT                 = MPI_ERR_COUNT,
   ERR_TYPE                  = MPI_ERR_TYPE,
   ERR_TAG                   = MPI_ERR_TAG,
   ERR_COMM                  = MPI_ERR_COMM,
   ERR_RANK                  = MPI_ERR_RANK,
   ERR_REQUEST               = MPI_ERR_REQUEST,
   ERR_ROOT                  = MPI_ERR_ROOT,
   ERR_GROUP                 = MPI_ERR_GROUP,
   ERR_OP                    = MPI_ERR_OP,
   ERR_TOPOLOGY              = MPI_ERR_TOPOLOGY,
   ERR_DIMS                  = MPI_ERR_DIMS,
   ERR_ARG                   = MPI_ERR_ARG,
   ERR_UNKNOWN               = MPI_ERR_UNKNOWN,
   ERR_TRUNCATE              = MPI_ERR_TRUNCATE,
   ERR_OTHER                 = MPI_ERR_OTHER,
   ERR_INTERN                = MPI_ERR_INTERN,
   ERR_IN_STATUS             = MPI_ERR_IN_STATUS,
   ERR_PENDING               = MPI_ERR_PENDING,
   ERR_INFO_KEY              = MPI_ERR_INFO_KEY,
   ERR_INFO_VALUE            = MPI_ERR_INFO_VALUE,
   ERR_INFO_NOKEY            = MPI_ERR_INFO_NOKEY,
   ERR_INFO                  = MPI_ERR_INFO,
   ERR_FILE                  = MPI_ERR_FILE,
   ERR_NOT_SAME              = MPI_ERR_NOT_SAME,
   ERR_AMODE                 = MPI_ERR_AMODE,
   ERR_UNSUPPORTED_DATAREP   = MPI_ERR_UNSUPPORTED_DATAREP,
   ERR_UNSUPPORTED_OPERATION = MPI_ERR_UNSUPPORTED_OPERATION,
   ERR_NO_SUCH_FILE          = MPI_ERR_NO_SUCH_FILE,
   ERR_FILE_EXISTS           = MPI_ERR_FILE_EXISTS,
   ERR_BAD_FILE              = MPI_ERR_BAD_FILE,
   ERR_ACCESS                = MPI_ERR_ACCESS,
   ERR_NO_SPACE              = MPI_ERR_NO_SPACE,
   ERR_QUOTA                 = MPI_ERR_QUOTA,
   ERR_READ_ONLY             = MPI_ERR_READ_ONLY,
   ERR_FILE_IN_USE           = MPI_ERR_FILE_IN_USE,
   ERR_DUP_DATAREP           = MPI_ERR_DUP_DATAREP,
   ERR_CONVERSION            = MPI_ERR_CONVERSION,
   ERR_IO                    = MPI_ERR_IO,
   ERR_WIN                   = MPI_ERR_WIN,
   ERR_BASE                  = MPI_ERR_BASE,
   ERR_SIZE                  = MPI_ERR_SIZE,
   ERR_DISP                  = MPI_ERR_DISP,
   ERR_LOCKTYPE              = MPI_ERR_LOCKTYPE,
   ERR_ASSERT                = MPI_ERR_ASSERT,
   ERR_RMA_CONFLICT          = MPI_ERR_RMA_CONFLICT,
   ERR_RMA_SYNC              = MPI_ERR_RMA_SYNC,
   ERR_NO_MEM                = MPI_ERR_NO_MEM,
   ERR_KEYVAL                = MPI_ERR_KEYVAL,

   ERR_LASTCODE              = MPI_ERR_LASTCODE
  };

  /* maximum sizes */

  enum
  {
   MAX_ERROR_STRING   = MPI_MAX_ERROR_STRING
  };
  enum
  {
   MAX_PROCESSOR_NAME = MPI_MAX_PROCESSOR_NAME
  };
  enum
  {
   MAX_FILE_NAME      = MPI_MAX_FILE_NAME
  };
  enum
  {
   MAX_DATAREP_STRING = MPI_MAX_DATAREP_STRING
  };
  enum{
   MAX_INFO_KEY       = MPI_MAX_INFO_KEY
  };
  enum
  {
   MAX_INFO_VAL       = MPI_MAX_INFO_VAL
  };
  enum
  {
   MAX_OBJECT_NAME    = MPI_MAX_OBJECT_NAME
  };
  enum
  {
   BSEND_OVERHEAD     = MPI_BSEND_OVERHEAD
  };

  /* environmental inquiry keys & predefined attibute keys */

  enum
  {
   TAG_UB          = MPI_TAG_UB,
   IO              = MPI_IO,
   HOST            = MPI_HOST,
   WTIME_IS_GLOBAL = MPI_WTIME_IS_GLOBAL,
   WIN_BASE        = MPI_WIN_BASE,
   WIN_SIZE        = MPI_WIN_SIZE,
   WIN_DISP_UNIT   = MPI_WIN_DISP_UNIT,
   LASTUSEDCODE    = MPI_LASTUSEDCODE
  };

  /* results of communicator and group comparisons */

  enum
  {
   IDENT     = MPI_IDENT,
   CONGRUENT = MPI_CONGRUENT,
   SIMILAR   = MPI_SIMILAR,
   UNEQUAL   = MPI_UNEQUAL
  };

  /* topologies */

  enum
  {
   GRAPH = MPI_GRAPH,
   CART  = MPI_CART
  };

  /* file operation constants: */
  
#ifdef _MPI_CPP_ALL_CONSTANTS

  enum
  {
   SEEK_SET = MPI_SEEK_SET,
   SEEK_CUR = MPI_SEEK_CUR,
   SEEK_END = MPI_SEEK_END
  };

#endif /* _MPI_CPP_ALL_CONSTANTS */

  /* datatype constants */

  enum
  {
   DISTRIBUTE_NONE      = MPI_DISTRIBUTE_NONE,
   DISTRIBUTE_BLOCK     = MPI_DISTRIBUTE_BLOCK,
   DISTRIBUTE_CYCLIC    = MPI_DISTRIBUTE_CYCLIC,
   DISTRIBUTE_DFLT_DARG = MPI_DISTRIBUTE_DFLT_DARG
  };

  enum
  {
   ORDER_C       = MPI_ORDER_C,
   ORDER_FORTRAN = MPI_ORDER_FORTRAN
  };

   static const Offset DISPLACEMENT_CURRENT;

  /* F90 datatype matching contants */

  enum
  {
   TYPECLASS_REAL    = MPI_TYPECLASS_REAL,
   TYPECLASS_INTEGER = MPI_TYPECLASS_INTEGER,
   TYPECLASS_COMPLEX = MPI_TYPECLASS_COMPLEX
  };

  /* constants for mpi-io */

  enum
  {
   MODE_RDONLY          = MPI_MODE_RDONLY,
   MODE_WRONLY          = MPI_MODE_WRONLY,
   MODE_RDWR            = MPI_MODE_RDWR,
   MODE_CREATE          = MPI_MODE_CREATE,
   MODE_APPEND          = MPI_MODE_APPEND,
   MODE_EXCL            = MPI_MODE_EXCL,
   MODE_DELETE_ON_CLOSE = MPI_MODE_DELETE_ON_CLOSE,
   MODE_UNIQUE_OPEN     = MPI_MODE_UNIQUE_OPEN,
   MODE_SEQUENTIAL      = MPI_MODE_SEQUENTIAL,
   MODE_NOCHECK         = MPI_MODE_NOCHECK,
   MODE_NOSTORE         = MPI_MODE_NOSTORE,
   MODE_NOPUT           = MPI_MODE_NOPUT,
   MODE_NOPRECEDE       = MPI_MODE_NOPRECEDE,
   MODE_NOSUCCEED       = MPI_MODE_NOSUCCEED
  };

  enum
  {
    LOCK_EXCLUSIVE   = MPI_LOCK_EXCLUSIVE,
    LOCK_SHARED      = MPI_LOCK_SHARED
  };

  /* combiner constants used for datatype decoding functions */

  enum
  {
   COMBINER_NAMED            = MPI_COMBINER_NAMED,
   COMBINER_DUP              = MPI_COMBINER_DUP,
   COMBINER_CONTIGUOUS       = MPI_COMBINER_CONTIGUOUS,
   COMBINER_VECTOR           = MPI_COMBINER_VECTOR,
   COMBINER_HVECTOR_INTEGER  = MPI_COMBINER_HVECTOR_INTEGER,
   COMBINER_HVECTOR          = MPI_COMBINER_HVECTOR,
   COMBINER_INDEXED          = MPI_COMBINER_INDEXED,
   COMBINER_HINDEXED_INTEGER = MPI_COMBINER_HINDEXED_INTEGER,
   COMBINER_HINDEXED         = MPI_COMBINER_HINDEXED,
   COMBINER_INDEXED_BLOCK    = MPI_COMBINER_INDEXED_BLOCK,
   COMBINER_STRUCT_INTEGER   = MPI_COMBINER_STRUCT_INTEGER,
   COMBINER_STRUCT           = MPI_COMBINER_STRUCT,
   COMBINER_SUBARRAY         = MPI_COMBINER_SUBARRAY,
   COMBINER_DARRAY           = MPI_COMBINER_DARRAY,
   COMBINER_F90_REAL         = MPI_COMBINER_F90_REAL,
   COMBINER_F90_COMPLEX      = MPI_COMBINER_F90_COMPLEX,
   COMBINER_F90_INTEGER      = MPI_COMBINER_F90_INTEGER,
   COMBINER_RESIZED          = MPI_COMBINER_RESIZED
  };

  /* threads constants */

  enum
  {
   THREAD_SINGLE             = MPI_THREAD_SINGLE,
   THREAD_FUNNELED           = MPI_THREAD_FUNNELED,
   THREAD_SERIALIZED         = MPI_THREAD_SERIALIZED,
   THREAD_MULTIPLE           = MPI_THREAD_MULTIPLE
  };

  /* assorted constants */

  enum
  {
   PROC_NULL = MPI_PROC_NULL
  };
  enum
  {
   ANY_SOURCE = MPI_ANY_SOURCE
  };
  enum
  {
   ANY_TAG = MPI_ANY_TAG
  };
  enum
  {
   UNDEFINED = MPI_UNDEFINED
  };
  enum
  {
   KEYVAL_INVALID = MPI_KEYVAL_INVALID
  };
  enum
  {
   ROOT = MPI_ROOT
  };

   static void* const BOTTOM;
   static void* const IN_PLACE;

  /* error-handling specifiers */

   static const Errhandler  ERRORS_ARE_FATAL;
   static const Errhandler  ERRORS_RETURN;
   static const Errhandler  ERRORS_THROW_EXCEPTIONS;

  /* special datatypes for contstruction of derived datatypes */

   static const Datatype UB;
   static const Datatype LB;
   static const Datatype BYTE;
   static const Datatype PACKED;

  /* elementary datatypes (C / C++) */

   static const Datatype CHAR;
   static const Datatype UNSIGNED_CHAR;
   static const Datatype SIGNED_CHAR;
   static const Datatype SHORT;
   static const Datatype INT;
   static const Datatype LONG;
   static const Datatype UNSIGNED_SHORT;
   static const Datatype UNSIGNED;
   static const Datatype UNSIGNED_LONG;
   static const Datatype FLOAT;
   static const Datatype DOUBLE;
   static const Datatype LONG_DOUBLE;

   static const Datatype LONG_LONG;
   static const Datatype UNSIGNED_LONG_LONG;
   static const Datatype WCHAR;

  /* datatypes for reductions functions (C / C++) */

   static const Datatype FLOAT_INT;
   static const Datatype DOUBLE_INT;
   static const Datatype LONG_INT;
   static const Datatype TWOINT;
   static const Datatype SHORT_INT;
   static const Datatype LONG_DOUBLE_INT;

  /* elementary datatype (Fortran) */

   static const Datatype INTEGER;
   static const Datatype REAL;
   static const Datatype DOUBLE_PRECISION;
   static const Datatype F_COMPLEX;
   static const Datatype LOGICAL;
   static const Datatype CHARACTER;

  /* datatype for reduction functions (Fortran) */

   static const Datatype TWOREAL;
   static const Datatype TWODOUBLE_PRECISION;
   static const Datatype TWOINTEGER;
   static const Datatype TWOF_COMPLEX;

  /* optional datatypes (Fortran) */

   static const Datatype INTEGER1;
   static const Datatype INTEGER2;
   static const Datatype INTEGER4;
   static const Datatype INTEGER8;
   static const Datatype REAL4;
   static const Datatype REAL8;
   static const Datatype REAL16;
   static const Datatype LOGICAL1;
   static const Datatype LOGICAL2;
   static const Datatype LOGICAL4;
   static const Datatype LOGICAL8;
   static const Datatype F_DOUBLE_COMPLEX;
   static const Datatype F_COMPLEX8;
   static const Datatype F_COMPLEX16;
   static const Datatype F_COMPLEX32;

  /* reserved communicators */
  /* these can not be const because Set_errhandler is not const */

   static Intracomm COMM_WORLD;
   static Intracomm COMM_SELF; 

  /* collective operations */

   static const Op MAX;
   static const Op MIN;
   static const Op SUM;
   static const Op PROD;
   static const Op MAXLOC;
   static const Op MINLOC;
   static const Op BAND;
   static const Op BOR;
   static const Op BXOR;
   static const Op LAND;
   static const Op LOR;
   static const Op LXOR;
   static const Op REPLACE;

  /* null handles */

   static const Group        GROUP_NULL;
   static const MPI_Comm     COMM_NULL;
   static const Datatype     DATATYPE_NULL;
   static const Request      REQUEST_NULL;
   static const Op           OP_NULL;
   static const Errhandler   ERRHANDLER_NULL;
   static const Info         INFO_NULL;
   static const Win          WIN_NULL;

  /* MPI::FILE_NULL is not const because Set_errhandler is not const (setting default errhandler) */
   static File               FILE_NULL;

  /* empty group */

   static const Group  GROUP_EMPTY;

  /* predefined functions */

   static Datarep_conversion_function* CONVERSION_FN_NULL;

  /********************************************************************/
  /*                            MPI Functions                         */
  /********************************************************************/

  static void
  Attach_buffer(void* buffer, int size);

  static int
  Detach_buffer(void*& buffer);

  static void
  Compute_dims(int nnodes, int ndims, int dims[]);

  static void
  Get_processor_name(char*& name, int& resultlen);

  static void
  Get_error_string(int errorcode, char* string, int& resultlen);

  static int
  Get_error_class(int errorcode);

  static int
  Add_error_class();

  static int
  Add_error_code(int errorclass);

  static void 
  Add_error_string(int errorcode, const char* string);

  static int
  Init_thread(int& argc, char**& argv, int required);
  
  static int
  Init_thread(int required);

  static int
  Query_thread();

  static bool
  Is_thread_main();

  static double
  Wtime();

  static double
  Wtick();

  static void
  Init(int& argc, char**& argv);

  static void
  Init();

  static void
  Finalize();

  static bool
  Is_initialized();

  static bool
  Is_finalized();

  static void
  Pcontrol(const int level, ...);

  static void
  Get_version(int& version, int& subversion);

  static Aint
  Get_address(void* location);

  static void*
  Alloc_mem(Aint size, const Info& info);

  static void
  Free_mem(void *base);

  static void
  Register_datarep(const char* datarep,
                   Datarep_conversion_function* read_conversion_fn,
                   Datarep_conversion_function* write_conversion_fn,
                   Datarep_extent_function* dtype_file_extent_fn,
                   void* extra_state);


  /********************************************************************/
  /*                            Class Comm                            */
  /********************************************************************/

  class Comm
  {

    public:

      /* typedef for user defined Comm errorhandler */

      typedef void Errhandler_fn(Comm&, int*, ...);

      /* typedefs for attribute caching */

      typedef int Copy_attr_function(const Comm& oldcomm, int comm_keyval, 
             void* extra_state, const void* attribute_val_in,
             void* attribute_val_out, bool& flag);
      typedef int Delete_attr_function(Comm& comm, int comm_keyval, void* attribute_val, 
             void* extra_state);


      /* construction */

      Comm() : mpi_comm(MPI_COMM_NULL) { }

      Comm(const Comm& data) : mpi_comm(data.mpi_comm) { }

      Comm(const MPI_Comm& data) : mpi_comm(data) { }


      /* assignment operator is defined in subclasses */

      /* comparison */

      bool operator==(const Comm& data) const
      {
         return((bool)(mpi_comm == data.mpi_comm));
      }

      bool operator!=(const Comm& data) const
      {
         return((bool)(mpi_comm != data.mpi_comm));
      }

      /* inter-language operability operators */

      operator MPI_Comm() const
      {
        return mpi_comm;
      }

      Comm& operator=(const MPI_Comm& data)
      {
         mpi_comm = data;
         return *this;
      }

      bool operator==(const MPI_Comm& data) const
      {
        return(mpi_comm == data);
      }

      bool operator!=(const MPI_Comm& data) const
      {
        return(mpi_comm != data);
      }

      /* destruction */

      virtual ~Comm() {}


      /******************/
      /* Point-to-Point */
      /******************/

      virtual void Send(const void *buf, int count, const Datatype & datatype, int dest, int tag) const;

      virtual void Recv(void *buf, int count, const Datatype & datatype, int source, int tag, Status & status) const;

      virtual void Recv(void *buf, int count, const Datatype & datatype, int source, int tag) const;

      virtual void Bsend(const void *buf, int count, const Datatype & datatype, int dest, int tag) const;

      virtual void Ssend(const void *buf, int count, const Datatype & datatype, int dest, int tag) const;

      virtual void Rsend(const void *buf, int count, const Datatype & datatype, int dest, int tag) const;

      virtual Request Isend(const void *buf, int count, const Datatype & datatype, int dest, int tag) const;

      virtual Request Ibsend(const void *buf, int count, const Datatype & datatype, int dest, int tag) const;

      virtual Request Issend(const void *buf, int count, const Datatype & datatype, int dest, int tag) const;

      virtual Request Irsend(const void *buf, int count, const Datatype & datatype, int dest, int tag) const;

      virtual Request Irecv(void *buf, int count, const Datatype & datatype, int source, int tag) const;

      virtual bool Iprobe(int source, int tag, Status & status) const;

      virtual bool Iprobe(int source, int tag) const;

      virtual void Probe(int source, int tag, Status & status) const;

      virtual void Probe(int source, int tag) const;

      virtual Prequest Send_init(const void *buf, int count, const Datatype & datatype, int dest, int tag) const;

      virtual Prequest Bsend_init(const void *buf, int count, const Datatype & datatype, int dest, int tag) const;

      virtual Prequest Ssend_init(const void *buf, int count, const Datatype & datatype, int dest, int tag) const;

      virtual Prequest Rsend_init(const void *buf, int count, const Datatype & datatype, int dest, int tag) const;

      virtual Prequest Recv_init(void *buf, int count, const Datatype & datatype, int source, int tag) const;

      virtual void Sendrecv(const void *sendbuf, int sendcount, const Datatype & sendtype, int dest, int sendtag,
                            void *recvbuf, int recvcount, const Datatype & recvtype, int source,
                            int recvtag, Status & status) const;

      virtual void Sendrecv(const void *sendbuf, int sendcount, const Datatype & sendtype, int dest, int sendtag,
                            void *recvbuf, int recvcount, const Datatype & recvtype, int source, int recvtag) const;

      virtual void Sendrecv_replace(void *buf, int count, const Datatype & datatype, int dest, int sendtag, int source,
                                    int recvtag, Status & status) const;

      virtual void Sendrecv_replace(void *buf, int count, const Datatype & datatype, int dest, int sendtag, int source,
                                    int recvtag) const;

      /*************************/
      /* Collective Operations */
      /*************************/

      virtual void Bcast(void *buffer, int count, const Datatype& datatype, int root) const;

      virtual void Gather(const void *sendbuf, int sendcount, const Datatype & sendtype, void *recvbuf, int recvcount, const Datatype & recvtype, int root) const;

      virtual void Gatherv(const void *sendbuf, int sendcount, const Datatype & sendtype, void *recvbuf, const int recvcounts[], const int displs[], const Datatype & recvtype, int root) const;

      virtual void Scatter(const void *sendbuf, int sendcount, const Datatype &sendtype, void *recvbuf, int recvcount, const Datatype & recvtype, int root) const;

      virtual void Scatterv(const void *sendbuf, const int sendcounts[], const int displs[], const Datatype & sendtype, void *recvbuf, int recvcount, const Datatype & recvtype, int root) const;

      virtual void Allgather(const void *sendbuf, int sendcount, const Datatype& sendtype, void *recvbuf, int recvcount, const Datatype & recvtype) const;

      virtual void Allgatherv(const void *sendbuf, int sendcount, const Datatype& sendtype, void *recvbuf, const int recvcounts[], const int displs[], const Datatype & recvtype) const;

      virtual void Alltoall(const void *sendbuf, int sendcount, const Datatype & sendtype, void *recvbuf, int recvcount, const Datatype & recvtype) const;

      virtual void Alltoallv(const void *sendbuf, const int sendcounts[], const int sdispls[], const Datatype & sendtype, void *recvbuf, const int recvcounts[], const int rdispls[], const Datatype & recvtype) const;

      virtual void Alltoallw(const void *sendbuf, const int sendcounts[], const int sdispls[], const MPI::Datatype sendtypes[], void *recvbuf, const int recvcounts[], const int rdispls[], const MPI::Datatype recvtypes[]) const;

      virtual void Reduce(const void *sendbuf, void *recvbuf, int count, const Datatype & datatype, const Op & op, int root) const;

      virtual void Allreduce(const void *sendbuf, void *recvbuf, int count, const Datatype & datatype, const Op & op) const;

      virtual void Reduce_scatter(const void *sendbuf, void *recvbuf, int recvcounts[], const Datatype & datatype, const Op & op) const;

      virtual void Barrier() const;

      /**************/
      /* Errhandler */
      /**************/

      static Errhandler Create_errhandler(Comm::Errhandler_fn* function);

      virtual Errhandler Get_errhandler() const;

      virtual void Set_errhandler(const Errhandler& errhandler);
 
      virtual void Call_errhandler(int errorcode) const;


      /***********************/
      /* Keys and Attributes */
      /***********************/

      static int Create_keyval(Copy_attr_function* comm_copy_attr_fn, Delete_attr_function* comm_delete_attr_fn,
                               void* extra_state);

      static void Free_keyval(int& comm_keyval);

      virtual void Set_attr(int comm_keyval, const void* attribute_val) const;

      virtual bool Get_attr(int comm_keyval, void* attribute_val) const;

      virtual void Delete_attr(int comm_keyval);

      /*************************/
      /* Other Get/Set Methods */
      /*************************/

      virtual Group Get_group() const;

      virtual int Get_size() const;

      virtual int Get_rank() const;

      virtual int Get_topology() const;

      virtual void Set_name( const char* comm_name);

      virtual void Get_name( char* comm_name, int& resultlen) const;

      /********/
      /* Misc */
      /********/

      virtual Comm& Clone() const = 0;

      virtual void Free(void);

      virtual bool Is_inter() const;

      static int Compare(const Comm & comm1, const Comm & comm2);

      virtual void Abort(int errorcode);

      /**********************************************/
      /* predefined functions for attribute caching */
      /**********************************************/

      static int NULL_COPY_FN(const Comm& oldcomm, int comm_keyval, void* extra_state, const void* attribute_val_in,
                              void* attribute_val_out, bool& flag);

      static int DUP_FN(const Comm& oldcomm, int comm_keyval, void* extra_state, const void* attribute_val_in,
                        void* attribute_val_out, bool& flag);

      static int NULL_DELETE_FN(Comm& comm, int comm_keyval, void* attribute_val, void* extra_state);

    protected:

      MPI_Comm mpi_comm;

    private:

      static void _set_cpp_err_lang_flag(MPI_Errhandler err);
      static void _set_cpp_key_lang_flag(int key);

  }; /* MPI::Comm */

  /********************************************************************/
  /*                            Class Datatype                        */
  /********************************************************************/

  class Datatype
  {

    public:

      /***********************************/
      /* typedefs for attribute caching  */
      /***********************************/

      typedef int Copy_attr_function(const Datatype& oldtype, int type_keyval, void* extra_state, const void* attribute_val_in, void* attribute_val_out, bool& flag);
      typedef int Delete_attr_function(Datatype& type, int type_keyval, void* attribute_val, void* extra_state);


      /* construction */

      Datatype() : mpi_datatype(MPI_DATATYPE_NULL) { }

      Datatype(const MPI_Datatype &i) : mpi_datatype(i) { }

      Datatype(const Datatype& dt) : mpi_datatype(dt.mpi_datatype) { }

      /* assignment */

      Datatype& operator=(const Datatype& dt)
      {
        mpi_datatype = dt.mpi_datatype;
        return *this;
      }

      /* comparison */

      bool operator== (const Datatype &a) const
      {
        return (bool) (mpi_datatype == a.mpi_datatype);
      }

      bool operator!= (const Datatype &a) const
      {
        return (bool) !(*this == a);
      }

      /* inter-language operability operators */

      Datatype& operator= (const MPI_Datatype &i)
      {
        mpi_datatype = i;
        return *this;
      }

      operator MPI_Datatype () const
      {
        return mpi_datatype;
      }

      bool operator==(const MPI_Datatype& data) const
      {
        return(mpi_datatype == data);
      }

      bool operator!=(const MPI_Datatype& data) const
      {
        return(mpi_datatype != data);
      }

      /* destruction */

      virtual ~Datatype() {}

      /***********************/
      /* Decoding a datatype */
      /***********************/

      virtual void Get_contents(int max_integers, int max_addresses, int max_datatypes, int array_of_integers[],
                                Aint array_of_addresses[], Datatype array_of_datatypes[]) const;

      virtual void Get_envelope(int& num_integers, int& num_addresses, int& num_datatypes, int& combiner) const;

      /**************************/
      /* Datatype constructors: */
      /**************************/

      virtual Datatype Create_darray(int size, int rank, int ndims, const int array_of_gsizes[], const int array_of_distribs[],
                                     const int array_of_dargs[], const int array_of_psizes[], int order) const;

      virtual Datatype Create_subarray(int ndims, const int array_of_sizes[], const int array_of_subsizes[],
                                       const int array_of_starts[], int order) const;


      virtual Datatype Create_contiguous(int count) const;

      virtual Datatype Create_vector(int count, int blocklength, int stride) const;

      virtual Datatype Create_indexed(int count,const int array_of_blocklengths[], const int array_of_displacements[]) const;

      virtual Datatype Create_indexed_block(int count, int blocklength, const int array_of_displacements[]) const;

      virtual Datatype Create_hindexed(int count, const int array_of_blocklengths[], const Aint array_of_displacements[]) const;

      virtual Datatype Create_hvector(int count, int blocklength, Aint stride) const;

      virtual Datatype Create_resized(const MPI::Aint lb, const MPI::Aint extent) const;

      static Datatype Create_struct(int count, const int array_of_blocklengths[], const Aint array_of_displacements[],
                                    const Datatype array_if_types[]);
      static Datatype Create_f90_real(int p, int r); 
      static Datatype Create_f90_complex(int p, int r); 
      static Datatype Create_f90_integer(int r); 
      static Datatype Match_size(int typeclass, int size);


      /***********************/
      /* Keys and Attributes */
      /***********************/

      virtual void Set_attr(int type_keyval, const void* attribute_val);

      virtual bool Get_attr(int type_keyval, void* attribute_val) const;

      virtual void Delete_attr(int type_keyval);

      static void Free_keyval(int& type_keyval);

      static int Create_keyval(Copy_attr_function* type_copy_attr_fn, Delete_attr_function* type_delete_attr_fn, void* extra_state);


      /********/
      /* Misc */
      /********/

      virtual int Get_size() const;

      virtual void Get_extent(Aint& lb, Aint& extent) const;

      virtual void Get_true_extent(MPI::Aint& true_lb, MPI::Aint& true_extent) const;

      virtual void Commit();

      virtual void Free();

      virtual void Pack(const void* inbuf, int incount, void *outbuf, int outsize, int& position, const Comm &comm) const;

      virtual void Unpack(const void* inbuf, int insize, void *outbuf, int outcount, int& position, const Comm& comm) const;

      virtual int Pack_size(int incount, const Comm& comm) const;

      virtual Datatype Dup() const;

      virtual void Set_name(const char* type_name);

      virtual void Get_name(char* type_name, int& resultlen) const;

      virtual void Pack_external(const char* datarep, const void* inbuf, int incount, void* outbuf, MPI::Aint outsize, MPI::Aint& position) const;

      virtual void Unpack_external(const char* datarep, const void* inbuf, MPI::Aint insize, MPI::Aint& position, void* outbuf, int outcount) const;

      virtual MPI::Aint Pack_external_size(const char* datarep, int incount) const;


      /**********************************************/
      /* predefined functions for attribute caching */
      /**********************************************/

      static int NULL_COPY_FN(const Datatype& oldtype, int type_keyval, void* extra_state, const void* attribute_val_in, void* attribute_val_out, bool& flag);

      static int DUP_FN(const Datatype& oldtype, int type_keyval, void* extra_state, const void* attribute_val_in, void* attribute_val_out, bool& flag);

      static int NULL_DELETE_FN(Datatype& type, int type_keyval, void* attribute_val, void* extra_state);

    protected:

      MPI_Datatype mpi_datatype;

    private:

      static void _set_cpp_key_lang_flag(int key);

  }; /* MPI::Datatype */

  /********************************************************************/
  /*                            Class Errhandler                      */
  /********************************************************************/

  class Errhandler
  {

    public:


      /* construction */

      Errhandler() : mpi_errhandler(MPI_ERRHANDLER_NULL) {}

      Errhandler(const MPI_Errhandler &i) : mpi_errhandler(i) {}

      Errhandler(const Errhandler& e) : mpi_errhandler(e.mpi_errhandler) { }

      /* assignment */

      Errhandler& operator=(const Errhandler& e)
      {
        mpi_errhandler = e.mpi_errhandler;
        return *this;
      }

      /* comparison */

      bool operator==(const Errhandler &a) const
      {
        return (bool)(mpi_errhandler == a.mpi_errhandler);
      }

      bool operator!=(const Errhandler &a) const
      {
        return (bool)!(*this == a);
      }

      /* inter-language operability operators */

      Errhandler& operator= (const MPI_Errhandler &i)
      {
        mpi_errhandler = i;
        return *this;
      }

      operator MPI_Errhandler() const
      {
        return mpi_errhandler;
      }

      bool operator==(const MPI_Errhandler& data) const
      {
        return(mpi_errhandler == data);
      }

      bool operator!=(const MPI_Errhandler& data) const
      {
        return(mpi_errhandler != data);
      }


      /* destruction */

      virtual ~Errhandler() {}

      /*******************************/
      /* Errhandler access functions */
      /*******************************/

      virtual void Free();

    protected:

      MPI_Errhandler mpi_errhandler;

  }; /* MPI::Errhandler */


  /********************************************************************/
  /*                            Class Exception                       */
  /********************************************************************/

  class Exception
  {

    public:

      /* construction */

      Exception(int ec) : error_code(ec)
      {
        (void)MPI_Error_class(error_code, &error_class);
        int resultlen;
        (void)MPI_Error_string(error_code, error_string, &resultlen);
      }

      /* destruction */

      virtual ~Exception(){ }

      /***************/
      /* Get methods */
      /***************/

      virtual int Get_error_code() const
      {
        return error_code;
      }

      virtual int Get_error_class() const
      {
        return error_class;
      }

      virtual const char* Get_error_string() const
      {
        return error_string;
      }



    protected:

      int  error_code;
      char error_string[MPI_MAX_ERROR_STRING];
      int  error_class;

  }; /* MPI::Exception */


  /********************************************************************/
  /*                            Class File                            */
  /********************************************************************/

  class File
  {

    public:

      /* typedef for user defined File errorhandler */

      typedef void Errhandler_fn(File&, int*, ...);


      /* construction */

      File() : mpi_file(MPI_FILE_NULL){}

      File(const File &f): mpi_file(f.mpi_file){}

      File(const MPI_File& f) : mpi_file(f){}

      /* assignment */

      File& operator=(const File& f)
      {
         mpi_file = f.mpi_file;
         return *this;
      }

      /* comparison */

      bool operator==(const File& f) const
      {
         return (bool)(mpi_file == f.mpi_file);
      }

      bool operator!=(const File& f) const
      {
         return (bool)(mpi_file != f.mpi_file);
      }

      /* inter-language operability operators */

      File& operator=(const MPI_File &f)
      {
         mpi_file = f;
         return *this;
      }

      operator MPI_File() const
      {
        return mpi_file;
      }

      bool operator==(const MPI_File& data) const
      {
        return(mpi_file == data);
      }

      bool operator!=(const MPI_File& data) const
      {
        return(mpi_file != data);
      }

      /* destruction */

      virtual ~File(){}

      /******************/
      /* Write methods  */
      /******************/

      virtual void Write_at(Offset offset, const void* buf, int count, const Datatype& datatype);

      virtual void Write_at(Offset offset, const void* buf, int count, const Datatype& datatype, Status& status);

      virtual void Write_at_all(Offset offset, const void* buf, int count, const Datatype& datatype);

      virtual void Write_at_all(Offset offset, const void* buf, int count, const Datatype& datatype, Status& status);

      virtual void Write(const void* buf, int count, const Datatype& datatype);

      virtual void Write(const void* buf, int count, const Datatype& datatype, Status& status);

      virtual void Write_all(const void* buf, int count, const Datatype& datatype);

      virtual void Write_all(const void* buf, int count, const Datatype& datatype, Status& status);

      virtual void Write_shared(const void* buf, int count, const Datatype& datatype);

      virtual void Write_shared(const void* buf, int count, const Datatype& datatype, Status& status);

      virtual void Write_ordered(const void* buf, int count, const Datatype& datatype);

      virtual void Write_ordered(const void* buf, int count, const Datatype& datatype, Status& status);

      virtual void Write_at_all_begin(Offset offset, const void* buf, int count, const Datatype& datatype);

      virtual void Write_at_all_end(const void* buf);

      virtual void Write_at_all_end(const void* buf, Status& status);

      virtual void Write_all_begin(const void* buf, int count, const Datatype& datatype);

      virtual void Write_all_end(const void* buf);

      virtual void Write_all_end(const void* buf, Status& status);

      virtual void Write_ordered_begin(const void* buf, int count, const Datatype& datatype);

      virtual void Write_ordered_end(const void* buf);

      virtual void Write_ordered_end(const void* buf, Status& status);


      virtual Request Iwrite(const void* buf, int count, const Datatype& datatype);

      virtual Request Iwrite_at(Offset offset, const void* buf, int count, const Datatype& datatype);

      virtual Request Iwrite_shared(const void* buf, int count, const Datatype& datatype);


      /****************/
      /* Read methods */
      /****************/

      virtual void Read_at(Offset offset, void* buf, int count, const Datatype& datatype);

      virtual void Read_at(Offset offset, void* buf, int count, const Datatype& datatype, Status& status);

      virtual void Read_at_all(Offset offset, void* buf, int count, const Datatype& datatype);

      virtual void Read_at_all(Offset offset, void* buf, int count, const Datatype& datatype, Status& status);

      virtual void Read(void* buf, int count, const Datatype& datatype);

      virtual void Read(void* buf, int count, const Datatype& datatype, Status& status);

      virtual void Read_all(void* buf, int count, const Datatype& datatype);

      virtual void Read_all(void* buf, int count, const Datatype& datatype, Status& status);

      virtual void Read_shared(void* buf, int count, const Datatype& datatype);

      virtual void Read_shared(void* buf, int count, const Datatype& datatype, Status& status);

      virtual void Read_ordered(void* buf, int count, const Datatype& datatype);

      virtual void Read_ordered(void* buf, int count, const Datatype& datatype, Status& status);

      virtual void Read_at_all_begin(Offset offset, void* buf, int count, const Datatype& datatype);

      virtual void Read_at_all_end(void *buf);

      virtual void Read_at_all_end(void *buf, Status& status);

      virtual void Read_all_begin(void* buf, int count, const Datatype& datatype);

      virtual void Read_all_end(void* buf);

      virtual void Read_all_end(void* buf, Status& status);

      virtual void Read_ordered_begin(void* buf, int count, const Datatype& datatype);

      virtual void Read_ordered_end(void* buf);

      virtual void Read_ordered_end(void* buf, Status& status);


      virtual Request Iread(void* buf, int count, const Datatype& datatype);

      virtual Request Iread_at(Offset offset, void *buf, int count, const Datatype& datatype);

      virtual Request Iread_shared(void* buf, int count, const Datatype& datatype);


      /**************/
      /* Errhandler */
      /**************/


      static Errhandler Create_errhandler(File::Errhandler_fn* function);

      virtual Errhandler Get_errhandler() const;

      virtual void Set_errhandler(const Errhandler& errhandler);

      virtual void Call_errhandler(int errorcode) const;


      /*************************/
      /* Other Get/Set Methods */
      /*************************/

      virtual int Get_amode() const;

      virtual void Set_atomicity(bool flag);

      virtual bool Get_atomicity() const;

      virtual Group Get_group() const;

      virtual void Set_info(const Info& info);

      virtual Info Get_info() const;

      virtual void Set_size(Offset size);

      virtual Offset Get_size() const;

      virtual void Set_view(Offset disp, const Datatype& etype, const Datatype& filetype, const char* datarep, const Info& info);

      virtual void Get_view(Offset& disp, Datatype& etype, Datatype& filetype, char* datarep) const;

      virtual Offset Get_position() const;

      virtual Offset Get_byte_offset(const Offset disp) const;

      virtual Aint Get_type_extent(const Datatype& datatype) const;

      virtual Offset Get_position_shared() const;


      /********/
      /* Misc */
      /********/

      static File Open(const Intracomm& comm, const char* filename, int amode, const Info& info);

      virtual void Close();

      virtual void Sync();

      virtual void Preallocate(Offset size);

      virtual void Seek(Offset offset, int whence);

      virtual void Seek_shared(Offset offset, int whence);

      static void Delete(const char* filename, const Info& info);


    protected:

        MPI_File mpi_file;

    private:

      static void _set_cpp_err_lang_flag(MPI_Errhandler err);

  }; /* MPI::File */



  /********************************************************************/
  /*                            Class Group                           */
  /********************************************************************/

  class Group
  {

    public:

      /* construction */

      Group() : mpi_group(MPI_GROUP_NULL) { }

      Group(const Group& g) : mpi_group(g.mpi_group) { }

      Group(const MPI_Group &i) : mpi_group(i) { }

      /* assignment */

      Group& operator=(const Group& g)
      {
        mpi_group = g.mpi_group;
        return *this;
      }

      /* comparison */

      bool operator== (const Group &a) const
      {
        return (bool)(mpi_group == a.mpi_group);
      }

      bool operator!= (const Group &a) const
      {
        return (bool)!(*this == a);
      }

      /* inter-language operability operators */

     Group& operator= (const MPI_Group &i)
      {
        mpi_group = i;
        return *this;
      }

      operator MPI_Group () const
      {
        return mpi_group;
      }

      bool operator==(const MPI_Group& data) const
      {
        return(mpi_group == data);
      }

      bool operator!=(const MPI_Group& data) const
      {
        return(mpi_group != data);
      }

      /* destruction */

      virtual ~Group() {}


      /******************************/
      /* Methods to generate Groups */
      /******************************/

      static Group Union(const Group &group1, const Group &group2);

      static Group Intersect(const Group &group1, const Group &group2);

      static Group Difference(const Group &group1, const Group &group2);

      virtual Group Incl(int n, const int ranks[]) const;

      virtual Group Excl(int n, const int ranks[]) const;

      virtual Group Range_incl(int n, const int ranges[][3]) const;

      virtual Group Range_excl(int n, const int ranges[][3]) const;

      /*******************/
      /* Get/Set Methods */
      /*******************/

      virtual int Get_size() const;

      virtual int Get_rank() const;

      /********/
      /* Misc */
      /********/

      static void Translate_ranks (const Group& group1, int n, const int ranks1[], const Group& group2, int ranks2[]);

      static int Compare(const Group& group1, const Group& group2);

      virtual void Free();

    protected:

      MPI_Group mpi_group;


  }; /* MPI::Group */


  /********************************************************************/
  /*                            Class Info                            */
  /********************************************************************/

  class Info
  {

    public:

      /* construction */

      Info() : mpi_info(MPI_INFO_NULL) {}

      Info(const Info &i): mpi_info(i.mpi_info) {}

      Info(const MPI_Info& i) : mpi_info(i) {}

      /* assignment */

      Info& operator=(const Info& i)
      {
         mpi_info = i.mpi_info;
         return *this;
      }

      /* comparison */

      bool operator==(const Info& i) const
      {
         return (bool)(mpi_info == i.mpi_info);
      }

      bool operator!=(const Info& i) const
      {
         return (bool)(mpi_info != i.mpi_info);
      }

      /* inter-language operability operators */

      Info& operator=(const MPI_Info &i)
      {
         mpi_info = i;
         return *this;
      }

      operator MPI_Info() const
      {
        return mpi_info;
      }

      bool operator==(const MPI_Info& data) const
      {
        return(mpi_info == data);
      }

      bool operator!=(const MPI_Info& data) const
      {
        return(mpi_info != data);
      }

      /* destruction */

      virtual ~Info(){}


      /*******************/
      /* Get/Set Methods */
      /*******************/

      virtual bool Get(const char* key, int valuelen, char* value) const;

      virtual int Get_nkeys() const;

      virtual void Get_nthkey(int n, char* key) const;

      virtual bool Get_valuelen(const char* key, int& valuelen) const;

      virtual void Set(const char* key, const char* value);

      /********/
      /* Misc */
      /********/

      static Info Create();

      virtual void Delete(const char* key);

      virtual Info Dup() const;

      virtual void Free();

    private:

      MPI_Info mpi_info;

  }; /* MPI::Info */

  /********************************************************************/
  /*                            Class Intercomm                       */
  /********************************************************************/


  class Intercomm : public Comm
  {

    public:

      /* construction */

      Intercomm() : Comm(MPI_COMM_NULL) { }

      Intercomm(const Intercomm& data) : Comm(data.mpi_comm) { }

      Intercomm(const MPI_Comm& data);

      /* assignment */

      Intercomm& operator=(const Intercomm& data)
      {
        mpi_comm = data.mpi_comm;
        return *this;
      }

      /* comparison operators inherited from Base class */

      /* inter-language operability operators (cast operator inherited from Base class) */

      Intercomm& operator=(const MPI_Comm& data)
      {
        mpi_comm = data;
        return *this;
      }


      /*******************/
      /* Get/Set Methods */
      /*******************/

      virtual int Get_remote_size() const;

      virtual Group Get_remote_group() const;

      /********/
      /* Misc */
      /********/

      Intercomm Dup() const; /* not virtual ! */

      virtual Intercomm& Clone() const;

      virtual Intercomm Create(const Group& group) const;

      virtual Intercomm Split(int color, int key) const;

      virtual Intracomm Merge(bool high);


  }; /* MPI::Intercomm */

  /********************************************************************/
  /*                            Class Intracomm                       */
  /********************************************************************/

  class Intracomm : public Comm
  {

    public:


      /* construction */

      Intracomm() { }

      Intracomm(const Intracomm& data) : Comm(data.mpi_comm) { }

      Intracomm(const MPI_Comm& data);

      /* assignment */

      Intracomm& operator=(const Intracomm& data)
      {
        mpi_comm = data.mpi_comm;
        return *this;
      }

      /* comparison operators inherited from Base class */

      /* inter-language operability operators (cast operator inherited from Base class) */

      Intracomm& operator=(const MPI_Comm& data)
      {
        mpi_comm = data;
        return *this;
      }


      /****************************/
      /* Collective Communication */
      /****************************/

      virtual void Scan(const void *sendbuf, void *recvbuf, int count, const Datatype & datatype, const Op & op) const;

      virtual void Exscan(const void *sendbuf, void *recvbuf, int count, const MPI::Datatype & datatype, const MPI::Op & op) const;

      /**************************************************/
      /* Methods to create different Communicator types */
      /**************************************************/

      Intracomm Dup() const; /* not virtual ! */

      virtual Intracomm& Clone() const;

      virtual Intracomm Create(const Group& group) const;

      virtual Intracomm Split(int color, int key) const;

      virtual Intercomm Create_intercomm(int local_leader, const Comm& peer_comm, int remote_leader, int tag) const;

      virtual Cartcomm Create_cart(int ndims, const int dims[], const bool periods[], bool reorder) const;

      virtual Graphcomm Create_graph(int nnodes, const int index[], const int edges[], bool reorder) const;


  }; /* MPI::Intercomm */

  /********************************************************************/
  /*                            Class Op                              */
  /********************************************************************/

  class Op {

    public:

      /* construction */

      Op() : mpi_op(MPI_OP_NULL) {}

      Op(const Op& op) : mpi_op(op.mpi_op) {}

      Op(const MPI_Op &op) : mpi_op(op) {}

      /* assignment */

      Op& operator=(const Op& op)
      {
         mpi_op = op.mpi_op;
         return *this;
      }

      /* comparison */

      bool operator== (const Op &a) const
      {
         return (bool)(mpi_op == a.mpi_op);
      }

      bool operator!= (const Op &a) const
      {
         return (bool)!(*this == a);
      }

      /* inter-language operability operators */

      operator MPI_Op () const
      {
         return mpi_op;
      }

      Op& operator= (const MPI_Op &i)
      {
         mpi_op = i;
         return *this;
      }

      bool operator==(const MPI_Op& data) const
      {
        return(mpi_op == data);
      }

      bool operator!=(const MPI_Op& data) const
      {
        return(mpi_op != data);
      }

      /* destruction */

      virtual ~Op() {}

      /***********/
      /* methods */
      /***********/

      virtual void Init(User_function *func, bool commute);

      virtual void Free();

    protected:

      MPI_Op mpi_op;

    private:

     static void _set_cpp_op_lang_flag(MPI_Op op);

  }; /* MPI::Op */

  /********************************************************************/
  /*                            Class Request                         */
  /********************************************************************/

  class Request
  {

    public:

      /* construction */

      Request() : mpi_request(MPI_REQUEST_NULL) { }

      Request(const MPI_Request &i) : mpi_request(i) { }

      Request(const Request& r) : mpi_request(r.mpi_request) { }

      /* assignment */

      Request& operator=(const Request& r)
      {
        mpi_request = r.mpi_request;
        return *this;
      }

      /* comparison */

      bool operator== (const Request &a) const
      {
        return (bool)(mpi_request == a.mpi_request);
      }

      bool operator!= (const Request &a) const
      {
        return (bool)!(*this == a);
      }

      /* inter-language operability operators */

      Request& operator= (const MPI_Request &i)
      {
        mpi_request = i;
        return *this;
      }

      operator MPI_Request () const
      {
        return mpi_request;
      }

      bool operator==(const MPI_Request& data) const
      {
        return(mpi_request == data);
      }

      bool operator!=(const MPI_Request& data) const
      {
        return(mpi_request != data);
      }

      /* destruction */

      virtual ~Request() {}


      /****************/
      /* Wait Methods */
      /****************/

      virtual void Wait(Status &status);

      virtual void Wait();

      static int Waitany(int count, Request array[], Status& status);

      static int Waitany(int count, Request array[]);

      static void Waitall(int count, Request req_array[], Status stat_array[]);

      static void Waitall(int count, Request req_array[]);

      static int Waitsome(int incount, Request req_array[], int array_of_indices[], Status stat_array[]) ;

      static int Waitsome(int incount, Request req_array[], int array_of_indices[]);

      /****************/
      /* Test Methods */
      /****************/

      virtual bool Test(Status &status);

      virtual bool Test();

      static bool Testany(int count, Request array[], int& index, Status& status);

      static bool Testany(int count, Request array[], int& index);

      static bool Testall(int count, Request req_array[], Status stat_array[]);

      static bool Testall(int count, Request req_array[]);

      static int Testsome(int incount, Request req_array[], int array_of_indices[], Status stat_array[]);

      static int Testsome(int incount, Request req_array[], int array_of_indices[]);


      /********/
      /* Misc */
      /********/
      virtual bool Get_status(MPI::Status& status) const;

      virtual bool Get_status() const;

      virtual void Free(void);

      virtual void Cancel(void) const;

    protected:

      MPI_Request mpi_request;


  }; /* MPI::Request */


  /********************************************************************/
  /*                            Class Prequest                        */
  /********************************************************************/

  class Prequest : public Request
  {

    public:

      /* construction */

      Prequest() { }

      Prequest(const Request& p) : Request(p) { }

      Prequest(const MPI_Request &i) : Request(i) { }

      /* assignment */

      Prequest& operator=(const Prequest& r)
      {
        mpi_request = r.mpi_request;
        return *this;
      }

      /* assignment (needed because of MPI::REQUEST_NULL) */

      Prequest& operator=(const Request& r)
      {
        mpi_request = r;
        return *this;
      }

      /* comparison operators inherited from Base class */

      /* inter-language operability operators (cast operator inherited from Base class) */

      Prequest& operator=(const MPI_Request& i)
      {
         mpi_request = i;
         return *this;
      }

      /*****************/
      /* Start Methods */
      /*****************/

      virtual void Start();

      static void Startall(int count, Prequest array_of_requests[]);

  }; /* MPI::PRequest */

  /********************************************************************/
  /*                            Class Status                          */
  /********************************************************************/

  class Status
  {

    friend class MPI::Comm;    /* so we can access pmpi_status data member in Comm */
    friend class MPI::Request; /* and also from Request */

    public:


      /* construction */

      Status() { }

      Status(const Status& data) : mpi_status(data.mpi_status) { }

      Status(const MPI_Status &i) : mpi_status(i) { }

      /* assignment */

      Status& operator=(const Status& data)
      {
        mpi_status = data.mpi_status;
        return *this;
      }

      /* comparison, don't need for status */

      /* inter-language operability operators */

      Status& operator= (const MPI_Status &i)
      {
        mpi_status = i;
        return *this;
      }

      operator MPI_Status () const
      {
        return mpi_status;
      }

      /* interlanguage comparison, don't need for status */

      /* destruction */

      virtual ~Status() {}


      /*******************/
      /* Get/Set Methods */
      /*******************/

      virtual int Get_count(const Datatype& datatype) const;

      virtual int Get_elements(const Datatype& datatype) const;

      virtual void Set_source(int source);

      virtual int Get_source() const;

      virtual void Set_tag(int tag);

      virtual int Get_tag() const;

      virtual void Set_error(int error);

      virtual int Get_error() const;

      virtual void Set_elements(const Datatype& datatype, int count);

      virtual void Set_cancelled(bool flag);

      /********/
      /* Misc */
      /********/

      virtual bool Is_cancelled() const;

    protected:

        MPI_Status mpi_status;

  }; /* MPI::Status */

  /********************************************************************/
  /*                            Class Cartcomm                        */
  /********************************************************************/

  class Cartcomm : public Intracomm
  {

    public:

      /* construction */

      Cartcomm() { }

      Cartcomm(const MPI_Comm& data);

      Cartcomm(const Cartcomm& data) : Intracomm(data.mpi_comm) { }

      /* assignment */

      Cartcomm& operator=(const Cartcomm& data)
      {
        mpi_comm = data.mpi_comm;
        return *this;
      }

      /* comparison operators inherited from Base class */

      /* inter-language operability operators (cast operator inherited from Base class) */

      Cartcomm& operator=(const MPI_Comm& data)
      {
        mpi_comm = data;
        return *this;
      }

      /* destruction */

      virtual ~Cartcomm() { }


      /************************/
      /*  Process Topologies  */
      /************************/

      virtual int Get_dim() const;

      virtual void Get_topo(int maxdims, int dims[], bool periods[], int coords[]) const;

      virtual int Get_cart_rank(const int coords[]) const;

      virtual void Get_coords(int rank, int maxdims, int coords[]) const;

      virtual void Shift(int direction, int disp, int &rank_source, int &rank_dest) const;

      virtual Cartcomm Sub(const bool remain_dims[]);

      virtual int Map(int ndims, const int dims[], const bool periods[]) const;

      /********/
      /* Misc */
      /********/

      Cartcomm Dup() const; /* not virtual ! */

      virtual Cartcomm& Clone() const;

  }; /* MPI::Cartcomm */


  /********************************************************************/
  /*                            Class Graphcomm                       */
  /********************************************************************/

  class Graphcomm :  public Intracomm
  {

    public:

      /* construction */

      Graphcomm() { }

      Graphcomm(const MPI_Comm& data);

      Graphcomm(const Graphcomm& data) : Intracomm(data.mpi_comm) { }

      /* assignment */

      Graphcomm& operator=(const Graphcomm& data)
      {
        mpi_comm = data.mpi_comm;
        return *this;
      }

      /* comparison operators inherited from Base class */

      /* inter-language operability operators (cast operator inherited from Base class) */

      Graphcomm& operator=(const MPI_Comm& data)
      {
        mpi_comm = data;
        return *this;
      }

      /************************/
      /*  Process Topologies  */
      /************************/

      virtual void Get_dims(int nnodes[], int nedges[]) const;

      virtual void Get_topo(int maxindex, int maxedges, int index[], int edges[]) const;

      virtual int Get_neighbors_count(int rank) const;

      virtual void Get_neighbors(int rank, int maxneighbors, int neighbors[]) const;

      virtual int Map(int nnodes, const int index[], const int edges[]) const;

      /********/
      /* Misc */
      /********/

      Graphcomm Dup() const; /* not virtual ! */

      virtual Graphcomm& Clone() const;


  }; /* MPI::Cartcomm */

  /********************************************************************/
  /*                            Class Win                             */
  /********************************************************************/

  class Win{

    public:

      /* typedef for user defined Win errorhandler */

      typedef void Errhandler_fn(Win&, int*, ...);

      /* typedefs for attribute caching  */

      typedef int Copy_attr_function(const Win& oldwin, int win_keyval, void* extra_state, const void* attribute_val_in, void* attribute_val_out, bool& flag);
      typedef int Delete_attr_function(Win& win, int win_keyval, void* attribute_val, void* extra_state);


      /* construction */

      Win() : mpi_win(MPI_WIN_NULL){}

      Win(const Win &w): mpi_win(w.mpi_win){}

      Win(const MPI_Win& w) : mpi_win(w){}


      /* assignment */

      Win& operator=(const Win& w)
      {
         mpi_win = w.mpi_win;
         return *this;
      }

      /* comparison */

      bool operator==(const Win& w) const
      {
         return (bool)(mpi_win == w.mpi_win);
      }

      bool operator!=(const Win& w) const
      {
         return (bool)(mpi_win != w.mpi_win);
      }

      /* inter-language operability operators */

      Win& operator=(const MPI_Win &w)
      {
         mpi_win = w;
         return *this;
      }

      operator MPI_Win() const
      {
        return mpi_win;
      }

      bool operator==(const MPI_Win& data) const
      {
        return(mpi_win == data);
      }

      bool operator!=(const MPI_Win& data) const
      {
        return(mpi_win != data);
      }

      /* destruction */

      virtual ~Win(){}

      /***********************/
      /* Keys and Attributes */
      /***********************/

      virtual bool Get_attr(int win_keyval, void* attribute_val) const;

      virtual void Set_attr(int win_keyval, const void* attribute_val);

      virtual void Delete_attr(int win_keyval);

      static int Create_keyval(Copy_attr_function* win_copy_attr_fn, Delete_attr_function* win_delete_attr_fn, void* extra_state);

      static void Free_keyval(int& win_keyval);

      /****************/
      /* Errorhandler */
      /****************/

      virtual void Set_errhandler(const Errhandler& errhandler);

      virtual Errhandler Get_errhandler() const;

      static Errhandler Create_errhandler(Errhandler_fn* function);

      virtual void Call_errhandler(int errorcode) const;

      /********/
      /* Misc */
      /********/

      virtual void Free();

      virtual Group Get_group() const;

      virtual void Put(const void* origin_addr, int origin_count, const Datatype& origin_datatype, int target_rank, Aint target_disp, int target_count, const Datatype& target_datatype) const;

      virtual void Get(void* origin_addr, int origin_count, const Datatype& origin_datatype, int target_rank, Aint target_disp, int target_count, const Datatype& target_datatype) const;

      virtual void Accumulate(const void* origin_addr, int origin_count, const Datatype& origin_datatype, int target_rank, Aint target_disp, int target_count, const Datatype& target_datatype, const Op& op) const;

      virtual void Fence(int assert) const;

      virtual void Start(const Group& group, int assert) const;

      virtual void Complete() const;

      virtual void Post(const Group& group, int assert) const;

      virtual void Wait() const;

      virtual bool Test() const;

      virtual void Lock(int lock_type, int rank, int assert) const;

      virtual void Unlock(int rank) const;

      static Win Create(const void* base, Aint size, int disp_unit, const Info& info, const Intracomm& comm);

      virtual void Set_name(const char* win_name);

      virtual void Get_name(char* win_name, int& resultlen) const;


      /* predefined functions for attribute caching */

      static int NULL_COPY_FN(const Win& oldwin, int win_keyval, void* extra_state, const void* attribute_val_in, void* attribute_val_out, bool& flag);

      static int DUP_FN(const Win& oldwin, int win_keyval, void* extra_state, const void* attribute_val_in, void* attribute_val_out, bool& flag);

      static int NULL_DELETE_FN(Win& win, int win_keyval, void* attribute_val, void* extra_state);

    private:

      MPI_Win mpi_win;

      static void _set_cpp_err_lang_flag(MPI_Errhandler err);
      static void _set_cpp_key_lang_flag(int key);

  }; /* MPI::Win */

  /********************************************************************/
  /*                            Class Grequest                        */
  /********************************************************************/

  class Grequest : public Request
  {

    public:

      /* typedefs for grequest callback functions */  

      typedef int Query_function(void* extra_state, MPI::Status& status);

      typedef int Free_function(void* extra_state);

      typedef int Cancel_function(void *extra_state, bool complete);
  
      /* construction */

      Grequest() { }

      Grequest(const Request& g) : Request(g) { }

      Grequest(const MPI_Request &i) : Request(i) { } 

      /* assignment */ 

      Grequest& operator=(const Grequest& r)
      {
        mpi_request = r.mpi_request;
        return *this;
      }

      /* assignment (needed because of MPI::REQUEST_NULL) */

      Grequest& operator=(const Request& r)
      {
        mpi_request = r;
        return *this;
      }

      /* comparison operators inherited from Base class */

      /* inter-language operability operators (cast operator inherited from Base class) */

      Grequest& operator=(const MPI_Request& i)
      {
         mpi_request = i;
         return *this;
      }

      /*****************/
      /*    Methods    */
      /*****************/

      static MPI::Grequest Start(MPI::Grequest::Query_function query_fn, 
                                 MPI::Grequest::Free_function free_fn, 
                                 MPI::Grequest::Cancel_function cancel_fn, 
                                 void *extra_state);

      virtual void Complete();

      private:
        
      static void _set_cpp_req_lang_flag(MPI_Request *request);

  }; /* MPI::Grequest */

 private:
   MPI() { }

   static void _set_cpp_datarep_lang_flag(const char* datarep);



 }; /* MPI */

/*******************************************************************************/
/*                                                                             */
/*    definition of all inlined MPI member functions                           */
/*                                                                             */
/*******************************************************************************/


/********************************************************************/
/*                            MPI functions                         */
/********************************************************************/


inline void
MPI::Attach_buffer(void* buffer, int size)
{
  (void)MPI_Buffer_attach(buffer, size);
}

inline int
MPI::Detach_buffer(void*& buffer)
{
  int size;
  (void)MPI_Buffer_detach(&buffer, &size);
  return size;
}

inline void
MPI::Compute_dims(int nnodes, int ndims, int dims[])
{
  (void)MPI_Dims_create(nnodes, ndims, dims);
}

inline void
MPI::Get_processor_name(char*& name, int& resultlen)
{
  (void)MPI_Get_processor_name(name, &resultlen);
}

inline void
MPI::Get_error_string(int errorcode, char* string, int& resultlen)
{
  (void)MPI_Error_string(errorcode, string, &resultlen);
}

inline int
MPI::Get_error_class(int errorcode)
{
  int errorclass;
  (void)MPI_Error_class(errorcode, &errorclass);
  return errorclass;
}

inline int
MPI::Add_error_class()
{
  int errorclass;
  (void)MPI_Add_error_class(&errorclass);
  return errorclass;
}

inline int
MPI::Add_error_code(int errorclass)
{
  int errorcode;
  (void)MPI_Add_error_code(errorclass, &errorcode);
  return errorcode;
}

inline void
MPI::Add_error_string(int errorcode, const char* string)
{
  (void)MPI_Add_error_string(errorcode, (char*)string);
}

inline int
MPI::Init_thread(int& argc, char**& argv, int required)
{
   int provided;
   (void)MPI_Init_thread(&argc, &argv, required, &provided);
   return(provided);
}

inline int
MPI::Init_thread(int required)
{
   int provided;
   (void)MPI_Init_thread(0,0,required, &provided);
   return(provided);
}

inline int
MPI::Query_thread()
{
   int provided;
   (void)MPI_Query_thread(&provided);
   return(provided);
}

inline bool
MPI::Is_thread_main()
{
   int t;
   (void)MPI_Is_thread_main(&t);
   if(t) return(true); else return(false);
}

inline double
MPI::Wtime()
{
  return (MPI_Wtime());
}

inline double
MPI::Wtick()
{
  return (MPI_Wtick());
}

inline void
MPI::Init(int& argc, char**& argv)
{
  (void)MPI_Init(&argc, &argv);
}

inline void
MPI::Init()
{
  (void)MPI_Init(0, 0);
}

inline void
MPI::Finalize()
{
  (void)MPI_Finalize();
}

inline bool
MPI::Is_initialized()
{
  int t;
  (void)MPI_Initialized(&t);
  if(t) return(true); else return(false);
}

inline bool
MPI::Is_finalized()
{
  int t;
  (void)MPI_Finalized(&t);
  if(t) return(true); else return(false);
}

inline MPI::Aint
MPI::Get_address(void* location)
{
  MPI::Aint ret;
  (void)MPI_Get_address(location, &ret);
  return ret;
}

inline void
MPI::Get_version(int& version, int& subversion)
{
  (void)MPI_Get_version(&version,&subversion);
}

inline void*
MPI::Alloc_mem(MPI::Aint size, const MPI::Info& info)
{
  void* retval;
  (void)MPI_Alloc_mem(size, info, &retval);
  return retval;
}

inline void
MPI::Free_mem(void *base)
{
  (void)MPI_Free_mem(base);
}

inline void
MPI::Register_datarep(const char* datarep,
                             MPI::Datarep_conversion_function* read_conversion_fn,
                             MPI::Datarep_conversion_function* write_conversion_fn,
                             MPI::Datarep_extent_function* dtype_file_extent_fn,
                             void* extra_state)
{
   (void)MPI_Register_datarep((char*)datarep,
                        (MPI_Datarep_conversion_function*) read_conversion_fn,
                        (MPI_Datarep_conversion_function*) write_conversion_fn,
                        (MPI_Datarep_extent_function*) dtype_file_extent_fn,
                        extra_state);

   _set_cpp_datarep_lang_flag(datarep);
}

inline void
MPI::Pcontrol(const int level, ...)
{
  (void)MPI_Pcontrol(level);
}



/********************************************************************/
/*                            Class Comm                            */
/********************************************************************/


inline void
MPI::Comm::Send(const void *buf, int count, const MPI::Datatype & datatype, int dest, int tag) const
{
  (void)MPI_Send((void *)buf, count, datatype, dest, tag, mpi_comm);
}

inline void
MPI::Comm::Recv(void *buf, int count, const MPI::Datatype & datatype, int source, int tag, MPI::Status & status) const
{
  (void)MPI_Recv(buf, count, datatype, source, tag, mpi_comm, &status.mpi_status);
}

inline void
MPI::Comm::Recv(void *buf, int count, const MPI::Datatype & datatype,
                                    int source, int tag) const
{
  (void)MPI_Recv(buf, count, datatype, source, tag, mpi_comm, MPI_STATUS_IGNORE);
}

inline void
MPI::Comm::Bsend(const void *buf, int count, const MPI::Datatype & datatype, int dest, int tag) const
{
  (void)MPI_Bsend((void *)buf, count, datatype, dest, tag, mpi_comm);
}

inline void
MPI::Comm::Ssend(const void *buf, int count, const MPI::Datatype & datatype, int dest, int tag) const
{
  (void)MPI_Ssend((void *)buf, count,  datatype, dest, tag, mpi_comm);
}

inline void
MPI::Comm::Rsend(const void *buf, int count, const MPI::Datatype & datatype, int dest, int tag) const
{
  (void)MPI_Rsend((void *)buf, count, datatype, dest, tag, mpi_comm);
}

inline MPI::Request
MPI::Comm::Isend(const void *buf, int count, const MPI::Datatype & datatype, int dest, int tag) const
{
  MPI_Request request;
  (void)MPI_Isend((void *)buf, count, datatype, dest, tag, mpi_comm, &request);
  return request;
}

inline MPI::Request
MPI::Comm::Ibsend(const void *buf, int count, const MPI::Datatype & datatype, int dest, int tag) const
{
  MPI_Request request;
  (void)MPI_Ibsend((void *)buf, count, datatype, dest, tag, mpi_comm, &request);
  return request;
}

inline MPI::Request
MPI::Comm::Issend(const void *buf, int count, const MPI::Datatype & datatype, int dest, int tag) const
{
  MPI_Request request;
  (void)MPI_Issend((void *)buf, count, datatype, dest, tag, mpi_comm, &request);
  return request;
}

inline MPI::Request
MPI::Comm::Irsend(const void *buf, int count, const MPI::Datatype & datatype, int dest, int tag) const
{
  MPI_Request request;
  (void)MPI_Irsend((void *) buf, count, datatype, dest, tag, mpi_comm, &request);
  return request;
}

inline MPI::Request
MPI::Comm::Irecv(void *buf, int count, const MPI::Datatype & datatype, int source, int tag) const
{
  MPI_Request request;
  (void)MPI_Irecv(buf, count, datatype, source, tag, mpi_comm, &request);
  return request;
}


inline bool
MPI::Comm::Iprobe(int source, int tag, MPI::Status & status) const
{
  int t;
  (void)MPI_Iprobe(source, tag, mpi_comm, &t, &status.mpi_status);
  if(t) return(true); else return(false);
}

inline bool
MPI::Comm::Iprobe(int source, int tag) const
{
  int t;
  (void)MPI_Iprobe(source, tag, mpi_comm, &t, MPI_STATUS_IGNORE);
  if(t) return(true); else return(false);
}

inline void
MPI::Comm::Probe(int source, int tag, MPI::Status & status) const
{
  (void)MPI_Probe(source, tag, mpi_comm, &status.mpi_status);
}

inline void
MPI::Comm::Probe(int source, int tag) const
{
  (void)MPI_Probe(source, tag, mpi_comm, MPI_STATUS_IGNORE);
}

inline MPI::Prequest
MPI::Comm::Send_init(const void *buf, int count, const MPI::Datatype & datatype, int dest, int tag) const
{
  MPI_Request request;
  (void)MPI_Send_init((void *)buf, count, datatype, dest, tag, mpi_comm, &request);
  return request;
}

inline MPI::Prequest
MPI::Comm::Bsend_init(const void *buf, int count, const MPI::Datatype & datatype, int dest, int tag) const
{
  MPI_Request request;
  (void)MPI_Bsend_init((void *)buf, count, datatype, dest, tag, mpi_comm, &request);
  return request;
}

inline MPI::Prequest
MPI::Comm::Ssend_init(const void *buf, int count, const MPI::Datatype & datatype, int dest, int tag) const
{
  MPI_Request request;
  (void)MPI_Ssend_init((void *)buf, count, datatype, dest, tag, mpi_comm, &request);
  return request;
}

inline MPI::Prequest
MPI::Comm::Rsend_init(const void *buf, int count, const MPI::Datatype & datatype, int dest, int tag) const
{
  MPI_Request request;
  (void)MPI_Rsend_init((void *)buf, count,  datatype, dest, tag, mpi_comm, &request);
  return request;
}

inline MPI::Prequest
MPI::Comm::Recv_init(void *buf, int count, const MPI::Datatype & datatype, int source, int tag) const
{
  MPI_Request request;
  (void)MPI_Recv_init(buf, count, datatype, source, tag, mpi_comm, &request);
  return request;
}

inline void
MPI::Comm::Sendrecv(const void *sendbuf, int sendcount, const MPI::Datatype & sendtype, int dest, int sendtag,
                           void *recvbuf, int recvcount, const MPI::Datatype & recvtype, int source,
                           int recvtag, MPI::Status & status) const
{
  (void)MPI_Sendrecv((void *)sendbuf, sendcount, sendtype, dest, sendtag, recvbuf, recvcount, recvtype,
                     source, recvtag, mpi_comm, &status.mpi_status);
}

inline void
MPI::Comm::Sendrecv(const void *sendbuf, int sendcount,
                           const MPI::Datatype & sendtype, int dest, int sendtag,
                           void *recvbuf, int recvcount, const MPI::Datatype & recvtype, int source,
                           int recvtag) const
{
  (void)MPI_Sendrecv((void *)sendbuf, sendcount, sendtype, dest, sendtag, recvbuf, recvcount, recvtype,
                     source, recvtag, mpi_comm, MPI_STATUS_IGNORE);
}

inline void
MPI::Comm::Sendrecv_replace(void *buf, int count, const MPI::Datatype & datatype, int dest,
                                   int sendtag, int source, int recvtag, MPI::Status & status) const
{
  (void)MPI_Sendrecv_replace(buf, count, datatype, dest, sendtag, source, recvtag, mpi_comm, &status.mpi_status);
}

inline void
MPI::Comm::Sendrecv_replace(void *buf, int count, const MPI::Datatype & datatype, int dest,
                            int sendtag, int source, int recvtag) const
{
  (void)MPI_Sendrecv_replace(buf, count, datatype, dest, sendtag, source, recvtag, mpi_comm, MPI_STATUS_IGNORE);
}

inline void
MPI::Comm::Barrier() const
{
  (void)MPI_Barrier(mpi_comm);
}

inline void
MPI::Comm::Bcast(void *buffer, int count, const MPI::Datatype& datatype, int root) const
{
  (void)MPI_Bcast(buffer, count, datatype, root, mpi_comm);
}

inline void
MPI::Comm::Gather(const void *sendbuf, int sendcount, const MPI::Datatype & sendtype, void *recvbuf, int recvcount, const MPI::Datatype & recvtype, int root) const
{
  (void)MPI_Gather((void *)sendbuf, sendcount, sendtype, recvbuf, recvcount, recvtype, root, mpi_comm);
}

inline void
MPI::Comm::Gatherv(const void *sendbuf, int sendcount,
                               const MPI::Datatype & sendtype, void *recvbuf,
                               const int recvcounts[], const int displs[],
                               const MPI::Datatype & recvtype, int root) const
{
  (void)MPI_Gatherv((void *)sendbuf, sendcount,  sendtype, recvbuf, (int *)recvcounts, (int *)displs, recvtype, root, mpi_comm);
}

inline void
MPI::Comm::Scatter(const void *sendbuf, int sendcount, const MPI::Datatype & sendtype, void *recvbuf, int recvcount, const MPI::Datatype & recvtype, int root) const
{
  (void)MPI_Scatter((void *)sendbuf, sendcount, sendtype, recvbuf, recvcount, recvtype, root, mpi_comm);
}

inline void
MPI::Comm::Scatterv(const void *sendbuf, const int sendcounts[], const int displs[], const MPI::Datatype & sendtype, void *recvbuf, int recvcount, const MPI::Datatype & recvtype, int root) const 
{
  (void)MPI_Scatterv((void *)sendbuf, (int *) sendcounts, (int *) displs, sendtype, recvbuf, recvcount, recvtype, root, mpi_comm);
}

inline void
MPI::Comm::Allgather(const void *sendbuf, int sendcount, const MPI::Datatype & sendtype, void *recvbuf, int recvcount, const MPI::Datatype & recvtype) const
{
  (void)MPI_Allgather((void *) sendbuf, sendcount, sendtype, recvbuf, recvcount, recvtype, mpi_comm);
}

inline void
MPI::Comm::Allgatherv(const void *sendbuf, int sendcount, const MPI::Datatype & sendtype, void *recvbuf, const int recvcounts[], const int displs[], const MPI::Datatype & recvtype) const
{
  (void)MPI_Allgatherv((void *)sendbuf, sendcount, sendtype, recvbuf, (int *) recvcounts, (int *) displs, recvtype, mpi_comm);
}

inline void
MPI::Comm::Alltoall(const void *sendbuf, int sendcount, const MPI::Datatype & sendtype, void *recvbuf, int recvcount, const MPI::Datatype & recvtype) const{
  (void)MPI_Alltoall((void *) sendbuf, sendcount, sendtype, recvbuf, recvcount, recvtype, mpi_comm);
}

inline void
MPI::Comm::Alltoallv(const void *sendbuf, const int sendcounts[], const int sdispls[], const MPI::Datatype & sendtype, void *recvbuf, const int recvcounts[], const int rdispls[], const MPI::Datatype & recvtype) const
{
    (void)MPI_Alltoallv((void *) sendbuf, (int *) sendcounts, (int *) sdispls, sendtype, recvbuf, (int *) recvcounts, (int *) rdispls, recvtype,mpi_comm);
}

inline void
MPI::Comm::Alltoallw(const void *sendbuf, const int sendcounts[], const int sdispls[], const MPI::Datatype sendtypes[], void *recvbuf, const int recvcounts[], const int rdispls[], const MPI::Datatype recvtypes[]) const
{
    int i,gsize;
    MPI_Comm_size(mpi_comm, &gsize);
    MPI_Datatype* sendtype_array = new MPI_Datatype[gsize];
    MPI_Datatype* recvtype_array = new MPI_Datatype[gsize];
    for (i=0; i < gsize; i++)
    { 
       sendtype_array[i] = sendtypes[i];
       recvtype_array[i] = recvtypes[i];
    }
    (void)MPI_Alltoallw((void *) sendbuf, (int *) sendcounts, (int *) sdispls, sendtype_array, recvbuf, (int *) recvcounts, (int *) rdispls, recvtype_array, mpi_comm);
    delete [] sendtype_array;
    delete [] recvtype_array;
}

inline void
MPI::Comm::Reduce(const void *sendbuf, void *recvbuf, int count, const MPI::Datatype & datatype, const MPI::Op& op, int root) const
{
  (void)MPI_Reduce((void*)sendbuf, recvbuf, count, datatype, op, root, mpi_comm);
}

inline void
MPI::Comm::Allreduce(const void *sendbuf, void *recvbuf, int count, const MPI::Datatype & datatype, const MPI::Op& op) const
{
  (void)MPI_Allreduce ((void*)sendbuf, recvbuf, count, datatype,  op, mpi_comm);
}

inline void
MPI::Comm::Reduce_scatter(const void *sendbuf, void *recvbuf, int recvcounts[], const MPI::Datatype & datatype, const MPI::Op& op) const
{
  (void)MPI_Reduce_scatter((void*)sendbuf, recvbuf, recvcounts, datatype, op, mpi_comm);
}

inline MPI::Group
MPI::Comm::Get_group() const
{
  MPI_Group group;
  (void)MPI_Comm_group(mpi_comm, &group);
  return group;
}

inline int
MPI::Comm::Get_size() const
{
  int size;
  (void)MPI_Comm_size (mpi_comm, &size);
  return size;
}


inline int
MPI::Comm::Get_rank() const
{
  int rank;
  (void)MPI_Comm_rank (mpi_comm, &rank);
  return rank;
}

inline void
MPI::Comm::Get_name(char* comm_name, int& resultlen) const
{
  (void)MPI_Comm_get_name(mpi_comm, comm_name, &resultlen);
}

inline void
MPI::Comm::Set_name(const char* comm_name)
{
  (void)MPI_Comm_set_name(mpi_comm, (char*)comm_name);
}

inline int
MPI::Comm::Compare(const MPI::Comm & comm1, const MPI::Comm & comm2)
{
  int result;
  (void)MPI_Comm_compare(comm1, comm2, &result);
  return result;
}

inline void
MPI::Comm::Free(void)
{
  (void)MPI_Comm_free(&mpi_comm);
}

inline bool
MPI::Comm::Is_inter() const
{
  int t;
  (void)MPI_Comm_test_inter(mpi_comm, &t);
  if(t) return(true); else return(false);
}

inline int
MPI::Comm::Get_topology() const
{
  int status;
  (void)MPI_Topo_test(mpi_comm, &status);
  return status;
}

inline void
MPI::Comm::Abort(int errorcode)
{
  (void)MPI_Abort(mpi_comm, errorcode);
}

inline void
MPI::Comm::Set_errhandler(const MPI::Errhandler& errhandler)
{
  (void)MPI_Comm_set_errhandler(mpi_comm, errhandler);
}

inline MPI::Errhandler
MPI::Comm::Get_errhandler() const
{
  MPI_Errhandler eh;
  (void)MPI_Comm_get_errhandler(mpi_comm,&eh);
  return eh;
}

inline void
MPI::Comm::Call_errhandler(int errorcode) const
{
  (void)MPI_Comm_call_errhandler(mpi_comm, errorcode);
}

inline MPI::Errhandler
MPI::Comm::Create_errhandler(MPI::Comm::Errhandler_fn* function)
{
  MPI_Errhandler errhandler;
  if(MPI_Comm_create_errhandler((MPI_Comm_errhandler_fn*)function, &errhandler) == MPI_SUCCESS)
  {
    _set_cpp_err_lang_flag(errhandler);
  }
  return errhandler;
}

inline int
MPI::Comm::Create_keyval(MPI::Comm::Copy_attr_function* comm_copy_attr_fn,
                                MPI::Comm::Delete_attr_function* comm_delete_attr_fn,
                                void* extra_state)
{
  int keyval;
  if(MPI_Comm_create_keyval((MPI_Comm_copy_attr_function*) comm_copy_attr_fn, (MPI_Comm_delete_attr_function*) comm_delete_attr_fn,
                       &keyval, extra_state) == MPI_SUCCESS)
  {
    _set_cpp_key_lang_flag(keyval);
  }
  return keyval;
}

inline void
MPI::Comm::Free_keyval(int& comm_keyval)
{
  (void)MPI_Comm_free_keyval(&comm_keyval);
}

inline void
MPI::Comm::Set_attr(int comm_keyval, const void* attribute_val) const
{
  (void)MPI_Comm_set_attr(mpi_comm, comm_keyval, (void*)attribute_val);
}

inline bool
MPI::Comm::Get_attr(int comm_keyval, void* attribute_val) const
{
  int flag;
  (void)MPI_Comm_get_attr(mpi_comm, comm_keyval, attribute_val, &flag);
  if(flag) return(true); else return(false);
}

inline void
MPI::Comm::Delete_attr(int comm_keyval)
{
  (void)MPI_Comm_delete_attr(mpi_comm, comm_keyval);
}

/* predefined functions for attribute caching */

inline int
MPI::Comm::NULL_COPY_FN(const MPI::Comm& oldcomm, int comm_keyval,
                               void* extra_state, const void* attribute_val_in,
                               void* attribute_val_out, bool& flag)
{
  flag = false;
  return MPI::SUCCESS;
}

inline int
MPI::Comm::DUP_FN(const MPI::Comm& oldcomm, int comm_keyval,
                         void* extra_state, const void* attribute_val_in,
                         void* attribute_val_out, bool& flag)
{
   flag = true;
   *((void **)attribute_val_out) = (void*)attribute_val_in;
   return(MPI::SUCCESS);
}

inline int
MPI::Comm::NULL_DELETE_FN(MPI::Comm& comm, int comm_keyval, void* attribute_val, void* extra_state)
{
  return MPI::SUCCESS;
}



/********************************************************************/
/*                            Class Datatype                        */
/********************************************************************/


inline void
MPI::Datatype::Get_contents(int max_integers, int max_addresses,
                                   int max_datatypes, int array_of_integers[],
                                   MPI::Aint array_of_addresses[],
                                   MPI::Datatype array_of_datatypes[]) const
{
  MPI_Datatype *datatypes_tmp;
  datatypes_tmp = new MPI_Datatype[max_datatypes];
  (void)MPI_Type_get_contents(mpi_datatype,max_integers,max_addresses,max_datatypes,
                              array_of_integers, array_of_addresses, datatypes_tmp);
  for(int i = 0; i < max_datatypes; i++)
  {
    array_of_datatypes[i] = datatypes_tmp[i];
  }
  delete [] datatypes_tmp;
}

inline void
MPI::Datatype::Get_envelope(int& num_integers, int& num_addresses, int& num_datatypes, int& combiner) const
{
  (void)MPI_Type_get_envelope(mpi_datatype,&num_integers, &num_addresses,&num_datatypes,&combiner);
}

inline MPI::Datatype
MPI::Datatype::Create_darray(int size, int rank,
                                    int ndims,
                                    const int array_of_gsizes[],
                                    const int array_of_distribs[],
                                    const int array_of_dargs[],
                                    const int array_of_psizes[],
                                    int order) const
{
  MPI_Datatype newtype;
  (void)MPI_Type_create_darray(size,rank,ndims, (int*)array_of_gsizes, (int*)array_of_distribs,
                               (int*)array_of_dargs, (int*)array_of_psizes,order, mpi_datatype, &newtype);
  return newtype;
}

inline MPI::Datatype
MPI::Datatype::Create_subarray(int ndims,
                                      const int array_of_sizes[],
                                      const int array_of_subsizes[],
                                      const int array_of_starts[],
                                      int order) const
{
  MPI_Datatype newtype;
  (void)MPI_Type_create_subarray(ndims,(int*)array_of_sizes,(int*)array_of_subsizes,
                                 (int*)array_of_starts,order,mpi_datatype,&newtype);
  return newtype;
}


inline MPI::Datatype
MPI::Datatype::Create_contiguous(int count) const
{
  MPI_Datatype newtype;
  (void)MPI_Type_contiguous(count, mpi_datatype, &newtype);
  return newtype;
}

inline MPI::Datatype
MPI::Datatype::Create_vector(int count, int blocklength, int stride) const
{
  MPI_Datatype newtype;
  (void)MPI_Type_vector(count, blocklength, stride, mpi_datatype, &newtype);
  return newtype;
}

inline MPI::Datatype
MPI::Datatype::Create_indexed(int count, const int array_of_blocklengths[], const int array_of_displacements[]) const
{
  MPI_Datatype newtype;
  (void)MPI_Type_indexed(count, (int *) array_of_blocklengths, (int *) array_of_displacements, mpi_datatype, &newtype);
  return newtype;
}
 
inline MPI::Datatype
MPI::Datatype::Create_indexed_block(int count, int blocklength, const int array_of_displacements
[]) const
{
  MPI_Datatype newtype;
  (void)MPI_Type_create_indexed_block(count, blocklength, (int *) array_of_displacements, mpi_datatype, &newtype);
  return newtype;
}

inline MPI::Datatype
MPI::Datatype::Create_hindexed(int count, const int array_of_blocklengths[],
                                      const MPI::Aint array_of_displacements[]) const
{
  MPI_Datatype newtype;
  (void)MPI_Type_create_hindexed(count, (int*)array_of_blocklengths, (MPI_Aint*)array_of_displacements, mpi_datatype, &newtype) ;
  return newtype;
}

inline MPI::Datatype
MPI::Datatype::Create_hvector(int count, int blocklength, MPI::Aint stride) const
{
  MPI_Datatype newtype;
  (void)MPI_Type_create_hvector(count, blocklength, (MPI_Aint)stride, mpi_datatype, &newtype);
  return newtype;
}

inline MPI::Datatype
MPI::Datatype::Create_resized(const MPI::Aint lb, const MPI::Aint extent) const
{
  MPI_Datatype newtype;
  (void)MPI_Type_create_resized(mpi_datatype, lb, extent, &newtype);
  return newtype;
}

inline int
MPI::Datatype::Get_size() const
{
  int size;
  (void)MPI_Type_size(mpi_datatype, &size);
  return size;
}

inline void
MPI::Datatype::Get_extent(MPI::Aint& lb, MPI::Aint& extent) const
{
  (void)MPI_Type_get_extent(mpi_datatype, &lb, &extent);
/*
  (void)MPI_Type_lb(mpi_datatype, &lb);
  (void)MPI_Type_extent(mpi_datatype, &extent);
*/
}

inline void
MPI::Datatype::Get_true_extent(MPI::Aint& true_lb, MPI::Aint& true_extent) const
{
  (void)MPI_Type_get_true_extent(mpi_datatype, &true_lb, &true_extent);
}

inline void
MPI::Datatype::Commit()
{
  (void)MPI_Type_commit(&mpi_datatype);
}

inline void
MPI::Datatype::Free()
{
  (void)MPI_Type_free(&mpi_datatype);
}

inline void
MPI::Datatype::Pack(const void* inbuf, int incount, void *outbuf, int outsize,
                           int& position, const MPI::Comm &comm) const
{
  (void)MPI_Pack((void *) inbuf, incount,  mpi_datatype, outbuf, outsize, &position, comm);
}

inline void
MPI::Datatype::Unpack(const void* inbuf, int insize, void *outbuf, int outcount, int& position,
                             const MPI::Comm& comm) const
{
  (void)MPI_Unpack((void *) inbuf, insize, &position, outbuf, outcount, mpi_datatype, comm);
}

inline int
MPI::Datatype::Pack_size(int incount, const MPI::Comm& comm) const
{
  int size;
  (void)MPI_Pack_size(incount, mpi_datatype, comm, &size);
  return size;
}

inline void
MPI::Datatype::Set_name(const char* type_name)
{
  (void)MPI_Type_set_name(mpi_datatype, (char*)type_name);
}

inline void
MPI::Datatype::Get_name(char* type_name, int& resultlen) const
{
  (void)MPI_Type_get_name(mpi_datatype, type_name, &resultlen);
}

inline void MPI::Datatype::Set_attr(int type_keyval, const void* attribute_val)
{
  (void)MPI_Type_set_attr(mpi_datatype, type_keyval, (void*)attribute_val);
}

inline bool MPI::Datatype::Get_attr(int type_keyval, void* attribute_val) const
{
  int flag;
  (void)MPI_Type_get_attr(mpi_datatype, type_keyval, attribute_val, &flag);
  if(flag) return(true); else return(false);
}

inline void MPI::Datatype::Delete_attr(int type_keyval)
{
  (void)MPI_Type_delete_attr(mpi_datatype, type_keyval);
}

inline MPI::Datatype MPI::Datatype::Dup() const
{
  MPI_Datatype newtype;
  (void)MPI_Type_dup(mpi_datatype, &newtype);
  return newtype;
}

/* static member functions: */

inline int MPI::Datatype::Create_keyval(MPI::Datatype::Copy_attr_function* type_copy_attr_fn,
                                               MPI::Datatype::Delete_attr_function* type_delete_attr_fn,
                                               void* extra_state)
{
  int keyval;
  if(MPI_Type_create_keyval((MPI_Type_copy_attr_function* ) type_copy_attr_fn,
                            (MPI_Type_delete_attr_function* ) type_delete_attr_fn,
                            &keyval, extra_state)  == MPI_SUCCESS)
  {
    _set_cpp_key_lang_flag(keyval);
  }
  return keyval;
}

inline void MPI::Datatype::Free_keyval(int& type_keyval)
{
  (void)MPI_Type_free_keyval(&type_keyval);
}


/* predefined functions for attribute caching: */

inline int
MPI::Datatype::NULL_COPY_FN(const MPI::Datatype& oldtype, int type_keyval,
                                   void* extra_state, const void* attribute_val_in,
                                   void* attribute_val_out, bool& flag)
{
  flag = false;
  return MPI::SUCCESS;
}

inline int
MPI::Datatype::DUP_FN(const MPI::Datatype& oldtype, int type_keyval,
                             void* extra_state, const void* attribute_val_in,
                             void* attribute_val_out, bool& flag)
{
   flag = true;
   *((void **)attribute_val_out) = (void*)attribute_val_in;
   return(MPI::SUCCESS);
}

inline int
MPI::Datatype::NULL_DELETE_FN(MPI::Datatype& type, int type_keyval, void* attribute_val, void* extra_state)
{
  return MPI::SUCCESS;
}


inline MPI::Datatype
MPI::Datatype::Create_struct(int count, const int array_of_blocklengths[],
                                    const MPI::Aint array_of_displacements[],
                                    const MPI::Datatype array_of_types[])
{
  MPI_Datatype newtype;
  int i;
  MPI_Datatype* type_array = new MPI_Datatype[count];
  for (i=0; i < count; i++)
  {
    type_array[i] = array_of_types[i];
  }
  (void)MPI_Type_create_struct(count, (int*)array_of_blocklengths, (MPI_Aint*)array_of_displacements, type_array, &newtype);
  delete [] type_array;
  return newtype;
}

inline MPI::Datatype
MPI::Datatype::Create_f90_real(int p, int r)
{
  MPI_Datatype newtype;
  (void)MPI_Type_create_f90_real(p, r, &newtype);
  return newtype;
}

inline MPI::Datatype
MPI::Datatype::Create_f90_complex(int p, int r)
{
  MPI_Datatype newtype;
  (void)MPI_Type_create_f90_complex(p, r, &newtype);
  return newtype;
}

inline MPI::Datatype
MPI::Datatype::Create_f90_integer(int r)
{
  MPI_Datatype newtype;
  (void)MPI_Type_create_f90_integer(r, &newtype);
  return newtype;
}

inline MPI::Datatype
MPI::Datatype::Match_size(int typeclass, int size)
{
  MPI_Datatype newtype;
  (void)MPI_Type_match_size(typeclass, size, &newtype);
  return newtype;
}

inline void
MPI::Datatype::Pack_external(const char* datarep, const  void* inbuf, int incount, void* outbuf, MPI::Aint outsize, MPI_Aint& position) const
{
  (void)MPI_Pack_external((char *)datarep, (void *) inbuf, incount, mpi_datatype, outbuf, outsize, &position);
}

inline void
MPI::Datatype::Unpack_external(const char* datarep, const void* inbuf, MPI::Aint insize, MPI::Aint& position, void* outbuf, int outcount) const
{
  (void)MPI_Unpack_external((char *)datarep, (void *) inbuf, insize, &position, outbuf, outcount, mpi_datatype);
}

inline MPI::Aint
MPI::Datatype::Pack_external_size(const char* datarep, int incount) const
{
  MPI::Aint size;
  (void)MPI_Pack_external_size((char *) datarep, incount, mpi_datatype, &size);
  return size;
}

/********************************************************************/
/*                            Class Errhandler                      */
/********************************************************************/


inline void
MPI::Errhandler::Free()
{
  (void)MPI_Errhandler_free(&mpi_errhandler);
}


/********************************************************************/
/*                            Class File                            */
/********************************************************************/

inline void
MPI::File::Call_errhandler(int errorcode) const
{
  (void)MPI_File_call_errhandler(mpi_file, errorcode);
}

inline void
MPI::File::Close()
{
  (void)MPI_File_close(&mpi_file);
}

inline MPI::Errhandler
MPI::File::Create_errhandler(MPI::File::Errhandler_fn* function)
{
  MPI_Errhandler errhandler;
  if(MPI_File_create_errhandler((MPI_File_errhandler_fn*)function, &errhandler)  == MPI_SUCCESS)
  {
    _set_cpp_err_lang_flag(errhandler);
  }
  MPI::Errhandler temp(errhandler);
  return temp;
}

inline int
MPI::File::Get_amode() const
{
  int retval;
  (void)MPI_File_get_amode(mpi_file,&retval);
  return retval;
}

inline bool
MPI::File::Get_atomicity() const
{
  int retval;
  (void)MPI_File_get_atomicity(mpi_file,&retval);
  if(retval) return(true); else return(false);
}

inline MPI::Errhandler
MPI::File::Get_errhandler() const
{
  MPI_Errhandler eh;
  (void)MPI_File_get_errhandler(mpi_file,&eh);
  return eh;
}

inline MPI::Group
MPI::File::Get_group() const
{
  MPI_Group group;
  (void)MPI_File_get_group(mpi_file,&group);
  return group;
}

inline MPI::Info
MPI::File::Get_info() const
{
  MPI_Info info;
  (void)MPI_File_get_info(mpi_file, &info);
  return info;
}


inline MPI::Offset
MPI::File::Get_size() const
{
  MPI_Offset size;
  (void)MPI_File_get_size(mpi_file, &size);
  return size;
}

inline void
MPI::File::Get_view(MPI::Offset& disp,MPI::Datatype& etype, MPI::Datatype& filetype,
                           char* datarep) const
{
  MPI_Datatype mpi_etype;
  MPI_Datatype mpi_filetype;
  (void)MPI_File_get_view(mpi_file, &disp, &mpi_etype, &mpi_filetype, datarep);
  etype = mpi_etype;
  filetype = mpi_filetype;
}

inline MPI::Request
MPI::File::Iread_at(MPI::Offset offset, void* buf, int count, const MPI::Datatype& datatype)
{
  MPI_Request  mpi_request;
  (void)MPI_File_iread_at(mpi_file,offset,buf,count,datatype,&mpi_request);
  return mpi_request;
}

inline MPI::Request
MPI::File::Iwrite_at(MPI::Offset offset, const void* buf, int count, const MPI::Datatype& datatype)
{
  MPI_Request  mpi_request;
  (void)MPI_File_iwrite_at(mpi_file,offset,(void*)buf,count,datatype,&mpi_request);
  return mpi_request;
}

inline void
MPI::File::Read_at(MPI::Offset offset, void* buf, int count, const MPI::Datatype& datatype)
{
  (void)MPI_File_read_at(mpi_file,offset,buf,count,datatype,MPI_STATUS_IGNORE);
}

inline void
MPI::File::Read_at(MPI::Offset offset, void *buf, int count, const MPI::Datatype& datatype,
                          MPI::Status& status)
{
  MPI_Status   mpi_status;
  (void)MPI_File_read_at(mpi_file,offset,buf,count,datatype,&mpi_status);
  status = mpi_status;
}

inline void
MPI::File::Read_at_all(MPI::Offset offset, void* buf, int count, const MPI::Datatype& datatype)
{
  (void)MPI_File_read_at_all(mpi_file,offset,buf,count,datatype,MPI_STATUS_IGNORE);
}

inline void
MPI::File::Read_at_all(MPI::Offset offset, void* buf, int count, const MPI::Datatype& datatype,
                              MPI::Status& status)
{
  MPI_Status   mpi_status;
  (void)MPI_File_read_at_all(mpi_file,offset,buf,count,datatype,&mpi_status);
  status = mpi_status;
}

inline void
MPI::File::Set_errhandler(const MPI::Errhandler& errhandler)
{
  (void)MPI_File_set_errhandler(mpi_file,errhandler);
}

inline void
MPI::File::Set_info(const MPI::Info& info)
{
  (void)MPI_File_set_info(mpi_file,info);
}

inline void MPI::File::Set_size(MPI::Offset size)
{
  (void)MPI_File_set_size(mpi_file,size);
}

inline void
MPI::File::Set_view(MPI::Offset disp, const MPI::Datatype& etype,
                           const MPI::Datatype& filetype, const char* datarep, const MPI::Info& info)
{
  (void)MPI_File_set_view(mpi_file,disp,etype,filetype,(char*)datarep,info);
}

inline void MPI::File::Sync()
{
  (void)MPI_File_sync(mpi_file);
}

inline void
MPI::File::Write_at(MPI::Offset offset, const void* buf, int count, const MPI::Datatype& datatype)
{
  (void)MPI_File_write_at(mpi_file,offset,(void*)buf,count,datatype,MPI_STATUS_IGNORE);
}

inline void
MPI::File::Write_at(MPI::Offset offset, const void* buf, int count, const MPI::Datatype& datatype,
                           MPI::Status& status)
{
  MPI_Status mpi_status;
  (void)MPI_File_write_at(mpi_file,offset,(void*)buf,count,datatype,&mpi_status);
  status = mpi_status;
}

inline void
MPI::File::Write_at_all(MPI::Offset offset, const void* buf, int count, const MPI::Datatype& datatype)
{
  (void)MPI_File_write_at_all(mpi_file,offset,(void*)buf,count,datatype,MPI_STATUS_IGNORE);
}

inline void
MPI::File::Write_at_all(MPI::Offset offset, const void* buf, int count, const MPI::Datatype& datatype,
                               MPI::Status& status)
{
  MPI_Status mpi_status;
  (void)MPI_File_write_at_all(mpi_file,offset,(void*)buf,count,datatype,&mpi_status);
  status = mpi_status;
}


inline void
MPI::File::Preallocate(MPI::Offset size)
{
  (void)MPI_File_preallocate(mpi_file, size);
}

inline void
MPI::File::Read(void* buf, int count, const MPI::Datatype& datatype)
{
  (void)MPI_File_read(mpi_file, buf, count, datatype, MPI_STATUS_IGNORE);
}

inline void
MPI::File::Read(void* buf, int count, const MPI::Datatype& datatype, MPI::Status& status)
{
  MPI_Status mpi_status;
  (void)MPI_File_read(mpi_file, buf, count, datatype, &mpi_status);
  status = mpi_status;
}

inline void
MPI::File::Read_all(void* buf, int count, const MPI::Datatype& datatype)
{
  (void)MPI_File_read_all(mpi_file, buf, count, datatype, MPI_STATUS_IGNORE);
}

inline void
MPI::File::Read_all(void* buf, int count, const MPI::Datatype& datatype, MPI::Status& status)
{
  MPI_Status mpi_status;
  (void)MPI_File_read_all(mpi_file, buf, count, datatype, &mpi_status);
  status = mpi_status;
}

inline void
MPI::File::Write(const void* buf, int count, const MPI::Datatype& datatype)
{
  (void)MPI_File_write(mpi_file, (void*)buf, count, datatype, MPI_STATUS_IGNORE);
}

inline void
MPI::File::Write(const void* buf, int count, const MPI::Datatype& datatype, MPI::Status& status)
{
  MPI_Status mpi_status;
  (void)MPI_File_write(mpi_file, (void*)buf, count, datatype, &mpi_status);
  status = mpi_status;
}

inline void
MPI::File::Write_all(const void* buf, int count, const MPI::Datatype& datatype)
{
  (void)MPI_File_write_all(mpi_file, (void*)buf, count, datatype, MPI_STATUS_IGNORE);
}

inline void
MPI::File::Write_all(const void* buf, int count, const MPI::Datatype& datatype, MPI::Status& status)
{
  MPI_Status mpi_status;
  (void)MPI_File_write_all(mpi_file, (void*)buf, count, datatype, &mpi_status);
  status = mpi_status;
}

inline MPI::Request
MPI::File::Iread(void* buf, int count, const MPI::Datatype& datatype)
{
  MPI_Request mpi_request;
  (void)MPI_File_iread(mpi_file, (void*)buf, count, datatype, &mpi_request);
  return mpi_request;
}

inline MPI::Request
MPI::File::Iwrite(const void* buf, int count, const MPI::Datatype& datatype)
{
  MPI_Request mpi_request;
  (void)MPI_File_iwrite(mpi_file, (void*)buf, count, datatype, &mpi_request);
  return mpi_request;
}

inline void
MPI::File::Seek(MPI::Offset offset, int whence)
{
  (void)MPI_File_seek(mpi_file, offset,whence);
}

inline MPI::Offset
MPI::File::Get_position() const
{
  MPI_Offset offset;
  (void)MPI_File_get_position(mpi_file, &offset);
  return offset;
}

inline MPI::Offset
MPI::File::Get_byte_offset(const MPI::Offset offset) const
{
  MPI_Offset disp;
  (void)MPI_File_get_byte_offset(mpi_file, offset, &disp);
  return disp;
}

inline void
MPI::File::Read_shared(void* buf, int count, const MPI::Datatype& datatype)
{
  (void)MPI_File_read_shared(mpi_file, buf, count,datatype, MPI_STATUS_IGNORE);
}

inline void
MPI::File::Read_shared(void* buf, int count, const MPI::Datatype& datatype, MPI::Status& status)
{
  MPI_Status mpi_status;
  (void)MPI_File_read_shared(mpi_file, buf, count,datatype, &mpi_status);
  status = mpi_status;
}

inline void
MPI::File::Write_shared(const void* buf, int count, const MPI::Datatype& datatype)
{
  (void)MPI_File_write_shared(mpi_file, (void*)buf, count, datatype,MPI_STATUS_IGNORE);
}

inline void
MPI::File::Write_shared(const void* buf, int count, const MPI::Datatype& datatype, MPI::Status& status)
{
  MPI_Status mpi_status;
  (void)MPI_File_write_shared(mpi_file, (void*)buf, count, datatype,&mpi_status);
  status = mpi_status;
}

inline MPI::Request
MPI::File::Iread_shared(void* buf, int count, const MPI::Datatype& datatype)
{
  MPI_Request mpi_request;
  (void)MPI_File_iread_shared(mpi_file, buf, count, datatype, &mpi_request);
  return mpi_request;
}

inline MPI::Request
MPI::File::Iwrite_shared(const void* buf, int count, const MPI::Datatype& datatype)
{
  MPI_Request mpi_request;
  (void)MPI_File_iwrite_shared(mpi_file, (void*)buf, count, datatype, &mpi_request);
  return mpi_request;
}

inline void
MPI::File::Read_ordered(void* buf, int count, const MPI::Datatype& datatype)
{
  (void)MPI_File_read_ordered(mpi_file, buf, count, datatype, MPI_STATUS_IGNORE);
}

inline void
MPI::File::Read_ordered(void* buf, int count, const MPI::Datatype& datatype, MPI::Status& status)
{
  MPI_Status mpi_status;
  (void)MPI_File_read_ordered(mpi_file, buf, count, datatype, &mpi_status);
  status = mpi_status;
}

inline void
MPI::File::Write_ordered(const void* buf, int count, const MPI::Datatype& datatype)
{
  (void)MPI_File_write_ordered(mpi_file, (void*)buf, count, datatype, MPI_STATUS_IGNORE);
}

inline void
MPI::File::Write_ordered(const void* buf, int count, const MPI::Datatype& datatype, MPI::Status& status)
{
  MPI_Status mpi_status;
  (void)MPI_File_write_ordered(mpi_file, (void*)buf, count, datatype, &mpi_status);
  status = mpi_status;
}

inline void
MPI::File::Seek_shared(MPI::Offset offset, int whence)
{
  (void)MPI_File_seek_shared(mpi_file, offset, whence);
}

inline MPI::Offset
MPI::File::Get_position_shared() const
{
  MPI_Offset offset;
  (void)MPI_File_get_position_shared(mpi_file, &offset);
  return offset;
}

inline void
MPI::File::Read_at_all_begin(MPI::Offset offset, void* buf, int count, const MPI::Datatype& datatype)
{
  (void)MPI_File_read_at_all_begin(mpi_file, offset, buf, count,datatype);
}

inline void
MPI::File::Read_at_all_end(void *buf)
{
  (void)MPI_File_read_at_all_end(mpi_file, buf, MPI_STATUS_IGNORE);
}

inline void
MPI::File::Read_at_all_end(void *buf, MPI::Status& status)
{
  MPI_Status mpi_status;
  (void)MPI_File_read_at_all_end(mpi_file, buf, &mpi_status);
  status = mpi_status;
}

inline void
MPI::File::Write_at_all_begin(MPI::Offset offset, const void* buf, int count, const MPI::Datatype& datatype)
{
  (void)MPI_File_write_at_all_begin(mpi_file, offset,(void*)buf, count, datatype);
}

inline void
MPI::File::Write_at_all_end(const void* buf)
{
  (void)MPI_File_write_at_all_end(mpi_file, (void*)buf, MPI_STATUS_IGNORE);
}

inline void
MPI::File::Write_at_all_end(const void* buf, MPI::Status& status)
{
  MPI_Status mpi_status;
  (void)MPI_File_write_at_all_end(mpi_file, (void*)buf, &mpi_status);
  status = mpi_status;
}

inline void
MPI::File::Read_all_begin(void* buf, int count, const MPI::Datatype& datatype)
{
  (void)MPI_File_read_all_begin(mpi_file, buf, count, datatype);
}

inline void
MPI::File::Read_all_end(void* buf)
{
  (void)MPI_File_read_all_end(mpi_file, buf, MPI_STATUS_IGNORE);
}

inline void
MPI::File::Read_all_end(void* buf, MPI::Status& status)
{
  MPI_Status mpi_status;
  (void)MPI_File_read_all_end(mpi_file, buf, &mpi_status);
  status = mpi_status;
}

inline void
MPI::File::Write_all_begin(const void* buf, int count, const MPI::Datatype& datatype)
{
  (void)MPI_File_write_all_begin(mpi_file, (void*)buf, count, datatype);
}

inline void
MPI::File::Write_all_end(const void* buf)
{
  (void)MPI_File_write_all_end(mpi_file, (void*)buf, MPI_STATUS_IGNORE);
}

inline void
MPI::File::Write_all_end(const void* buf, MPI::Status& status)
{
  MPI_Status mpi_status;
  (void)MPI_File_write_all_end(mpi_file, (void*)buf, &mpi_status);
  status = mpi_status;
}

inline void
MPI::File::Read_ordered_begin(void* buf, int count, const MPI::Datatype& datatype)
{
  (void)MPI_File_read_ordered_begin(mpi_file, buf, count, datatype);
}

inline void
MPI::File::Read_ordered_end(void* buf)
{
  (void)MPI_File_read_ordered_end(mpi_file, buf, MPI_STATUS_IGNORE);
}

inline void
MPI::File::Read_ordered_end(void* buf, MPI::Status& status)
{
  MPI_Status mpi_status;
  (void)MPI_File_read_ordered_end(mpi_file, buf, &mpi_status);
  status = mpi_status;
}

inline void
MPI::File::Write_ordered_begin(const void* buf, int count, const MPI::Datatype& datatype)
{
  (void)MPI_File_write_ordered_begin(mpi_file, (void*)buf, count, datatype);
}

inline void
MPI::File::Write_ordered_end(const void* buf)
{
  (void)MPI_File_write_ordered_end(mpi_file, (void*)buf, MPI_STATUS_IGNORE);
}

inline void
MPI::File::Write_ordered_end(const void* buf, MPI::Status& status)
{
  MPI_Status mpi_status;
  (void)MPI_File_write_ordered_end(mpi_file, (void*)buf, &mpi_status);
  status = mpi_status;
}

inline void
MPI::File::Set_atomicity(bool flag)
{
  (void)MPI_File_set_atomicity(mpi_file, flag);
}

inline MPI::Aint
MPI::File::Get_type_extent(const MPI::Datatype& datatype) const
{
  MPI_Aint extent;
  (void)MPI_File_get_type_extent(mpi_file, datatype, &extent);
  return extent;
}

/* static methods */

inline MPI::File
MPI::File::Open(const MPI::Intracomm& comm, const char* filename, int amode, const MPI::Info& info)
{
  MPI_File fh;
  (void)MPI_File_open(comm, (char*)filename, amode, info,&fh);
  return fh;
}

inline void
MPI::File::Delete(const char* filename, const MPI::Info& info)
{
  (void)MPI_File_delete((char*)filename,info);
}


/********************************************************************/
/*                            Class Group                           */
/********************************************************************/

inline int
MPI::Group::Get_size() const
{
  int size;
  (void)MPI_Group_size(mpi_group, &size);
  return size;
}

inline int
MPI::Group::Get_rank() const
{
  int rank;
  (void)MPI_Group_rank(mpi_group, &rank);
  return rank;
}

inline void
MPI::Group::Translate_ranks (const MPI::Group& group1, int n, const int ranks1[],
                                    const MPI::Group& group2, int ranks2[])
{
  (void)MPI_Group_translate_ranks(group1, n, (int*)ranks1, group2, (int*)ranks2);
}

inline int
MPI::Group::Compare(const MPI::Group& group1, const MPI::Group& group2)
{
  int result;
  (void)MPI_Group_compare(group1, group2, &result);
  return result;
}

inline MPI::Group
MPI::Group::Union(const MPI::Group &group1, const MPI::Group &group2)
{
  MPI_Group newgroup;
  (void)MPI_Group_union(group1, group2, &newgroup);
  return newgroup;
}

inline MPI::Group
MPI::Group::Intersect(const MPI::Group &group1, const MPI::Group &group2)
{
  MPI_Group newgroup;
  (void)MPI_Group_intersection( group1,  group2, &newgroup);
  return newgroup;
}

inline MPI::Group
MPI::Group::Difference(const MPI::Group &group1, const MPI::Group &group2)
{
  MPI_Group newgroup;
  (void)MPI_Group_difference(group1, group2, &newgroup);
  return newgroup;
}

inline MPI::Group
MPI::Group::Incl(int n, const int ranks[]) const
{
  MPI_Group newgroup;
  (void)MPI_Group_incl(mpi_group, n, (int*)ranks, &newgroup);
  return newgroup;
}

inline MPI::Group
MPI::Group::Excl(int n, const int ranks[]) const
{
  MPI_Group newgroup;
  (void)MPI_Group_excl(mpi_group, n, (int*)ranks, &newgroup);
  return newgroup;
}

inline MPI::Group
MPI::Group::Range_incl(int n, const int ranges[][3]) const
{
  MPI_Group newgroup;
  (void)MPI_Group_range_incl(mpi_group, n, (int(*)[3])ranges, &newgroup);
  return newgroup;
}

inline MPI::Group
MPI::Group::Range_excl(int n, const int ranges[][3]) const
{
  MPI_Group newgroup;
  (void)MPI_Group_range_excl(mpi_group, n, (int(*)[3])ranges, &newgroup);
  return newgroup;
}

inline void
MPI::Group::Free()
{
  (void)MPI_Group_free(&mpi_group);
}

inline void MPI::Info::Delete(const char* key)
{
  (void)MPI_Info_delete(mpi_info,(char*)key);
}

inline MPI::Info MPI::Info::Dup() const
{
  MPI_Info newinfo;
  (void)MPI_Info_dup(mpi_info, &newinfo);
  return newinfo;
}

inline void MPI::Info::Free()
{
  (void)MPI_Info_free(&mpi_info);
}

inline bool MPI::Info::Get(const char* key, int valuelen, char* value) const
{
  int flag;
  (void)MPI_Info_get(mpi_info,(char*)key,valuelen,value,&flag);
  if(flag) return(true); else return(false);
}

inline int MPI::Info::Get_nkeys() const
{
  int nkeys;
  (void)MPI_Info_get_nkeys(mpi_info,&nkeys);
  return nkeys;
}

inline void MPI::Info::Get_nthkey(int n, char* key) const
{
  (void)MPI_Info_get_nthkey(mpi_info,n,key);
}

inline bool MPI::Info::Get_valuelen(const char* key, int& valuelen) const
{
  int flag;
  (void)MPI_Info_get_valuelen(mpi_info,(char*)key,&valuelen,&flag);
  if(flag) return(true); else return(false);
}

inline void MPI::Info::Set(const char* key, const char* value)
{
  (void)MPI_Info_set(mpi_info,(char*)key,(char*)value);
}

inline MPI::Info MPI::Info::Create()
{
  MPI_Info newinfo;
  (void)MPI_Info_create(&newinfo);
  return newinfo;
}

/********************************************************************/
/*                            Class Intercomm                       */
/********************************************************************/

inline
MPI::Intercomm::Intercomm(const MPI_Comm& data)
{
  int flag;
  if (MPI::Is_initialized() && (data != MPI_COMM_NULL))
  {
    (void)MPI_Comm_test_inter(data, &flag);
    if (flag)
    {
      mpi_comm = data;
    }
    else
    {
      mpi_comm = MPI_COMM_NULL;
    }
  }
  else
  {
    mpi_comm = data;
  }
}

inline MPI::Intercomm
MPI::Intercomm::Dup() const
{
  MPI_Comm newcomm;
  (void)MPI_Comm_dup(mpi_comm, &newcomm);
  return newcomm;
}

inline MPI::Intercomm&
MPI::Intercomm::Clone() const
{
  MPI_Comm newcomm;
  (void)MPI_Comm_dup(mpi_comm, &newcomm);
  MPI::Intercomm* dup = new MPI::Intercomm(newcomm);
  return *dup;
}

inline MPI::Intercomm
MPI::Intercomm::Create(const MPI::Group& group) const
{
  MPI_Comm newcomm;
  (void)MPI_Comm_create(mpi_comm, group, &newcomm);
  return newcomm;
}

inline MPI::Intercomm
MPI::Intercomm::Split(int color, int key) const
{
  MPI_Comm newcomm;
  (void)MPI_Comm_split(mpi_comm, color, key, &newcomm);
  return newcomm;
}

inline int
MPI::Intercomm::Get_remote_size() const
{
  int size;
  (void)MPI_Comm_remote_size(mpi_comm, &size);
  return size;
}

inline MPI::Group
MPI::Intercomm::Get_remote_group() const
{
  MPI_Group group;
  (void)MPI_Comm_remote_group(mpi_comm, &group);
  return group;
}

inline MPI::Intracomm
MPI::Intercomm::Merge(bool high)
{
  MPI_Comm newcomm;
  (void)MPI_Intercomm_merge(mpi_comm, (int)high, &newcomm);
  return newcomm;
}

/********************************************************************/
/*                            Class Intracomm                       */
/********************************************************************/

inline
MPI::Intracomm::Intracomm(const MPI_Comm& data)
{
  int flag;
  if (MPI::Is_initialized() && (data != MPI_COMM_NULL))
  {
    (void)MPI_Comm_test_inter(data, &flag);
    if (flag)
    {
      mpi_comm = MPI_COMM_NULL;
    }
    else
    {
      mpi_comm = data;
    }
  }
  else
  {
    mpi_comm = data;
  }
}

inline void
MPI::Intracomm::Scan(const void *sendbuf, void *recvbuf, int count,
                            const MPI::Datatype & datatype, const MPI::Op& op) const
{
  (void)MPI_Scan((void *)sendbuf, recvbuf, count, datatype, op, mpi_comm);
}

inline void
MPI::Intracomm::Exscan(const void *sendbuf, void *recvbuf, int count, 
                            const MPI::Datatype & datatype, const MPI::Op& op) const
{
  (void)MPI_Exscan((void *)sendbuf, recvbuf, count, datatype, op, mpi_comm);
}

inline MPI::Intracomm MPI::Intracomm::Dup() const
{
  MPI_Comm newcomm;
  (void)MPI_Comm_dup(mpi_comm, &newcomm);
  return newcomm;
}

inline MPI::Intracomm&
MPI::Intracomm::Clone() const
{
  MPI_Comm newcomm;
  (void)MPI_Comm_dup(mpi_comm, &newcomm);
  MPI::Intracomm* dup = new MPI::Intracomm(newcomm);
  return *dup;
}

inline MPI::Intracomm
MPI::Intracomm::Create(const MPI::Group& group) const
{
  MPI_Comm newcomm;
  (void)MPI_Comm_create(mpi_comm, group, &newcomm);
  return newcomm;
}

inline MPI::Intracomm
MPI::Intracomm::Split(int color, int key) const
{
  MPI_Comm newcomm;
  (void)MPI_Comm_split(mpi_comm, color, key, &newcomm);
  return newcomm;
}

inline MPI::Intercomm
MPI::Intracomm::Create_intercomm(int local_leader, const MPI::Comm& peer_comm, int remote_leader, int tag) const
{
  MPI_Comm newintercomm;
  (void)MPI_Intercomm_create(mpi_comm, local_leader, peer_comm, remote_leader, tag, &newintercomm);
  return newintercomm;
}

inline MPI::Cartcomm
MPI::Intracomm::Create_cart(int ndims, const int dims[], const bool periods[], bool reorder) const
{
  int *int_periods = new int [ndims];
  for (int i=0; i<ndims; i++)
  {
    int_periods[i] = (int) periods[i];
  }
  MPI_Comm newcomm;
  (void)MPI_Cart_create(mpi_comm, ndims, (int*)dims, int_periods, (int)reorder, &newcomm);
  delete [] int_periods;
  return newcomm;
}

inline MPI::Graphcomm
MPI::Intracomm::Create_graph(int nnodes, const int index[], const int edges[], bool reorder) const
{
  MPI_Comm newcomm;
  (void)MPI_Graph_create(mpi_comm, nnodes, (int*)index, (int*)edges, (int)reorder, &newcomm);
  return newcomm;
}



/********************************************************************/
/*                            Class Op                              */
/********************************************************************/


inline void
MPI::Op::Init(MPI::User_function *func, bool commute)
{
  if(MPI_Op_create((MPI_User_function*) func, (int) commute, &mpi_op)  == MPI_SUCCESS)
  {
    _set_cpp_op_lang_flag(mpi_op);
  }
}


inline void
MPI::Op::Free()
{
  (void)MPI_Op_free(&mpi_op);
}



/********************************************************************/
/*                            Class Request                         */
/********************************************************************/


inline void
MPI::Request::Wait(MPI::Status &status)
{
  (void)MPI_Wait(&mpi_request, &status.mpi_status);
}

inline void
MPI::Request::Wait()
{
  (void)MPI_Wait(&mpi_request, MPI_STATUS_IGNORE);
}

inline void
MPI::Request::Free()
{
  (void)MPI_Request_free(&mpi_request);
}

inline bool
MPI::Request::Test(MPI::Status &status)
{
  int t;
  (void)MPI_Test(&mpi_request, &t, &status.mpi_status);
  if(t) return(true); else return(false);
}

inline bool
MPI::Request::Test()
{
  int t;
  (void)MPI_Test(&mpi_request, &t, MPI_STATUS_IGNORE);
  if(t) return(true); else return(false);
}

inline bool
MPI::Request::Get_status(MPI::Status &status) const
{
  int t;
  (void)MPI_Request_get_status(mpi_request, &t, &status.mpi_status);
  if(t) return(true); else return(false);
}

inline bool
MPI::Request::Get_status() const
{
  int t;
  (void)MPI_Request_get_status(mpi_request, &t, MPI_STATUS_IGNORE);
  if(t) return(true); else return(false);
}


inline int
MPI::Request::Waitany(int count, MPI::Request array[],
                             MPI::Status& status)
{
  int index, i;
  MPI_Request* array_of_requests = new MPI_Request[count];
  for (i=0; i < count; i++)
  {
    array_of_requests[i] = array[i];
  }
  (void)MPI_Waitany(count, array_of_requests, &index, &status.mpi_status);
  for (i=0; i < count; i++)
  {
    array[i] = array_of_requests[i];
  }
  delete [] array_of_requests;
  return index;
}

inline int
MPI::Request::Waitany(int count, MPI::Request array[])
{
  int index, i;
  MPI_Request* array_of_requests = new MPI_Request[count];
  for (i=0; i < count; i++)
  {
    array_of_requests[i] = array[i];
  }
  (void)MPI_Waitany(count, array_of_requests, &index, MPI_STATUS_IGNORE);
  for (i=0; i < count; i++)
  {
    array[i] = array_of_requests[i];
  }
  delete [] array_of_requests;
  return index;
}

inline bool
MPI::Request::Testany(int count, MPI::Request array[], int& index, MPI::Status& status)
{
  int i, flag;
  MPI_Request* array_of_requests = new MPI_Request[count];
  for (i=0; i < count; i++)
  {
    array_of_requests[i] = array[i];
  }
  (void)MPI_Testany(count, array_of_requests, &index, &flag, &status.mpi_status);
  for (i=0; i < count; i++)
  {
    array[i] = array_of_requests[i];
  }
  delete [] array_of_requests;
  if(flag) return(true); else return(false);
}

inline bool
MPI::Request::Testany(int count, MPI::Request array[], int& index)
{
  int i, flag;
  MPI_Request* array_of_requests = new MPI_Request[count];
  for (i=0; i < count; i++)
  {
    array_of_requests[i] = array[i];
  }
  (void)MPI_Testany(count, array_of_requests, &index, &flag, MPI_STATUS_IGNORE);
  for (i=0; i < count; i++)
  {
    array[i] = array_of_requests[i];
  }
  delete [] array_of_requests;
  if(flag) return(true); else return(false);
}

inline void
MPI::Request::Waitall(int count, MPI::Request req_array[], MPI::Status stat_array[])
{
  int i;
  MPI_Request* array_of_requests = new MPI_Request[count];
  MPI_Status* array_of_statuses = new MPI_Status[count];
  for (i=0; i < count; i++)
  {
    array_of_requests[i] = req_array[i];
  }
  (void)MPI_Waitall(count, array_of_requests, array_of_statuses);
  for (i=0; i < count; i++)
  {
    req_array[i] = array_of_requests[i];
    stat_array[i] = array_of_statuses[i];
  }
  delete [] array_of_requests;
  delete [] array_of_statuses;
}

inline void
MPI::Request::Waitall(int count, MPI::Request req_array[])
{
  int i;
  MPI_Request* array_of_requests = new MPI_Request[count];
  for (i=0; i < count; i++)
  {
    array_of_requests[i] = req_array[i];
  }
  (void)MPI_Waitall(count, array_of_requests, MPI_STATUSES_IGNORE);
  for (i=0; i < count; i++)
  {
    req_array[i] = array_of_requests[i];
  }
  delete [] array_of_requests;
}

inline bool
MPI::Request::Testall(int count, MPI::Request req_array[], MPI::Status stat_array[])
{
  int i, flag;
  MPI_Request* array_of_requests = new MPI_Request[count];
  MPI_Status* array_of_statuses = new MPI_Status[count];
  for (i=0; i < count; i++)
  {
    array_of_requests[i] = req_array[i];
  }
  (void)MPI_Testall(count, array_of_requests, &flag, array_of_statuses);
  for (i=0; i < count; i++)
  {
    req_array[i] = array_of_requests[i];
    stat_array[i] = array_of_statuses[i];
  }
  delete [] array_of_requests;
  delete [] array_of_statuses;
  if(flag) return(true); else return(false);
}

inline bool
MPI::Request::Testall(int count, MPI::Request req_array[])
{
  int i, flag;
  MPI_Request* array_of_requests = new MPI_Request[count];
  for (i=0; i < count; i++)
  {
    array_of_requests[i] = req_array[i];
  }
  (void)MPI_Testall(count, array_of_requests, &flag, MPI_STATUSES_IGNORE);
  for (i=0; i < count; i++)
  {
    req_array[i] = array_of_requests[i];
  }
  delete [] array_of_requests;
  if(flag) return(true); else return(false);
}

inline int
MPI::Request::Waitsome(int incount, MPI::Request req_array[], int array_of_indices[], MPI::Status stat_array[])
{
  int i, outcount;
  MPI_Request* array_of_requests = new MPI_Request[incount];
  MPI_Status* array_of_statuses = new MPI_Status[incount];
  for (i=0; i < incount; i++)
  {
    array_of_requests[i] = req_array[i];
  }
  (void)MPI_Waitsome(incount, array_of_requests, &outcount, array_of_indices, array_of_statuses);
  for (i=0; i < incount; i++)
  {
    req_array[i] = array_of_requests[i];
    stat_array[i] = array_of_statuses[i];
  }
  delete [] array_of_requests;
  delete [] array_of_statuses;
  return outcount;
}

inline int
MPI::Request::Waitsome(int incount, MPI::Request req_array[], int array_of_indices[])
{
  int i, outcount;
  MPI_Request* array_of_requests = new MPI_Request[incount];
  for (i=0; i < incount; i++)
  {
    array_of_requests[i] = req_array[i];
  }
  (void)MPI_Waitsome(incount, array_of_requests, &outcount,
                     array_of_indices, MPI_STATUSES_IGNORE);
  for (i=0; i < incount; i++)
  {
    req_array[i] = array_of_requests[i];
  }
  delete [] array_of_requests;
  return outcount;
}

inline int
MPI::Request::Testsome(int incount, MPI::Request req_array[],
                              int array_of_indices[], MPI::Status stat_array[])
{
  int i, outcount;
  MPI_Request* array_of_requests = new MPI_Request[incount];
  MPI_Status* array_of_statuses = new MPI_Status[incount];
  for (i=0; i < incount; i++)
  {
    array_of_requests[i] = req_array[i];
  }
  (void)MPI_Testsome(incount, array_of_requests, &outcount, array_of_indices, array_of_statuses);
  for (i=0; i < incount; i++)
  {
    req_array[i] = array_of_requests[i];
    stat_array[i] = array_of_statuses[i];
  }
  delete [] array_of_requests;
  delete [] array_of_statuses;
  return outcount;
}

inline int
MPI::Request::Testsome(int incount, MPI::Request req_array[], int array_of_indices[])
{
  int i, outcount;
  MPI_Request* array_of_requests = new MPI_Request[incount];
  for (i=0; i < incount; i++)
  {
    array_of_requests[i] = req_array[i];
  }
  (void)MPI_Testsome(incount, array_of_requests, &outcount,
                     array_of_indices, MPI_STATUSES_IGNORE);
  for (i=0; i < incount; i++)
  {
    req_array[i] = array_of_requests[i];
  }
  delete [] array_of_requests;
  return outcount;
}

inline void
MPI::Request::Cancel(void) const
{
  (void)MPI_Cancel((MPI_Request*)&mpi_request);
}

/********************************************************************/
/*                            Class Prequest                        */
/********************************************************************/

inline void
MPI::Prequest::Start()
{
  (void)MPI_Start(&mpi_request);
}

inline void
MPI::Prequest::Startall(int count, MPI:: Prequest array_of_requests[])
{
  MPI_Request* mpi_requests = new MPI_Request[count];
  int i;
  for (i=0; i < count; i++)
  {
    mpi_requests[i] = array_of_requests[i];
  }
  (void)MPI_Startall(count, mpi_requests);
  for (i=0; i < count; i++)
  {
    array_of_requests[i].mpi_request = mpi_requests[i] ;
  }
  delete [] mpi_requests;
}

/********************************************************************/
/*                            Class Status                          */
/********************************************************************/


inline int
MPI::Status::Get_count(const MPI::Datatype& datatype) const
{
  int count;
  (void)MPI_Get_count((MPI_Status*)&mpi_status, datatype, &count);
  return count;
}

inline bool
MPI::Status::Is_cancelled() const
{
  int t;
  (void)MPI_Test_cancelled((MPI_Status*)&mpi_status, &t);
  if(t) return(true); else return(false);
}

inline int
MPI::Status::Get_elements(const MPI::Datatype& datatype) const
{
  int count;
  (void)MPI_Get_elements((MPI_Status*)&mpi_status, datatype, &count);
  return count;
}

inline void 
MPI::Status::Set_elements(const MPI::Datatype& datatype, int count)
{
   (void)MPI_Status_set_elements((MPI_Status*)&mpi_status, datatype, count);
}

inline void
MPI::Status::Set_cancelled(bool flag)
{
   int tmp_flag;
   if(flag) tmp_flag = 1; else tmp_flag=0;
   (void)MPI_Status_set_cancelled((MPI_Status*)&mpi_status, tmp_flag);
}

inline int
MPI::Status::Get_source() const
{
  int source;
  source = mpi_status.MPI_SOURCE;
  return source;
}

inline void
MPI::Status::Set_source(int source)
{
  mpi_status.MPI_SOURCE = source;
}

inline int
MPI::Status::Get_tag() const
{
  int tag;
  tag = mpi_status.MPI_TAG;
  return tag;
}

inline void
MPI::Status::Set_tag(int tag)
{
  mpi_status.MPI_TAG = tag;
}

inline int
MPI::Status::Get_error() const
{
  int error;
  error = mpi_status.MPI_ERROR;
  return error;
}

inline void
MPI::Status::Set_error(int error)
{
  mpi_status.MPI_ERROR = error;
}

/********************************************************************/
/*                            Class Cartcomm                        */
/********************************************************************/

inline
MPI::Cartcomm::Cartcomm(const MPI_Comm& data)
{
  int status;
  if (MPI::Is_initialized() && (data != MPI_COMM_NULL))
  {
    (void)MPI_Topo_test(data, &status);
    if (status == MPI_CART)
    {
      mpi_comm = data;
    }
    else
    {
      mpi_comm = MPI_COMM_NULL;
    }
  }
  else
  {
    mpi_comm = data;
  }
}

inline MPI::Cartcomm
MPI::Cartcomm::Dup() const
{
  MPI_Comm newcomm;
  (void)MPI_Comm_dup(mpi_comm, &newcomm);
  return newcomm;
}

inline int
MPI::Cartcomm::Get_dim() const
{
  int ndims;
  (void)MPI_Cartdim_get(mpi_comm, &ndims);
  return ndims;
}

inline void
MPI::Cartcomm::Get_topo(int maxdims, int dims[], bool periods[], int coords[]) const
{
  int *int_periods = new int [maxdims];
  int i;
  for (i=0; i < maxdims; i++)
  {
    int_periods[i] = (int)periods[i];
  }
  (void)MPI_Cart_get(mpi_comm, maxdims, dims, int_periods, coords);
  for (i=0; i < maxdims; i++)
  {
    periods[i] = (bool)int_periods[i];
  }
  delete [] int_periods;
}

inline int
MPI::Cartcomm::Get_cart_rank(const int coords[]) const
{
  int rank;
  (void)MPI_Cart_rank(mpi_comm, (int*)coords, &rank);
  return rank;
}

inline void
MPI::Cartcomm::Get_coords(int rank, int maxdims, int coords[]) const
{
  (void)MPI_Cart_coords(mpi_comm, rank, maxdims, coords);
}

inline void
MPI::Cartcomm::Shift(int direction, int disp,
                            int &rank_source, int &rank_dest) const
{
  (void)MPI_Cart_shift(mpi_comm, direction, disp, &rank_source, &rank_dest);
}

inline MPI::Cartcomm
MPI::Cartcomm::Sub(const bool remain_dims[])
{
  int ndims;
  (void)MPI_Cartdim_get(mpi_comm, &ndims);
  int* int_remain_dims = new int[ndims];
  for (int i=0; i<ndims; i++)
  {
    int_remain_dims[i] = (int)remain_dims[i];
  }
  MPI_Comm newcomm;
  (void)MPI_Cart_sub(mpi_comm, int_remain_dims, &newcomm);
  delete [] int_remain_dims;
  return newcomm;
}

inline int
MPI::Cartcomm::Map(int ndims, const int dims[], const bool periods[]) const
{
  int *int_periods = new int [ndims];
  for (int i=0; i<ndims; i++)
  {
    int_periods[i] = (int) periods[i];
  }
  int newrank;
  (void)MPI_Cart_map(mpi_comm, ndims, (int*)dims, int_periods, &newrank);
  delete [] int_periods;
  return newrank;
}


inline MPI::Cartcomm&
MPI::Cartcomm::Clone() const
{
  MPI_Comm newcomm;
  (void)MPI_Comm_dup(mpi_comm, &newcomm);
  MPI::Cartcomm* dup = new MPI::Cartcomm(newcomm);
  return *dup;
}

/********************************************************************/
/*                            Class Graphcomm                       */
/********************************************************************/

inline
MPI::Graphcomm::Graphcomm(const MPI_Comm& data)
{
  int status;
  if (MPI::Is_initialized() && (data != MPI_COMM_NULL))
  {
    (void)MPI_Topo_test(data, &status) ;
    if (status == MPI_GRAPH)
    {
      mpi_comm = data;
    }
    else
    {
      mpi_comm = MPI_COMM_NULL;
    }
  }
  else
  {
    mpi_comm = data;
  }
}

inline MPI::Graphcomm
MPI::Graphcomm::Dup() const
{
  MPI_Comm newcomm;
  (void)MPI_Comm_dup(mpi_comm, &newcomm);
  return newcomm;
}

inline void
MPI::Graphcomm::Get_dims(int nnodes[], int nedges[]) const
{
  (void)MPI_Graphdims_get(mpi_comm, nnodes, nedges);
}

inline void
MPI::Graphcomm::Get_topo(int maxindex, int maxedges, int index[], int edges[]) const
{
  (void)MPI_Graph_get(mpi_comm, maxindex, maxedges, index, edges);
}

inline int
MPI::Graphcomm::Get_neighbors_count(int rank) const
{
  int nneighbors;
  (void)MPI_Graph_neighbors_count(mpi_comm, rank, &nneighbors);
  return nneighbors;
}

inline void
MPI::Graphcomm::Get_neighbors(int rank, int maxneighbors, int neighbors[]) const
{
  (void)MPI_Graph_neighbors(mpi_comm, rank, maxneighbors, neighbors);
}

inline int
MPI::Graphcomm::Map(int nnodes, const int index[], const int edges[]) const
{
  int newrank;
  (void)MPI_Graph_map(mpi_comm, nnodes, (int*)index, (int*)edges, &newrank);
  return newrank;
}

inline MPI::Graphcomm&
MPI::Graphcomm::Clone() const
{
  MPI_Comm newcomm;
  (void)MPI_Comm_dup(mpi_comm, &newcomm);
  MPI::Graphcomm* dup = new MPI::Graphcomm(newcomm);
  return *dup;
}

/********************************************************************/
/*                            Class Win                             */
/********************************************************************/

inline void
MPI::Win::Free()
{
  (void)MPI_Win_free(&mpi_win);
}

inline MPI::Group
MPI::Win::Get_group() const
{
  MPI_Group mpi_group;
  (void)MPI_Win_get_group(mpi_win, &mpi_group);
  return mpi_group;
}

inline void
MPI::Win::Put(const void* origin_addr, int origin_count, const MPI::Datatype& origin_datatype, int target_rank,
                     MPI::Aint target_disp, int target_count, const MPI::Datatype& target_datatype) const
{
  (void)MPI_Put((void*)origin_addr, origin_count, origin_datatype, target_rank, target_disp, target_count, target_datatype, mpi_win);
}

inline void
MPI::Win::Get(void* origin_addr, int origin_count, const MPI::Datatype& origin_datatype, int target_rank,
                     MPI::Aint target_disp, int target_count, const MPI::Datatype& target_datatype) const
{
  (void)MPI_Get(origin_addr,origin_count,origin_datatype,target_rank,target_disp,target_count,target_datatype,mpi_win);
}

inline void
MPI::Win::Accumulate(const void* origin_addr, int origin_count, const MPI::Datatype& origin_datatype,
                            int target_rank, MPI::Aint target_disp, int target_count,
                            const MPI::Datatype& target_datatype, const MPI::Op& op) const
{
  (void)MPI_Accumulate((void*)origin_addr,origin_count,origin_datatype,target_rank, target_disp,target_count,target_datatype,op,mpi_win);
}

inline void
MPI::Win::Fence(int assert) const
{
  (void)MPI_Win_fence(assert,mpi_win);
}

inline void
MPI::Win::Start(const MPI::Group& group, int assert) const
{
  (void)MPI_Win_start(group,assert,mpi_win);
}

inline void
MPI::Win::Complete() const
{
  (void)MPI_Win_complete(mpi_win);
}

inline void
MPI::Win::Post(const MPI::Group& group, int assert) const
{
  (void)MPI_Win_post(group,assert,mpi_win);
}

inline void
MPI::Win::Wait() const
{
  (void)MPI_Win_wait(mpi_win);
}

inline bool
MPI::Win::Test() const
{
  int flag;
  (void)MPI_Win_test(mpi_win,&flag);
  if(flag) return(true); else return(false);
}

inline void
MPI::Win::Lock(int lock_type, int rank, int assert) const
{
  (void)MPI_Win_lock(lock_type,rank,assert,mpi_win);
}

inline void
MPI::Win::Unlock(int rank) const
{
  (void)MPI_Win_unlock(rank,mpi_win);
}

inline bool
MPI::Win::Get_attr(int win_keyval, void* attribute_val) const
{
  int flag;
  (void)MPI_Win_get_attr(mpi_win,win_keyval,attribute_val,&flag);
  if(flag) return(true); else return(false);
}

inline void
MPI::Win::Set_attr(int win_keyval, const void* attribute_val)
{
  (void)MPI_Win_set_attr(mpi_win,win_keyval,(void*)attribute_val);
}

inline void
MPI::Win::Delete_attr(int win_keyval)
{
  (void)MPI_Win_delete_attr(mpi_win,win_keyval);
}

inline MPI::Errhandler
MPI::Win::Get_errhandler() const
{
  MPI_Errhandler eh;
  (void)MPI_Win_get_errhandler(mpi_win,&eh);
  return eh;
}

inline void
MPI::Win::Set_errhandler(const MPI::Errhandler& errhandler)
{
  (void)MPI_Win_set_errhandler(mpi_win,errhandler);
}

inline void
MPI::Win::Call_errhandler(int errorcode) const
{
  (void)MPI_Win_call_errhandler(mpi_win, errorcode);
}

inline void
MPI::Win::Get_name(char* win_name, int& resultlen) const
{
  (void)MPI_Win_get_name(mpi_win, win_name, &resultlen);
}

inline void
MPI::Win::Set_name(const char* win_name)
{
  (void)MPI_Win_set_name(mpi_win, (char*)win_name);
}

/* static methods */

inline MPI::Win
MPI::Win::Create(const void* base, MPI::Aint size, int disp_unit, const MPI::Info& info,
                        const MPI::Intracomm& comm)
{
  MPI_Win win;
  (void)MPI_Win_create((void*)base,size,disp_unit,info,comm,&win);
  return win;
}

inline int
MPI::Win::Create_keyval(MPI::Win::Copy_attr_function* win_copy_attr_fn,
                               MPI::Win::Delete_attr_function* win_delete_attr_fn, void* extra_state)
{
  int win_keyval;
  if(MPI_Win_create_keyval((MPI_Win_copy_attr_function*) win_copy_attr_fn, (MPI_Win_delete_attr_function*) win_delete_attr_fn,
                           &win_keyval, extra_state)  == MPI_SUCCESS)
  {
    _set_cpp_key_lang_flag(win_keyval);
  }
  return win_keyval;
}

inline void
MPI::Win::Free_keyval(int& win_keyval)
{
  (void)MPI_Win_free_keyval(&win_keyval);
}

inline MPI::Errhandler
MPI::Win::Create_errhandler(MPI::Win::Errhandler_fn* function)
{
  MPI_Errhandler errhandler;
  if(MPI_Win_create_errhandler((MPI_Win_errhandler_fn*)function, &errhandler)  == MPI_SUCCESS)
  {
    _set_cpp_err_lang_flag(errhandler);
  }
  MPI::Errhandler temp(errhandler);
  return temp;
}

/* predefined attribute functions: */

inline int
MPI::Win::NULL_COPY_FN(const MPI::Win& oldwin, int win_keyval, void* extra_state, const void* attribute_val_in,
                              void* attribute_val_out, bool& flag)
{
  flag = false;
  return MPI::SUCCESS;
}

inline int
MPI::Win::DUP_FN(const MPI::Win& oldwin, int win_keyval, void* extra_state, const void* attribute_val_in,
                        void* attribute_val_out, bool& flag)
{
  flag = true;
  *((void **)attribute_val_out) = (void*)attribute_val_in;
  return(MPI::SUCCESS);
}

inline int
MPI::Win::NULL_DELETE_FN(MPI::Win& win, int win_keyval, void* attribute_val, void* extra_state)
{
  return MPI::SUCCESS;
}

inline MPI::Grequest
MPI::Grequest::Start(MPI::Grequest::Query_function query_fn, 
                     MPI::Grequest::Free_function free_fn, 
                     MPI::Grequest::Cancel_function cancel_fn, 
                     void *extra_state)
{
   int rc;
   MPI_Request tmp_request;
 
   rc = MPI_Grequest_start((MPI_Grequest_query_function*) query_fn, (MPI_Grequest_free_function*) free_fn, (MPI_Grequest_cancel_function*) cancel_fn, extra_state, &tmp_request);

   if(rc == MPI_SUCCESS) {
      _set_cpp_req_lang_flag(&tmp_request);
   }

   return(tmp_request);
}

inline void
MPI::Grequest::Complete()
{
   (void)MPI_Grequest_complete(mpi_request);
} 

#ifndef LINUX
void * const MPI::BOTTOM = (void*) MPI_BOTTOM;
void * const MPI::IN_PLACE = (void*) MPI_IN_PLACE;

// error-handling specifiers

const MPI::Errhandler  MPI::ERRORS_ARE_FATAL(MPI_ERRORS_ARE_FATAL);
const MPI::Errhandler  MPI::ERRORS_RETURN(MPI_ERRORS_RETURN);

#define ERRORS_THROW_EXCEPTIONS_NUM 3

const MPI::Errhandler  MPI::ERRORS_THROW_EXCEPTIONS(ERRORS_THROW_EXCEPTIONS_NUM);

// elementary datatypes

const MPI::Datatype MPI::CHAR(MPI_CHAR);
const MPI::Datatype MPI::SHORT(MPI_SHORT);
const MPI::Datatype MPI::INT(MPI_INT);
const MPI::Datatype MPI::LONG(MPI_LONG);
const MPI::Datatype MPI::SIGNED_CHAR(MPI_SIGNED_CHAR);
const MPI::Datatype MPI::UNSIGNED_CHAR(MPI_UNSIGNED_CHAR);
const MPI::Datatype MPI::UNSIGNED_SHORT(MPI_UNSIGNED_SHORT);
const MPI::Datatype MPI::UNSIGNED(MPI_UNSIGNED);
const MPI::Datatype MPI::UNSIGNED_LONG(MPI_UNSIGNED_LONG);
const MPI::Datatype MPI::FLOAT(MPI_FLOAT);
const MPI::Datatype MPI::DOUBLE(MPI_DOUBLE);
const MPI::Datatype MPI::LONG_DOUBLE(MPI_LONG_DOUBLE);
const MPI::Datatype MPI::BYTE(MPI_BYTE);
const MPI::Datatype MPI::PACKED(MPI_PACKED);
const MPI::Datatype MPI::WCHAR(MPI_WCHAR);
const MPI::Datatype MPI::LONG_LONG(MPI_LONG_LONG);
const MPI::Datatype MPI::UNSIGNED_LONG_LONG(MPI_UNSIGNED_LONG_LONG);

// datatypes for reductions functions (C / C++)

const MPI::Datatype MPI::FLOAT_INT(MPI_FLOAT_INT);
const MPI::Datatype MPI::DOUBLE_INT(MPI_DOUBLE_INT);
const MPI::Datatype MPI::LONG_INT(MPI_LONG_INT);
const MPI::Datatype MPI::TWOINT(MPI_2INT);
const MPI::Datatype MPI::SHORT_INT(MPI_SHORT_INT);
const MPI::Datatype MPI::LONG_DOUBLE_INT(MPI_LONG_DOUBLE);

// elementary datatype (Fortran)

const MPI::Datatype MPI::INTEGER(MPI_INTEGER);
const MPI::Datatype MPI::REAL(MPI_REAL);
const MPI::Datatype MPI::DOUBLE_PRECISION(MPI_DOUBLE_PRECISION);
const MPI::Datatype MPI::F_COMPLEX(MPI_COMPLEX);
const MPI::Datatype MPI::LOGICAL(MPI_LOGICAL);
const MPI::Datatype MPI::CHARACTER(MPI_CHARACTER);

// datatype for reduction functions (Fortran)

const MPI::Datatype MPI::TWOREAL(MPI_2REAL);
const MPI::Datatype MPI::TWODOUBLE_PRECISION(MPI_2DOUBLE_PRECISION);
const MPI::Datatype MPI::TWOINTEGER(MPI_2INTEGER);
const MPI::Datatype MPI::TWOF_COMPLEX(MPI_2COMPLEX);

// optional datatypes (Fortran)

const MPI::Datatype MPI::INTEGER1(MPI_INTEGER1);
const MPI::Datatype MPI::INTEGER2(MPI_INTEGER2);
const MPI::Datatype MPI::INTEGER4(MPI_INTEGER4);
const MPI::Datatype MPI::INTEGER8(MPI_INTEGER8);
const MPI::Datatype MPI::REAL4(MPI_REAL4);
const MPI::Datatype MPI::REAL8(MPI_REAL8);
/* const MPI::Datatype MPI::REAL16(MPI_REAL16); */
const MPI::Datatype MPI::LOGICAL1(MPI_LOGICAL1);
const MPI::Datatype MPI::LOGICAL2(MPI_LOGICAL2);
const MPI::Datatype MPI::LOGICAL4(MPI_LOGICAL4);
const MPI::Datatype MPI::LOGICAL8(MPI_LOGICAL8);
const MPI::Datatype MPI::F_DOUBLE_COMPLEX(MPI_DOUBLE_COMPLEX);
const MPI::Datatype MPI::F_COMPLEX8(MPI_COMPLEX8);
const MPI::Datatype MPI::F_COMPLEX16(MPI_COMPLEX16);
/* const MPI::Datatype MPI::F_COMPLEX32(MPI_COMPLEX32); */

// c++ types

#if 0
const MPI::Datatype MPI::BOOL;
const MPI::Datatype MPI::COMPLEX;
const MPI::Datatype MPI::DOUBLE_COMPLEX;
const MPI::Datatype MPI::LONG_DOUBLE_COMPLEX;
#endif

MPI::Intracomm MPI::COMM_WORLD(MPI_COMM_WORLD);
MPI::Intracomm MPI::COMM_SELF(MPI_COMM_SELF);

// collective operations

const MPI::Op MPI::MAX(MPI_MAX);
const MPI::Op MPI::MIN(MPI_MIN);
const MPI::Op MPI::SUM(MPI_SUM);
const MPI::Op MPI::PROD(MPI_PROD);
const MPI::Op MPI::MAXLOC(MPI_MAXLOC);
const MPI::Op MPI::MINLOC(MPI_MINLOC);
const MPI::Op MPI::BAND(MPI_BAND);
const MPI::Op MPI::BOR(MPI_BOR);
const MPI::Op MPI::BXOR(MPI_BXOR);
const MPI::Op MPI::LAND(MPI_LAND);
const MPI::Op MPI::LOR(MPI_LOR);
const MPI::Op MPI::LXOR(MPI_LXOR);
const MPI::Op MPI::REPLACE(MPI_REPLACE);

/* null handles */
const MPI::Group        MPI::GROUP_NULL(MPI_GROUP_NULL);
const MPI_Comm          MPI::COMM_NULL(MPI_COMM_NULL);
const MPI::Datatype     MPI::DATATYPE_NULL(MPI_DATATYPE_NULL);
const MPI::Request      MPI::REQUEST_NULL(MPI_REQUEST_NULL);
const MPI::Op           MPI::OP_NULL(MPI_OP_NULL);
const MPI::Errhandler   MPI::ERRHANDLER_NULL(MPI_ERRHANDLER_NULL);
const MPI::Info         MPI::INFO_NULL(MPI_INFO_NULL);
const MPI::Win          MPI::WIN_NULL(MPI_WIN_NULL);
MPI::File               MPI::FILE_NULL(MPI_FILE_NULL);

// empty group

const MPI::Group MPI::GROUP_EMPTY(MPI_GROUP_EMPTY);

// special datatypes for contstruction of derived datatypes

const MPI::Datatype MPI::UB(MPI_UB);
const MPI::Datatype MPI::LB(MPI_LB);

// file operation constants:
const MPI::Offset MPI::DISPLACEMENT_CURRENT(MPI_DISPLACEMENT_CURRENT);

// pedefined functions:

MPI::Datarep_conversion_function* MPI::CONVERSION_FN_NULL(MPI_CONVERSION_FN_NULL);
#endif

#endif /* defined(__cplusplus) && defined(_MPI_CPP_BINDINGS) */

#endif /* _H_MPI */
